module ffchl_module_ef

   implicit none

contains

   !function get_ksi_ef(x, na, nneigh, two_body_power, cut_start, cut_distance, ef_scale, df, verbose) result(ksi)
   subroutine get_ksi_ef(x, na, nneigh, two_body_power, cut_start, cut_distance, ef_scale, df, verbose, ksi)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: two_body_power

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance

      ! Electric field displacement
      double precision, intent(in) :: ef_scale
      double precision, intent(in) :: df

      ! Display output
      logical, intent(in) :: verbose

      ! Pre-computed two-body weights
      ! double precision, allocatable, dimension(:, :, :, :, :) :: ksi
      double precision, dimension(:, :, :, :, :) :: ksi

      ! Internal counters
      integer :: maxneigh, maxatoms, nm, a, ni, i, xyz, pm

      ! Electric field
      double precision, dimension(3) :: field

      maxneigh = maxval(nneigh)
      maxatoms = maxval(na)
      nm = size(x, dim=1)

      !allocate (ksi(nm, 3, 2, maxatoms, maxneigh))

      ksi = 0.0d0

      !$OMP PARALLEL DO PRIVATE(ni, field)
      do a = 1, nm
         ni = na(a)
         do xyz = 1, 3
            do pm = 1, 2

               field = 0.0d0
               field(xyz) = (pm - 1.5d0)*2.0d0*df

               ! write(*,*) xyz, pm, field

               do i = 1, ni

                  ksi(a, xyz, pm, i, :) = get_twobody_weights_ef(x(a, i, :, :), field, nneigh(a, i), &
                      & two_body_power, cut_start, cut_distance, maxneigh, ef_scale)

               end do
            end do
         end do
      end do
      !$OMP END PARALLEL do

      ! end function get_ksi_ef
   end subroutine get_ksi_ef

   !function get_ksi_ef_field(x, na, nneigh, two_body_power, cut_start, cut_distance, fields, ef_scale, verbose) result(ksi)
   subroutine get_ksi_ef_field(x, na, nneigh, two_body_power, cut_start, cut_distance, fields, ef_scale, verbose, ksi)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: two_body_power

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance

      ! Electric fields for each representation
      double precision, dimension(:, :), intent(in) :: fields

      ! Display output
      logical, intent(in) :: verbose

      ! Pre-computed two-body weights
      !double precision, allocatable, dimension(:, :, :) :: ksi
      double precision, dimension(:, :, :), intent(out) :: ksi

      ! Internal counters
      integer :: maxneigh, maxatoms, nm, a, ni, i

      double precision, intent(in) :: ef_scale

      ! Electric field displacement
      ! double precision, intent(in) :: df

      maxneigh = maxval(nneigh)
      maxatoms = maxval(na)
      nm = size(x, dim=1)

      !allocate (ksi(nm, maxatoms, maxneigh))

      ksi = 0.0d0

      !$OMP PARALLEL DO PRIVATE(ni)
      do a = 1, nm
         ni = na(a)

         do i = 1, ni

            ksi(a, i, :) = get_twobody_weights_ef(x(a, i, :, :), fields(a, :), nneigh(a, i), &
                & two_body_power, cut_start, cut_distance, maxneigh, ef_scale)
         end do

      end do
      !$OMP END PARALLEL do

      !end function get_ksi_ef_field
   end subroutine get_ksi_ef_field

   subroutine init_cosp_sinp_ef(x, na, nneigh, three_body_power, order, cut_start, cut_distance, &
          & cosp, sinp, ef_scale, df, verbose)

      use ffchl_module, only: get_pmax

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: three_body_power

      integer, intent(in) :: order

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance
      double precision, intent(in) :: ef_scale

      ! Electric field displacement
      double precision, intent(in) :: df

      ! Cosine and sine terms for each atomtype
      double precision, dimension(:, :, :, :, :, :, :), intent(out) :: cosp
      double precision, dimension(:, :, :, :, :, :, :), intent(out) :: sinp

      ! Display output
      logical, intent(in) :: verbose

      ! Internal counters
      integer :: maxneigh, maxatoms, pmax, nm, a, ni, i

      double precision, allocatable, dimension(:, :, :, :) :: fourier

      ! Internal counters
      integer :: xyz, pm

      ! Electric field
      double precision, dimension(3) :: field

      maxneigh = maxval(nneigh)
      maxatoms = maxval(na)
      nm = size(x, dim=1)

      pmax = get_pmax(x, na)

      cosp = 0.0d0
      sinp = 0.0d0

      !$OMP PARALLEL DO PRIVATE(ni, fourier, field) schedule(dynamic)
      do a = 1, nm
         ni = na(a)
         do xyz = 1, 3
            do pm = 1, 2

               field = 0.0d0
               field(xyz) = (pm - 1.5d0)*2.0d0*df

               do i = 1, ni

                  fourier = get_threebody_fourier_ef(x(a, i, :, :), field, &
                  & nneigh(a, i), order, three_body_power, cut_start, cut_distance, pmax, order, maxneigh, ef_scale)

                  cosp(a, xyz, pm, i, :, :, :) = fourier(1, :, :, :)
                  sinp(a, xyz, pm, i, :, :, :) = fourier(2, :, :, :)

               end do
            end do
         end do
      end do
      !$OMP END PARALLEL DO

   end subroutine init_cosp_sinp_ef

   subroutine init_cosp_sinp_ef_field(x, na, nneigh, three_body_power, &
           & order, cut_start, cut_distance, cosp, sinp, fields, ef_scale, verbose)

      use ffchl_module, only: get_pmax

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: three_body_power

      integer, intent(in) :: order

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance
      double precision, intent(in) :: ef_scale

      ! Electric field displacement
      ! double precision, intent(in) :: df

      ! Display output
      logical, intent(in) :: verbose

      ! Cosine and sine terms for each atomtype
      double precision, dimension(:, :, :, :, :), intent(out) :: cosp
      double precision, dimension(:, :, :, :, :), intent(out) :: sinp

      ! Electric fields for each representation
      double precision, dimension(:, :), intent(in) :: fields

      ! Internal counters
      integer :: maxneigh, maxatoms, pmax, nm, a, ni, i

      double precision, allocatable, dimension(:, :, :, :) :: fourier

      maxneigh = maxval(nneigh)
      maxatoms = maxval(na)
      nm = size(x, dim=1)

      pmax = get_pmax(x, na)

      cosp = 0.0d0
      sinp = 0.0d0

      !$OMP PARALLEL DO PRIVATE(ni, fourier) schedule(dynamic)
      do a = 1, nm

         ni = na(a)

         do i = 1, ni

            fourier = get_threebody_fourier_ef(x(a, i, :, :), fields(a, :), &
            & nneigh(a, i), order, three_body_power, cut_start, cut_distance, pmax, order, maxneigh, ef_scale)

            cosp(a, i, :, :, :) = fourier(1, :, :, :)
            sinp(a, i, :, :, :) = fourier(2, :, :, :)
         end do

      end do
      !$OMP END PARALLEL DO

   end subroutine init_cosp_sinp_ef_field

   ! Calculate the Fourier terms for the FCHL three-body expansion
   function get_threebody_fourier_ef(x, field, neighbors, order, power, cut_start, cut_distance, &
       & dim1, dim2, dim3, ef_scale) result(fourier)

      use ffchl_module, only: calc_angle

      implicit none

      ! Input representation, dimension=(5,n).
      double precision, dimension(:, :), intent(in) :: x

      double precision, dimension(3), intent(in) :: field

      ! Number of neighboring atoms to iterate over.
      integer, intent(in) :: neighbors

      ! Fourier-expansion order.
      integer, intent(in) :: order

      ! Power law
      double precision, intent(in) :: power

      ! Lower limit of damping function
      double precision, intent(in) :: cut_start

      ! Upper limit of damping function
      double precision, intent(in) :: cut_distance

      double precision, intent(in) :: ef_scale

      ! Dimensions or the output array.
      integer, intent(in) :: dim1, dim2, dim3

      ! dim(1,:,:,:) are cos terms, dim(2,:,:,:) are sine terms.
      double precision, dimension(2, dim1, dim2, dim3) :: fourier

      ! Pi at double precision.
      double precision, parameter :: pi = 4.0d0*atan(1.0d0)

      ! Internal counters.
      integer :: j, k, m

      ! Indexes for the periodic-table distance matrix.
      integer :: pj, pk

      ! Angle between atoms for the three-body term.
      double precision :: theta

      ! Three-body weight
      double precision :: ksi3

      ! Temporary variables for cos and sine Fourier terms.
      double precision :: cos_m, sin_m

      fourier = 0.0d0

      do j = 2, neighbors
         do k = j + 1, neighbors

            ksi3 = calc_ksi3_ef(X(:, :), field, j, k, neighbors, power, cut_start, cut_distance, ef_scale)
            theta = calc_angle(x(3:5, j), x(3:5, 1), x(3:5, k))

            pj = int(x(2, k))
            pk = int(x(2, j))

            do m = 1, order

               cos_m = (cos(m*theta) - cos((theta + pi)*m))*ksi3
               sin_m = (sin(m*theta) - sin((theta + pi)*m))*ksi3

               fourier(1, pj, m, j) = fourier(1, pj, m, j) + cos_m
               fourier(2, pj, m, j) = fourier(2, pj, m, j) + sin_m

               fourier(1, pk, m, k) = fourier(1, pk, m, k) + cos_m
               fourier(2, pk, m, k) = fourier(2, pk, m, k) + sin_m

            end do

         end do
      end do

      return

   end function get_threebody_fourier_ef

   function calc_ksi3_ef(X, field, j, k, neighbors, power, cut_start, cut_distance, ef_scale) result(ksi3)

      use ffchl_module, only: cut_function, calc_cos_angle

      implicit none

      double precision, dimension(:, :), intent(in) :: X

      double precision, dimension(3), intent(in) :: field

      integer, intent(in) :: j
      integer, intent(in) :: k

      ! Number of neighboring atoms to iterate over.
      integer, intent(in) :: neighbors

      double precision, intent(in) :: power
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance
      double precision, intent(in) :: ef_scale

      double precision :: cos_i, cos_j, cos_k
      double precision :: di, dj, dk

      double precision :: ksi3
      double precision :: cut

      ! Center of nuclear charge
      double precision, dimension(3) :: coz
      double precision, dimension(3) :: dipole

      double precision :: total_charge

      integer :: i
      ! coz
      ! dipole

      cos_i = calc_cos_angle(x(3:5, k), x(3:5, 1), x(3:5, j))
      cos_j = calc_cos_angle(x(3:5, j), x(3:5, k), x(3:5, 1))
      cos_k = calc_cos_angle(x(3:5, 1), x(3:5, j), x(3:5, k))

      dk = x(1, j)
      dj = x(1, k)
      di = norm2(x(3:5, j) - x(3:5, k))

      cut = cut_function(dk, cut_start, cut_distance)* &
          & cut_function(dj, cut_start, cut_distance)* &
          & cut_function(di, cut_start, cut_distance)

      total_charge = 0.0d0

      coz = 0.0d0

      do i = 1, neighbors
         coz = coz + x(3:5, i)*x(2, i)
         total_charge = total_charge + x(2, i)
      end do

      coz = coz/total_charge

      dipole = (x(3:5, 1) - coz)*x(6, 1) + (x(3:5, j) - coz)*x(6, j) &
           & + (x(3:5, k) - coz)*x(6, k)

      ! ksi3 = cut * (1.0d0 + 3.0d0 * cos_i*cos_j*cos_k) / (di * dj * dk)**power

      ksi3 = cut*((1.0d0 + 3.0d0*cos_i*cos_j*cos_k)/(di*dj*dk)**power &
         & + ef_scale*dot_product(dipole, field))

      ! ksi3 = cut * dot_product(dipole, field)

   end function calc_ksi3_ef

   function get_twobody_weights_ef(x, field, neighbors, power, cut_start, cut_distance, dim1, ef_scale) result(ksi)

      use ffchl_module, only: cut_function

      implicit none

      double precision, dimension(:, :), intent(in) :: x
      double precision, dimension(3), intent(in) :: field
      integer, intent(in) :: neighbors
      double precision, intent(in) :: power
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance
      double precision, intent(in) :: ef_scale
      integer, intent(in) :: dim1

      double precision, dimension(dim1) :: ksi

      ! Electric field displacement
      ! double precision, intent(in) :: df

      integer :: i

      double precision, dimension(3) :: dipole

      ! Center of nuclear charge
      double precision, dimension(3) :: coz
      double precision :: total_charge

      ksi = 0.0d0

      coz = 0.0d0
      total_charge = 0.0d0
      do i = 1, neighbors
         coz = coz + x(3:5, i)*x(2, i)
         total_charge = total_charge + x(2, i)
      end do

      coz = coz/total_charge

      do i = 2, neighbors

         dipole = (x(3:5, 1) - coz)*x(6, 1) + (x(3:5, i) - coz)*x(6, i)

         ksi(i) = cut_function(x(1, i), cut_start, cut_distance) &
                 & *(1.0d0/x(1, i)**power + ef_scale*dot_product(dipole, field))

         ! ksi(i) = cut_function(x(1, i), cut_start, cut_distance) &
         !     & * (dot_product(dipole, field))

      end do

   end function get_twobody_weights_ef

   function get_twobody_weights_ef_field(x, field, neighbors, power, cut_start, cut_distance, dim1, ef_scale) result(ksi)

      use ffchl_module, only: cut_function

      implicit none

      double precision, dimension(:, :), intent(in) :: x
      double precision, dimension(3), intent(in) :: field
      integer, intent(in) :: neighbors
      double precision, intent(in) :: power
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance
      double precision, intent(in) :: ef_scale
      integer, intent(in) :: dim1

      double precision, dimension(dim1) :: ksi

      ! Electric field displacement
      ! double precision, intent(in) :: df

      integer :: i

      double precision, dimension(3) :: dipole

      ! Center of nuclear charge
      double precision, dimension(3) :: coz
      double precision :: total_charge

      ksi = 0.0d0

      coz = 0.0d0
      total_charge = 0.0d0
      do i = 1, neighbors
         coz = coz + x(3:5, i)*x(2, i)
         total_charge = total_charge + x(2, i)
      end do

      coz = coz/total_charge

      do i = 2, neighbors

         dipole = (x(3:5, 1) - coz)*x(6, 1) + (x(3:5, i) - coz)*x(6, i)

         ksi(i) = cut_function(x(1, i), cut_start, cut_distance) &
                 & *(1.0d0/x(1, i)**power + ef_scale*dot_product(dipole, field))

      end do

   end function get_twobody_weights_ef_field

end module ffchl_module_ef

module ffchl_kernels

   implicit none

   public :: kernel

contains

   subroutine gaussian_kernel(s11, s22, s12, parameters, k)

      implicit none

      double precision, intent(in) :: s11
      double precision, intent(in) :: s22
      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: k

      integer :: i
      double precision :: l2

      l2 = s11 + s22 - 2.0d0*s12

      do i = 1, size(k)
         k(i) = exp(l2*parameters(i, 1))
      end do

   end subroutine gaussian_kernel

   subroutine linear_kernel(s12, parameters, k)

      implicit none

      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters
      double precision, intent(out), dimension(:) :: k

      integer :: i

      do i = 1, size(k)
         k(i) = s12 + parameters(i, 1)
      end do

   end subroutine linear_kernel

   subroutine polynomial_kernel(s12, parameters, k)

      implicit none

      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: k

      integer :: i

      do i = 1, size(k)
         k(i) = (parameters(i, 1)*s12 + parameters(i, 2))**parameters(i, 3)
      end do

   end subroutine polynomial_kernel

   subroutine sigmoid_kernel(s12, parameters, k)

      implicit none
      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: k

      integer :: i

      do i = 1, size(k)
         k(i) = tanh(parameters(i, 1)*s12 + parameters(i, 2))
      end do

   end subroutine sigmoid_kernel

   subroutine multiquadratic_kernel(s11, s22, s12, parameters, k)

      implicit none

      double precision, intent(in) :: s11
      double precision, intent(in) :: s22
      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: k

      integer :: i
      double precision :: l2

      l2 = s11 + s22 - 2.0d0*s12

      do i = 1, size(k)
         k(i) = sqrt(l2 + parameters(i, 1)**2)
      end do

   end subroutine multiquadratic_kernel

   subroutine inverse_multiquadratic_kernel(s11, s22, s12, parameters, k)

      implicit none

      double precision, intent(in) :: s11
      double precision, intent(in) :: s22
      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: k

      integer :: i
      double precision :: l2

      l2 = s11 + s22 - 2.0d0*s12

      do i = 1, size(k)
         k(i) = 1.0d0/sqrt(l2 + parameters(i, 1)**2)
      end do

   end subroutine inverse_multiquadratic_kernel

   subroutine bessel_kernel(s12, parameters, k)

      implicit none

      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: k

      integer :: i

      do i = 1, size(k)
         k(i) = BESSEL_JN(int(parameters(i, 2)), parameters(i, 1)*s12) &
             & /(s12**(-parameters(i, 3)*(parameters(i, 2) + 1)))
      end do

   end subroutine bessel_kernel

   subroutine l2_kernel(s11, s22, s12, parameters, k)

      implicit none

      double precision, intent(in) :: s11
      double precision, intent(in) :: s22
      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: k

      integer :: i
      double precision :: l2

      l2 = s11 + s22 - 2.0d0*s12

      do i = 1, size(k)
         k(i) = l2*parameters(i, 1) + parameters(i, 2)
      end do

   end subroutine l2_kernel

   subroutine matern_kernel(s11, s22, s12, parameters, kernel)

      implicit none

      double precision, intent(in) :: s11
      double precision, intent(in) :: s22
      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: kernel

      double precision :: l2

      double precision :: rho

      integer :: i, k, n
      double precision:: v, fact

      l2 = sqrt(s11 + s22 - 2.0d0*s12)

      kernel(:) = 0.0d0

      do i = 1, size(kernel)
         n = int(parameters(i, 2))
         v = n + 0.5d0

         rho = 2.0d0*sqrt(2.0d0*v)*l2/parameters(i, 1)

         do k = 0, n

            fact = parameters(i, 3 + k)

            kernel(i) = kernel(i) + exp(-0.5d0*rho)*fact*rho**(n - k)

         end do
      end do

   end subroutine matern_kernel

   subroutine cauchy_kernel(s11, s22, s12, parameters, k)

      implicit none

      double precision, intent(in) :: s11
      double precision, intent(in) :: s22
      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: k

      integer :: i
      double precision :: l2

      l2 = s11 + s22 - 2.0d0*s12

      do i = 1, size(k)
         k(i) = 1.0d0/(1.0d0 + l2/parameters(i, 1)**2)
      end do

   end subroutine cauchy_kernel

   subroutine polynomial2_kernel(s12, parameters, k)

      implicit none

      double precision, intent(in) :: s12
      double precision, intent(in), dimension(:, :) :: parameters

      double precision, intent(out), dimension(:) :: k

      integer :: i

      do i = 1, size(k)
         k(i) = parameters(i, 1) &
            & + parameters(i, 2)*s12 &
            & + parameters(i, 3)*s12**2 &
            & + parameters(i, 4)*s12**3 &
            & + parameters(i, 5)*s12**4 &
            & + parameters(i, 6)*s12**5 &
            & + parameters(i, 7)*s12**6 &
            & + parameters(i, 8)*s12**7 &
            & + parameters(i, 9)*s12**8 &
            & + parameters(i, 10)*s12**9
      end do

   end subroutine polynomial2_kernel

   !function kernel(s11, s22, s12, kernel_idx, parameters) result(k)
   subroutine kernel(s11, s22, s12, kernel_idx, parameters, k)

      use ffchl_kernel_types

      implicit none

      double precision, intent(in) :: s11
      double precision, intent(in) :: s22
      double precision, intent(in) :: s12
      integer, intent(in) :: kernel_idx
      double precision, intent(in), dimension(:, :) :: parameters

      integer :: n
      !double precision, allocatable, dimension(:) :: k
      double precision, dimension(:) :: k

      n = size(parameters, dim=1)
      !allocate (k(n))

      if (kernel_idx == GAUSSIAN) then
         call gaussian_kernel(s11, s22, s12, parameters, k)

      else if (kernel_idx == LINEAR) then
         call linear_kernel(s12, parameters, k)

      else if (kernel_idx == POLYNOMIAL) then
         call polynomial_kernel(s12, parameters, k)

      else if (kernel_idx == SIGMOID) then
         call sigmoid_kernel(s12, parameters, k)

      else if (kernel_idx == MULTIQUADRATIC) then
         call multiquadratic_kernel(s11, s22, s12, parameters, k)

      else if (kernel_idx == INV_MULTIQUADRATIC) then
         call inverse_multiquadratic_kernel(s11, s22, s12, parameters, k)

      else if (kernel_idx == BESSEL) then
         call bessel_kernel(s12, parameters, k)

      else if (kernel_idx == L2) then
         call l2_kernel(s11, s22, s12, parameters, k)

      else if (kernel_idx == MATERN) then
         call matern_kernel(s11, s22, s12, parameters, k)

      else if (kernel_idx == CAUCHY) then
         call cauchy_kernel(s11, s22, s12, parameters, k)

      else if (kernel_idx == POLYNOMIAL2) then
         call polynomial2_kernel(s12, parameters, k)

      else
         write (*, *) "QML ERROR: Unknown kernel function requested:", kernel_idx
         stop
      end if

   end subroutine kernel

end module ffchl_kernels

module slatm_utils

   implicit none

contains

   function linspace(x0, x1, nx) result(xs)

      implicit none

      double precision, intent(in) :: x0
      double precision, intent(in) :: x1
      integer, intent(in) :: nx

      double precision, dimension(nx) :: xs

      integer :: i
      double precision :: step

      step = (x1 - x0)/(nx - 1)

      !$OMP PARALLEL DO
      do i = 1, nx
         xs(i) = x0 + (i - 1)*step
      end do
      !$OMP END PARALLEL DO

   end function linspace

   function calc_angle(a, b, c) result(angle)

      implicit none

      double precision, intent(in), dimension(3) :: a
      double precision, intent(in), dimension(3) :: b
      double precision, intent(in), dimension(3) :: c

      double precision, dimension(3) :: v1
      double precision, dimension(3) :: v2

      double precision :: cos_angle
      double precision :: angle

      v1 = a - b
      v2 = c - b

      v1 = v1/norm2(v1)
      v2 = v2/norm2(v2)

      cos_angle = dot_product(v1, v2)

      ! Clipping
      if (cos_angle > 1.0d0) cos_angle = 1.0d0
      if (cos_angle < -1.0d0) cos_angle = -1.0d0

      angle = acos(cos_angle)

   end function calc_angle

   function calc_cos_angle(a, b, c) result(cos_angle)

      implicit none

      double precision, intent(in), dimension(3) :: a
      double precision, intent(in), dimension(3) :: b
      double precision, intent(in), dimension(3) :: c

      double precision, dimension(3) :: v1
      double precision, dimension(3) :: v2

      double precision :: cos_angle

      v1 = a - b
      v2 = c - b

      v1 = v1/norm2(v1)
      v2 = v2/norm2(v2)

      cos_angle = dot_product(v1, v2)

   end function calc_cos_angle

end module slatm_utils

subroutine fget_sbot(coordinates, nuclear_charges, z1, z2, z3, rcut, nx, dgrid, sigma, coeff, ys)

   use slatm_utils, only: linspace, calc_angle, calc_cos_angle

   implicit none

   double precision, dimension(:, :), intent(in) :: coordinates
   double precision, dimension(:), intent(in) :: nuclear_charges
   double precision, intent(in) :: rcut
   integer, intent(in) :: nx
   double precision, intent(in) :: dgrid
   double precision, intent(in) :: sigma
   double precision, intent(in) :: coeff
   double precision, dimension(nx), intent(out) :: ys

   ! MBtype
   integer, intent(in) :: z1, z2, z3

   integer, dimension(:), allocatable :: ias1, ias2, ias3
   integer :: nias1, nias2, nias3

   integer :: ia1, ia2, ia3

   double precision, allocatable, dimension(:, :) :: distance_matrix

   double precision :: norm

   integer :: i, j, k
   integer :: natoms

   double precision, parameter :: eps = epsilon(0.0d0)
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)
   double precision :: d2r
   double precision :: c0
   double precision :: ang
   double precision :: cak
   double precision :: cai
   double precision :: prefactor
   double precision :: r
   double precision :: a0, a1
   double precision, dimension(nx) :: xs
   double precision, dimension(nx) :: cos_xs
   double precision :: inv_sigma

   natoms = size(coordinates, dim=1)
   if (size(coordinates, dim=1) /= size(nuclear_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(nuclear_charges, dim=1), "atom_types!"
      stop
   end if

   ! Allocate temporary
   allocate (distance_matrix(natoms, natoms))
   distance_matrix = 0.0d0

   !$OMP PARALLEL DO PRIVATE(norm)
   do i = 1, natoms
      do j = i + 1, natoms
         norm = sqrt(sum((coordinates(j, :) - coordinates(i, :))**2))
         distance_matrix(i, j) = norm
         distance_matrix(j, i) = norm
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (ias1(natoms))
   allocate (ias2(natoms))
   allocate (ias3(natoms))

   ias1 = 0
   ias2 = 0
   ias3 = 0

   nias1 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z1) then
         nias1 = nias1 + 1
         ias1(nias1) = i
      end if
   end do

   nias2 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z2) then
         nias2 = nias2 + 1
         ias2(nias2) = i
      end if
   end do

   nias3 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z3) then
         nias3 = nias3 + 1
         ias3(nias3) = i
      end if
   end do

   d2r = pi/180.0d0
   a0 = -20.0d0*d2r
   a1 = pi + 20.0d0*d2r

   xs = linspace(a0, a1, nx)

   prefactor = 1.0d0/3.0d0

   c0 = prefactor*(mod(z1, 1000)*mod(z2, 1000)*mod(z3, 1000))*coeff*dgrid

   ys = 0.0d0
   inv_sigma = -1.0d0/(2*sigma**2)

   !$OMP PARALLEL DO
   do i = 1, nx
      cos_xs(i) = cos(xs(i))*c0
   end do
   !$OMP END PARALLEL do

   if (z1 == z3) then

      !$OMP PARALLEL DO PRIVATE(i,j,k,ang,cai,cak,r) REDUCTION(+:ys) SCHEDULE(DYNAMIC)
      do ia1 = 1, nias1
         do ia2 = 1, nias2
            if (.not. ((distance_matrix(ias1(ia1), ias2(ia2)) > eps) .and. &
                     & (distance_matrix(ias1(ia1), ias2(ia2)) <= rcut))) cycle
            do ia3 = ia1 + 1, nias3
               if (distance_matrix(ias1(ia1), ias3(ia3)) > rcut) cycle
               if (.not. ((distance_matrix(ias2(ia2), ias3(ia3)) > eps) .and. &
                        & (distance_matrix(ias2(ia2), ias3(ia3)) <= rcut))) cycle

               i = ias1(ia1)
               j = ias2(ia2)
               k = ias3(ia3)

               ang = calc_angle(coordinates(i, :), coordinates(j, :), coordinates(k, :))
               cak = calc_cos_angle(coordinates(i, :), coordinates(k, :), coordinates(j, :))
               cai = calc_cos_angle(coordinates(k, :), coordinates(i, :), coordinates(j, :))

               r = distance_matrix(i, j)*distance_matrix(i, k)*distance_matrix(k, j)

               ys = ys + (c0 + cos_xs*cak*cai)/(r**3)*(exp((xs - ang)**2*inv_sigma))

            end do
         end do
      end do
      !$OMP END PARALLEL do

   else

      !$OMP PARALLEL DO PRIVATE(i,j,k,ang,cai,cak,r) REDUCTION(+:ys) SCHEDULE(DYNAMIC)
      do ia1 = 1, nias1
         do ia2 = 1, nias2
            if (.not. ((distance_matrix(ias1(ia1), ias2(ia2)) > eps) .and. &
                     & (distance_matrix(ias1(ia1), ias2(ia2)) <= rcut))) cycle
            do ia3 = 1, nias3
               if (distance_matrix(ias1(ia1), ias3(ia3)) > rcut) cycle
               if (.not. ((distance_matrix(ias2(ia2), ias3(ia3)) > eps) .and. &
                        & (distance_matrix(ias2(ia2), ias3(ia3)) <= rcut))) cycle

               i = ias1(ia1)
               j = ias2(ia2)
               k = ias3(ia3)

               ang = calc_angle(coordinates(i, :), coordinates(j, :), coordinates(k, :))
               cak = calc_cos_angle(coordinates(i, :), coordinates(k, :), coordinates(j, :))
               cai = calc_cos_angle(coordinates(k, :), coordinates(i, :), coordinates(j, :))

               r = distance_matrix(i, j)*distance_matrix(i, k)*distance_matrix(k, j)
               ys = ys + (c0 + cos_xs*cak*cai)/(r**3)*(exp((xs - ang)**2*inv_sigma))

            end do
         end do
      end do
      !$OMP END PARALLEL do

   end if

   ! !$OMP PARALLEL DO PRIVATE(i,j,k,ang,cai,cak,r) REDUCTION(+:ys) SCHEDULE(DYNAMIC)
   ! do ia1 = 1, nias1
   !     do ia2 = 1, nias2
   !         if (.not. ((distance_matrix(ias1(ia1),ias2(ia2)) > eps) .and. &
   !                  & (distance_matrix(ias1(ia1),ias2(ia2)) <= rcut))) cycle
   !         do ia3 = 1, nias3
   !             if ((z1 == z3) .and. (ias1(ia1) < ias3(ia3))) cycle
   !             if (.not. ((distance_matrix(ias1(ia1),ias3(ia3)) > eps) .and. &
   !                      & (distance_matrix(ias1(ia1),ias3(ia3)) <= rcut))) cycle
   !             if (.not. ((distance_matrix(ias2(ia2),ias3(ia3)) > eps) .and. &
   !                      & (distance_matrix(ias2(ia2),ias3(ia3)) <= rcut))) cycle

   !                 i = ias1(ia1)
   !                 j = ias2(ia2)
   !                 k = ias3(ia3)

   !                 ang = calc_angle(coordinates(i, :), coordinates(j, :), coordinates(k, :))
   !                 cak = calc_cos_angle(coordinates(i, :), coordinates(k, :), coordinates(j, :))
   !                 cai = calc_cos_angle(coordinates(k, :), coordinates(i, :), coordinates(j, :))

   !                 r = distance_matrix(i,j) * distance_matrix(i,k) * distance_matrix(k,j)

   !                 ! ys = ys + c0 *( (1.0d0 + cos_xs*cak*cai)/(r**3 ) ) * ( exp((xs-ang)**2 * inv_sigma) )
   !                 ys = ys + (c0 + cos_xs*cak*cai)/(r**3 ) * ( exp((xs-ang)**2 * inv_sigma) )

   !         enddo
   !     enddo
   ! enddo
   ! !$OMP END PARALLEL do

   deallocate (ias1)
   deallocate (ias2)
   deallocate (ias3)
   deallocate (distance_matrix)

end subroutine fget_sbot

subroutine fget_sbot_local(coordinates, nuclear_charges, ia_python, z1, z2, z3, rcut, nx, dgrid, sigma, coeff, ys)

   use slatm_utils, only: linspace, calc_angle, calc_cos_angle

   implicit none

   double precision, dimension(:, :), intent(in) :: coordinates
   double precision, dimension(:), intent(in) :: nuclear_charges
   double precision, intent(in) :: rcut
   integer, intent(in) :: nx
   integer, intent(in) :: ia_python
   double precision, intent(in) :: dgrid
   double precision, intent(in) :: sigma
   double precision, intent(in) :: coeff
   double precision, dimension(nx), intent(out) :: ys

   ! MBtype
   integer, intent(in) :: z1, z2, z3

   integer, dimension(:), allocatable :: ias1, ias2, ias3
   integer :: nias1, nias2, nias3

   integer :: ia1, ia2, ia3

   double precision, allocatable, dimension(:, :) :: distance_matrix

   double precision :: norm

   integer :: i, j, k
   integer :: natoms

   double precision, parameter :: eps = epsilon(0.0d0)
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)
   double precision :: d2r
   double precision :: c0
   double precision :: ang
   double precision :: cak
   double precision :: cai
   double precision :: prefactor
   double precision :: r
   double precision :: a0, a1
   double precision, dimension(nx) :: xs
   double precision, dimension(nx) :: cos_xs
   double precision :: inv_sigma

   logical :: stop_flag

   integer :: ia
   ia = ia_python + 1

   natoms = size(coordinates, dim=1)
   if (size(coordinates, dim=1) /= size(nuclear_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(nuclear_charges, dim=1), "atom_types!"
      stop
   end if

   ! Allocate temporary
   allocate (distance_matrix(natoms, natoms))
   distance_matrix = 0.0d0

   !$OMP PARALLEL DO PRIVATE(norm)
   do i = 1, natoms
      do j = i + 1, natoms
         norm = sqrt(sum((coordinates(j, :) - coordinates(i, :))**2))
         distance_matrix(i, j) = norm
         distance_matrix(j, i) = norm
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (ias1(natoms))
   allocate (ias2(natoms))
   allocate (ias3(natoms))

   ias1 = 0
   ias2 = 0
   ias3 = 0

   nias1 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z1) then
         nias1 = nias1 + 1
         ias1(nias1) = i
      end if
   end do

   nias2 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z2) then
         nias2 = nias2 + 1
         ias2(nias2) = i
      end if
   end do

   nias3 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z3) then
         nias3 = nias3 + 1
         ias3(nias3) = i
      end if
   end do

   stop_flag = .true.
   do ia2 = 1, nias2
      if (ias2(ia2) == ia) stop_flag = .false.
   end do
   if (stop_flag) return

   d2r = pi/180.0d0
   a0 = -20.0d0*d2r
   a1 = pi + 20.0d0*d2r

   xs = linspace(a0, a1, nx)

   prefactor = 1.0d0/3.0d0

   c0 = prefactor*(mod(z1, 1000)*mod(z2, 1000)*mod(z3, 1000))*coeff*dgrid

   ys = 0.0d0
   inv_sigma = -1.0d0/(2*sigma**2)

   !$OMP PARALLEL DO
   do i = 1, nx
      cos_xs(i) = cos(xs(i))*c0
   end do
   !$OMP END PARALLEL do

   if (z1 == z3) then

      !$OMP PARALLEL DO PRIVATE(i,j,k,ang,cai,cak,r) REDUCTION(+:ys) SCHEDULE(DYNAMIC)
      do ia1 = 1, nias1
         if (.not. ((distance_matrix(ias1(ia1), ia) > eps) .and. &
                  & (distance_matrix(ias1(ia1), ia) <= rcut))) cycle
         do ia3 = ia1 + 1, nias3
            if (distance_matrix(ias1(ia1), ias3(ia3)) > rcut) cycle
            if (.not. ((distance_matrix(ia, ias3(ia3)) > eps) .and. &
                     & (distance_matrix(ia, ias3(ia3)) <= rcut))) cycle

            i = ias1(ia1)
            j = ia
            k = ias3(ia3)

            ang = calc_angle(coordinates(i, :), coordinates(j, :), coordinates(k, :))
            cak = calc_cos_angle(coordinates(i, :), coordinates(k, :), coordinates(j, :))
            cai = calc_cos_angle(coordinates(k, :), coordinates(i, :), coordinates(j, :))

            r = distance_matrix(i, j)*distance_matrix(i, k)*distance_matrix(k, j)

            ys = ys + (c0 + cos_xs*cak*cai)/(r**3)*(exp((xs - ang)**2*inv_sigma))

         end do
      end do
      !$OMP END PARALLEL do

   else

      !$OMP PARALLEL DO PRIVATE(i,j,k,ang,cai,cak,r) REDUCTION(+:ys) SCHEDULE(DYNAMIC)
      do ia1 = 1, nias1
         if (.not. ((distance_matrix(ias1(ia1), ia) > eps) .and. &
                  & (distance_matrix(ias1(ia1), ia) <= rcut))) cycle
         do ia3 = 1, nias3
            if (distance_matrix(ias1(ia1), ias3(ia3)) > rcut) cycle
            if (.not. ((distance_matrix(ia, ias3(ia3)) > eps) .and. &
                     & (distance_matrix(ia, ias3(ia3)) <= rcut))) cycle

            i = ias1(ia1)
            j = ia
            k = ias3(ia3)

            ang = calc_angle(coordinates(i, :), coordinates(j, :), coordinates(k, :))
            cak = calc_cos_angle(coordinates(i, :), coordinates(k, :), coordinates(j, :))
            cai = calc_cos_angle(coordinates(k, :), coordinates(i, :), coordinates(j, :))

            r = distance_matrix(i, j)*distance_matrix(i, k)*distance_matrix(k, j)
            ys = ys + (c0 + cos_xs*cak*cai)/(r**3)*(exp((xs - ang)**2*inv_sigma))

         end do
      end do
      !$OMP END PARALLEL do

   end if

   deallocate (ias1)
   deallocate (ias2)
   deallocate (ias3)
   deallocate (distance_matrix)

end subroutine fget_sbot_local

subroutine fget_sbop(coordinates, nuclear_charges, z1, z2, rcut, nx, dgrid, sigma, coeff, rpower, ys)

   use slatm_utils, only: linspace

   implicit none

   double precision, dimension(:, :), intent(in) :: coordinates
   double precision, dimension(:), intent(in) :: nuclear_charges
   double precision, intent(in) :: rcut
   integer, intent(in) :: nx
   double precision, intent(in) :: dgrid
   double precision, intent(in) :: sigma
   double precision, intent(in) :: rpower
   double precision, intent(in) :: coeff
   double precision, dimension(nx), intent(out) :: ys

   integer, intent(in) :: z1, z2

   double precision :: r0
   double precision :: r
   double precision :: rcut2
   integer :: i
   integer :: natoms

   integer, dimension(:), allocatable :: ias1, ias2
   integer :: nias1, nias2

   integer :: ia1, ia2
   double precision, parameter :: eps = epsilon(0.0d0)
   double precision, dimension(nx) :: xs
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)
   double precision :: c0
   double precision :: inv_sigma

   double precision, dimension(nx) :: xs0

   natoms = size(coordinates, dim=1)
   if (size(coordinates, dim=1) /= size(nuclear_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(nuclear_charges, dim=1), "atom_types!"
      stop
   end if

   allocate (ias1(natoms))
   allocate (ias2(natoms))

   ias1 = 0
   ias2 = 0

   nias1 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z1) then
         nias1 = nias1 + 1
         ias1(nias1) = i
      end if
   end do

   nias2 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z2) then
         nias2 = nias2 + 1
         ias2(nias2) = i
      end if
   end do

   r0 = 0.1d0
   xs = linspace(r0, rcut, nx)
   ys = 0.0d0

   c0 = (mod(z1, 1000)*mod(z2, 1000))*coeff
   inv_sigma = -0.5d0/sigma**2
   xs0 = c0/(xs**rpower)*dgrid

   rcut2 = rcut**2

   if (z1 .eq. z2) then

      !$OMP PARALLEL DO REDUCTION(+:ys)
      do ia1 = 1, nias1
         do ia2 = ia1 + 1, nias2
            r = sum((coordinates(ias1(ia1), :) - coordinates(ias2(ia2), :))**2)

            if (r < rcut2) ys = ys + xs0*exp(inv_sigma*(xs - sqrt(r))**2)

         end do
      end do
      !$OMP END PARALLEL DO

   else

      !$OMP PARALLEL DO REDUCTION(+:ys)
      do ia1 = 1, nias1
         do ia2 = 1, nias2
            r = sum((coordinates(ias1(ia1), :) - coordinates(ias2(ia2), :))**2)

            if (r < rcut2) ys = ys + xs0*exp(inv_sigma*(xs - sqrt(r))**2)
         end do
      end do
      !$OMP END PARALLEL DO

   end if

   deallocate (ias1)
   deallocate (ias2)

end subroutine fget_sbop

subroutine fget_sbop_local(coordinates, nuclear_charges, ia_python, z1, z2, rcut, nx, dgrid, sigma, coeff, rpower, ys)

   use slatm_utils, only: linspace

   implicit none

   double precision, dimension(:, :), intent(in) :: coordinates
   double precision, dimension(:), intent(in) :: nuclear_charges
   double precision, intent(in) :: rcut
   integer, intent(in) :: nx
   integer, intent(in) :: ia_python
   double precision, intent(in) :: dgrid
   double precision, intent(in) :: sigma
   double precision, intent(in) :: rpower
   double precision, intent(in) :: coeff
   double precision, dimension(nx), intent(out) :: ys

   integer, intent(in) :: z1, z2

   double precision :: r0
   double precision :: r
   double precision :: rcut2
   integer :: i
   integer :: natoms

   integer, dimension(:), allocatable :: ias1, ias2
   integer :: nias1, nias2

   integer :: ia1, ia2
   double precision, parameter :: eps = epsilon(0.0d0)
   double precision, dimension(nx) :: xs
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)
   double precision :: c0
   double precision :: inv_sigma

   double precision, dimension(nx) :: xs0
   integer :: ia

   ia = ia_python + 1

   natoms = size(coordinates, dim=1)
   if (size(coordinates, dim=1) /= size(nuclear_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(nuclear_charges, dim=1), "atom_types!"
      stop
   end if

   allocate (ias1(natoms))
   allocate (ias2(natoms))

   ias1 = 0
   ias2 = 0

   nias1 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z1) then
         nias1 = nias1 + 1
         ias1(nias1) = i
      end if
   end do

   nias2 = 0
   do i = 1, natoms
      if (int(nuclear_charges(i)) .eq. z2) then
         nias2 = nias2 + 1
         ias2(nias2) = i
      end if
   end do

   r0 = 0.1d0
   xs = linspace(r0, rcut, nx)
   ys = 0.0d0

   c0 = (mod(z1, 1000)*mod(z2, 1000))*coeff
   inv_sigma = -0.5d0/sigma**2
   xs0 = c0/(xs**rpower)*dgrid

   rcut2 = rcut**2

   if (z1 .eq. z2) then

      !$OMP PARALLEL DO REDUCTION(+:ys)
      do ia1 = 1, nias1
         do ia2 = ia1 + 1, nias2
            if ((ias1(ia1) /= ia) .and. (ias2(ia2) /= ia)) cycle
            r = sum((coordinates(ias1(ia1), :) - coordinates(ias2(ia2), :))**2)

            if (r < rcut2) ys = ys + xs0*exp(inv_sigma*(xs - sqrt(r))**2)

         end do
      end do
      !$OMP END PARALLEL DO

   else

      !$OMP PARALLEL DO REDUCTION(+:ys)
      do ia1 = 1, nias1
         do ia2 = 1, nias2
            if ((ias1(ia1) /= ia) .and. (ias2(ia2) /= ia)) cycle
            r = sum((coordinates(ias1(ia1), :) - coordinates(ias2(ia2), :))**2)

            if (r < rcut2) ys = ys + xs0*exp(inv_sigma*(xs - sqrt(r))**2)
         end do
      end do
      !$OMP END PARALLEL DO

   end if

   deallocate (ias1)
   deallocate (ias2)

end subroutine fget_sbop_local

subroutine fkpca(k, n, centering, kpca)

   implicit none

   double precision, dimension(:, :), intent(in) :: k
   integer, intent(in) :: n
   logical, intent(in) :: centering
   double precision, dimension(n, n), intent(out) :: kpca

   ! Eigenvalues
   double precision, dimension(n) :: eigenvals

   double precision, allocatable, dimension(:) :: work

   integer :: lwork
   integer :: info

   integer :: i

   double precision :: inv_n
   double precision, allocatable, dimension(:) :: temp
   double precision :: temp_sum

   kpca(:, :) = k(:, :)

   ! This first part centers the matrix,
   ! basically Kpca = K - G@K - K@G + G@K@G, with G = 1/n
   ! It is a bit hard to follow, sry, but it is very fast
   ! and requires very little memory overhead.

   if (centering) then

      inv_n = 1.0d0/n

      allocate (temp(n))
      temp(:) = 0.0d0

      !$OMP PARALLEL DO
      do i = 1, n
         temp(i) = sum(k(i, :))*inv_n
      end do
      !$OMP END PARALLEL DO

      temp_sum = sum(temp(:))*inv_n

      !$OMP PARALLEL DO
      do i = 1, n
         kpca(i, :) = kpca(i, :) + temp_sum
      end do
      !$OMP END PARALLEL DO

      !$OMP PARALLEL DO
      do i = 1, n
         kpca(:, i) = kpca(:, i) - temp(i)
      end do
      !$OMP END PARALLEL DO

      !$OMP PARALLEL DO
      do i = 1, n
         kpca(i, :) = kpca(i, :) - temp(i)
      end do
      !$OMP END PARALLEL DO

      deallocate (temp)

   end if

   ! This 2nd part solves the eigenvalue problem with the least
   ! memory intensive solver, namely DSYEV(). DSYEVD() is twice
   ! as fast, but requires a lot more memory, which quickly
   ! becomes prohibitive.

   ! Dry run which returns the optimal "lwork"
   allocate (work(1))
   call dsyev("V", "U", n, kpca, n, eigenvals, work, -1, info)
   lwork = nint(work(1)) + 1
   deallocate (work)

   ! Get eigenvectors
   allocate (work(lwork))
   call dsyev("V", "U", n, kpca, n, eigenvals, work, lwork, info)
   deallocate (work)

   if (info < 0) then

      write (*, *) "ERROR: The ", -info, "-th argument to DSYEV() had an illegal value."

   else if (info > 0) then

      write (*, *) "ERROR: DSYEV() failed to compute an eigenvalue."

   end if

   ! This 3rd part sorts the kernel PCA matrix such that the first PCA is kpca(1)
   kpca = kpca(:, n:1:-1)
   kpca = transpose(kpca)

   !$OMP PARALLEL DO
   do i = 1, n
      kpca(i, :) = kpca(i, :)*sqrt(eigenvals(n - i + 1))
   end do
   !$OMP END PARALLEL DO

end subroutine fkpca

subroutine fcho_solve(A, y, x)

   implicit none

   double precision, dimension(:, :), intent(in) :: A
   double precision, dimension(:), intent(in) :: y
   double precision, dimension(:), intent(inout) :: x

   integer :: info, na

   na = size(A, dim=1)

   call dpotrf("U", na, A, na, info)
   if (info > 0) then
      write (*, *) "WARNING: Error in LAPACK Cholesky decomposition DPOTRF()."
      write (*, *) "WARNING: The", info, "-th leading order is not positive definite."
   else if (info < 0) then
      write (*, *) "WARNING: Error in LAPACK Cholesky decomposition DPOTRF()."
      write (*, *) "WARNING: The", -info, "-th argument had an illegal value."
   end if

   x(:na) = y(:na)

   call dpotrs("U", na, 1, A, na, x, na, info)
   if (info < 0) then
      write (*, *) "WARNING: Error in LAPACK Cholesky solver DPOTRS()."
      write (*, *) "WARNING: The", -info, "-th argument had an illegal value."
   end if

end subroutine fcho_solve

subroutine fcho_invert(A)

   implicit none

   double precision, dimension(:, :), intent(inout) :: A
   integer :: info, na

   na = size(A, dim=1)

   call dpotrf("L", na, A, na, info)
   if (info > 0) then
      write (*, *) "WARNING: Cholesky decomposition DPOTRF() exited with error code:", info
   end if

   call dpotri("L", na, A, na, info)
   if (info > 0) then
      write (*, *) "WARNING: Cholesky inversion DPOTRI() exited with error code:", info
   end if

end subroutine fcho_invert

subroutine fbkf_invert(A)

   implicit none

   double precision, dimension(:, :), intent(inout) :: A
   integer :: info, na, nb

   integer, dimension(size(A, 1)) :: ipiv   ! pivot indices
   integer :: ilaenv

   integer :: lwork

   double precision, allocatable, dimension(:) :: work

   na = size(A, dim=1)

   nb = ilaenv(1, 'DSYTRF', "L", na, -1, -1, -1)

   lwork = na*nb

   allocate (work(lwork))

   ! call dpotrf("L", na, A , na, info)
   call dsytrf("L", na, A, na, ipiv, work, lwork, info)
   if (info > 0) then
      write (*, *) "WARNING: Bunch-Kaufman factorization DSYTRI() exited with error code:", info
   end if

   ! call dpotri("L", na, A , na, info )
   call dsytri("L", na, a, na, ipiv, work, info)
   if (info > 0) then
      write (*, *) "WARNING: BKF inversion DPOTRI() exited with error code:", info
   end if

   deallocate (work)

end subroutine fbkf_invert

subroutine fbkf_solve(A, y, x)

   implicit none

   double precision, dimension(:, :), intent(in) :: A
   double precision, dimension(:), intent(in) :: y
   double precision, dimension(:), intent(inout) :: x

   double precision, allocatable, dimension(:) :: work
   integer :: ilaenv

   integer, dimension(size(A, 1)) :: ipiv   ! pivot indices
   integer :: info, na, nb, lwork

   na = size(A, dim=1)

   nb = ilaenv(1, 'DSYTRF', "L", na, -1, -1, -1)

   lwork = na*nb
   allocate (work(lwork))

   call dsytrf("L", na, A, na, ipiv, work, lwork, info)
   if (info > 0) then
      write (*, *) "WARNING: Bunch-Kaufman factorization DSYTRI() exited with error code:", info
   end if

   x(:na) = y(:na)

   call dsytrs("L", na, 1, A, na, ipiv, x, na, info)

   if (info > 0) then
      write (*, *) "WARNING: Bunch-Kaufman solver DSYTRS() exited with error code:", info
   end if

   deallocate (work)
end subroutine fbkf_solve

subroutine fqrlq_solve(A, y, la, x)

   implicit none

   double precision, dimension(:, :), intent(inout) :: A
   double precision, dimension(:), intent(inout):: y
   integer, intent(in):: la

   double precision, allocatable, dimension(:, :) :: b
   double precision, dimension(la), intent(out) :: x

   integer :: m, n, nrhs, lda, ldb, info

   integer :: lwork
   double precision, dimension(:), allocatable :: work

   m = size(A, dim=1)
   n = size(A, dim=2)

   nrhs = 1
   lda = m
   ldb = max(m, n)

   allocate (b(ldb, 1))
   b = 0.0d0
   b(:m, 1) = y(:m)

   lwork = (min(m, n) + max(m, n))*10
   allocate (work(lwork))

   ! write (*,*) info, lda, ldb, m, n
   call dgels("N", m, n, nrhs, a, lda, b, ldb, work, lwork, info)

   if (info < 0) then
      write (*, *) "QML WARNING: Could not perform QRLQ solver DGELS: info =", info
   else if (info > 0) then
      write (*, *) "QML WARNING: QRLQ solver (DGELS) the", -info, "th"
      write (*, *) "diagonal element of the triangular factor of A is zero,"
      write (*, *) "so that A does not have full rank; the least squares"
      write (*, *) "solution could not be computed."
   end if

   x(:n) = b(:n, 1)

end subroutine fqrlq_solve

subroutine fsvd_solve(A, y, la, rcond, x)

   implicit none

   double precision, dimension(:, :), intent(inout) :: A
   double precision, dimension(:), intent(inout):: y
   integer, intent(in):: la
   double precision, intent(in) :: rcond

   double precision, allocatable, dimension(:, :) :: b
   double precision, dimension(la), intent(out) :: x

   integer :: m, n, nrhs, lda, ldb, info

   integer :: lwork
   integer :: liwork
   double precision, dimension(:), allocatable :: work

   integer, dimension(:), allocatable :: iwork

   double precision, dimension(:), allocatable :: s
   integer :: rank

   m = size(A, dim=1)
   n = size(A, dim=2)

   nrhs = 1
   lda = m
   ldb = max(m, n)

   allocate (b(ldb, 1))
   b = 0.0d0
   b(:m, 1) = y(:m)

   allocate (s(ldb))
   ! rcond = 0.0d0

   allocate (work(1))
   allocate (iwork(1))

   lwork = -1
   call dgelsd(m, n, nrhs, a, lda, b, ldb, s, rcond, rank, work, lwork, iwork, info)

   liwork = int(iwork(1))
   lwork = int(work(1))

   deallocate (work)
   deallocate (iwork)
   allocate (work(lwork))
   allocate (iwork(liwork))

   call dgelsd(m, n, nrhs, a, lda, b, ldb, s, rcond, rank, work, lwork, iwork, info)

   ! write (*,*) "DGELSD(): matrix rank =", rank, "/", n
   ! write (*,*) "DGELSD(): matrix rcond =", rcond
   ! write (*,*) "DGELSD(): matrix cond =", 1.0d0/rcond

   ! allocate(x(m))
   x(:n) = b(:n, 1)

end subroutine fsvd_solve

subroutine fcond(A, rcond)

   implicit none

   double precision, dimension(:, :), intent(inout) :: A
   double precision, intent(out) :: rcond

   double precision :: anorm
   character, parameter :: norm = "1"
   character, parameter :: uplo = "U"

   double precision, allocatable, dimension(:) :: work
   integer, allocatable, dimension(:) :: iwork

   double precision, allocatable, dimension(:) :: A_diag

   integer :: info, na, nb
   integer :: n, lda
   integer :: i

   double precision :: dlansy

   na = size(A, dim=1)
   nb = size(A, dim=2)

   n = na
   lda = na

   ! Save diagonal
   allocate (a_diag(n))
   do i = 1, na
      a_diag(i) = a(i, i)
   end do

   allocate (work(n))
   anorm = dlansy(norm, uplo, n, a, lda, work)
   deallocate (work)

   ! Cholesky factorization

   call dpotrf("U", n, A, lda, info)
   if (info > 0) then
      write (*, *) "WARNING: Cholesky decompositon failed because A is not positive definite. info = ", info
   else if (info < 0) then
      write (*, *) "WARNING: Cholesky decompositon DPOTRF() failed. info = ", info
   end if

   ! Condition number from Cholesky factorization

   allocate (work(n*3))
   allocate (iwork(n))

   call dpocon(uplo, n, a, lda, anorm, rcond, work, iwork, info)
   if (info < 0) then
      write (*, *) "WARNING: Calculating condition number DPOCON() failed. info = ", info
   end if

   deallocate (work)
   deallocate (iwork)

   ! Restore lower triangle and diagonal
   do i = 1, na
      a(i, i) = a_diag(i)
      a(i, i + 1:) = a(i + 1:, i)
   end do

   deallocate (a_diag)

   rcond = 1.0d0/rcond

end subroutine fcond

subroutine fcond_ge(K, rcond)

   implicit none

   double precision, dimension(:, :), intent(in) :: K
   double precision, intent(out) :: rcond

   double precision :: anorm
   character, parameter :: norm = "1"
   ! character, parameter :: uplo = "U"

   double precision, allocatable, dimension(:) :: work
   double precision, allocatable, dimension(:, :) :: A
   integer, allocatable, dimension(:) :: iwork
   integer, allocatable, dimension(:) :: ipiv

   integer :: info
   integer :: n, m, lda

   double precision :: dlange

   m = size(K, dim=1)
   n = size(K, dim=2)

   allocate (A(m, n))

   A(:, :) = K(:, :)

   lda = n

   allocate (work(max(m, n)))
   anorm = dlange(norm, m, n, a, lda, work)
   deallocate (work)

   allocate (ipiv(min(m, n)))
   call dgetrf(m, n, a, lda, ipiv, info)
   deallocate (ipiv)

   if (info > 0) then
      write (*, *) "WARNING: LU-decompositon failed because A is exactly singular. info = ", info
   else if (info < 0) then
      write (*, *) "WARNING: LU-decompositon DGETRF() failed. info = ", info
   end if

   allocate (work(n*4))
   allocate (iwork(n))
   call dgecon(norm, n, a, lda, anorm, rcond, work, iwork, info)

   if (info < 0) then
      write (*, *) "WARNING: Calculating condition number DGECON() failed. info = ", info
   end if

   deallocate (work)
   deallocate (iwork)
   deallocate (a)

   rcond = 1.0d0/rcond

end subroutine fcond_ge

module acsf_utils

    implicit none

contains

function decay(r, invrc, natoms) result(f)

    implicit none

    double precision, intent(in), dimension(:,:) :: r
    double precision, intent(in) :: invrc
    integer, intent(in) :: natoms
    double precision, dimension(natoms, natoms) :: f

    double precision, parameter :: pi = 4.0d0 * atan(1.0d0)

    ! Decaying function reaching 0 at rc
    f = 0.5d0 * (cos(pi * r * invrc) + 1.0d0)


end function decay

function calc_angle(a, b, c) result(angle)

    implicit none

    double precision, intent(in), dimension(3) :: a
    double precision, intent(in), dimension(3) :: b
    double precision, intent(in), dimension(3) :: c

    double precision, dimension(3) :: v1
    double precision, dimension(3) :: v2

    double precision :: cos_angle
    double precision :: angle

    v1 = a - b
    v2 = c - b

    v1 = v1 / norm2(v1)
    v2 = v2 / norm2(v2)

    cos_angle = dot_product(v1,v2)

    ! Clipping
    if (cos_angle > 1.0d0) cos_angle = 1.0d0
    if (cos_angle < -1.0d0) cos_angle = -1.0d0

    angle = acos(cos_angle)

end function calc_angle

function calc_cos_angle(a, b, c) result(cos_angle)

    implicit none

    double precision, intent(in), dimension(3) :: a
    double precision, intent(in), dimension(3) :: b
    double precision, intent(in), dimension(3) :: c

    double precision, dimension(3) :: v1
    double precision, dimension(3) :: v2

    double precision :: cos_angle

    v1 = a - b
    v2 = c - b

    v1 = v1 / norm2(v1)
    v2 = v2 / norm2(v2)

    cos_angle = dot_product(v1,v2)

end function calc_cos_angle

end module acsf_utils


subroutine fgenerate_acsf(coordinates, nuclear_charges, elements, &
                          & Rs2, Rs3, Ts, eta2, eta3, zeta, rcut, acut, natoms, rep_size, rep)

    use acsf_utils, only: decay, calc_angle

    implicit none

    double precision, intent(in), dimension(:, :) :: coordinates
    integer, intent(in), dimension(:) :: nuclear_charges
    integer, intent(in), dimension(:) :: elements
    double precision, intent(in), dimension(:) :: Rs2
    double precision, intent(in), dimension(:) :: Rs3
    double precision, intent(in), dimension(:) :: Ts
    double precision, intent(in) :: eta2
    double precision, intent(in) :: eta3
    double precision, intent(in) :: zeta
    double precision, intent(in) :: rcut
    double precision, intent(in) :: acut
    integer, intent(in) :: natoms
    integer, intent(in) :: rep_size
    double precision, intent(out), dimension(natoms, rep_size) :: rep

    integer :: i, j, k, l, n, m, p, q, s, z, nelements, nbasis2, nbasis3, nabasis
    integer, allocatable, dimension(:) :: element_types
    double precision :: rij, rik, angle, invcut
    double precision, allocatable, dimension(:) :: radial, angular, a, b, c
    double precision, allocatable, dimension(:, :) :: distance_matrix, rdecay,  rep_subset

    double precision, parameter :: pi = 4.0d0 * atan(1.0d0)

    if (natoms /= size(nuclear_charges, dim=1)) then
        write(*,*) "ERROR: Atom Centered Symmetry Functions creation"
        write(*,*) natoms, "coordinates, but", &
            & size(nuclear_charges, dim=1), "atom_types!"
        stop
    endif


    ! number of element types
    nelements = size(elements)
    ! Allocate temporary
    allocate(element_types(natoms))

    ! Store element index of every atom
    !$OMP PARALLEL DO
    do i = 1, natoms
        do j = 1, nelements
            if (nuclear_charges(i) .eq. elements(j)) then
                element_types(i) = j
                cycle
            endif
        enddo
    enddo
    !$OMP END PARALLEL DO


    ! Get distance matrix
    ! Allocate temporary
    allocate(distance_matrix(natoms, natoms))
    distance_matrix = 0.0d0


    !$OMP PARALLEL DO PRIVATE(rij)
    do i = 1, natoms
        do j = i+1, natoms
            rij = norm2(coordinates(j,:) - coordinates(i,:))
            distance_matrix(i, j) = rij
            distance_matrix(j, i) = rij
        enddo
    enddo
    !$OMP END PARALLEL DO

    ! number of basis functions in the two body term
    nbasis2 = size(Rs2)

    ! Inverse of the two body cutoff
    invcut = 1.0d0 / rcut
    ! pre-calculate the radial decay in the two body terms
    rdecay = decay(distance_matrix, invcut, natoms)

    ! Allocate temporary
    allocate(radial(nbasis2))
    allocate(rep_subset(natoms, nelements * nbasis2))

    rep_subset = 0.0d0

    !$OMP PARALLEL DO PRIVATE(n,m,rij,radial) COLLAPSE(2) REDUCTION(+:rep_subset) SCHEDULE(dynamic)
    do i = 1, natoms
        do j = 1, natoms
            if (j .le. i) cycle
            rij = distance_matrix(i,j)
            if (rij <= rcut) then
                ! index of the element of atom i
                m = element_types(i)
                ! index of the element of atom j
                n = element_types(j)
                ! distance between atoms i and j
                ! two body term of the representation
                radial = exp(-eta2*(rij - Rs2)**2) * rdecay(i,j)
                rep_subset(i, (n-1)*nbasis2 + 1:n*nbasis2) = rep_subset(i, (n-1)*nbasis2 + 1:n*nbasis2) + radial
                rep_subset(j, (m-1)*nbasis2 + 1:m*nbasis2) = rep_subset(j, (m-1)*nbasis2 + 1:m*nbasis2) + radial
            endif
        enddo
    enddo
    !$OMP END PARALLEL DO

    rep(:, 1:nelements * nbasis2) = rep_subset(:,:)

    deallocate(radial)
    deallocate(rep_subset)

    ! number of radial basis functions in the three body term
    nbasis3 = size(Rs3)
    ! number of radial basis functions in the three body term
    nabasis = size(Ts)

    ! Inverse of the three body cutoff
    invcut = 1.0d0 / acut
    ! pre-calculate the radial decay in the three body terms
    rdecay = decay(distance_matrix, invcut, natoms)

    ! Allocate temporary
    allocate(rep_subset(natoms,rep_size - nelements * nbasis2))
    allocate(a(3))
    allocate(b(3))
    allocate(c(3))
    allocate(radial(nbasis3))
    allocate(angular(nabasis))

    rep_subset = 0.0d0

    ! This could probably be done more efficiently if it's a bottleneck
    ! Also the order is a bit wobbly compared to the tensorflow implementation
    !$OMP PARALLEL DO PRIVATE(rij, n, rik, m, a, b, c, angle, radial, angular, &
    !$OMP p, q, s, z) REDUCTION(+:rep_subset) COLLAPSE(2) SCHEDULE(dynamic)
    do i = 1, natoms
        do j = 1, natoms - 1
            if (i .eq. j) cycle
            ! distance between atoms i and j
            rij = distance_matrix(i,j)
            if (rij > acut) cycle
            ! index of the element of atom j
            n = element_types(j)
            do k = j + 1, natoms
                if (i .eq. k) cycle
                ! distance between atoms i and k
                rik = distance_matrix(i,k)
                if (rik > acut) cycle
                ! index of the element of atom k
                m = element_types(k)
                ! coordinates of atoms j, i, k
                a = coordinates(j,:)
                b = coordinates(i,:)
                c = coordinates(k,:)
                ! angle between atoms i, j and k centered on i
                angle = calc_angle(a,b,c)
                ! The radial part of the three body terms including decay
                radial = exp(-eta3*(0.5d0 * (rij+rik) - Rs3)**2) * rdecay(i,j) * rdecay(i,k)
                ! The angular part of the three body terms
                angular = 2.0d0 * ((1.0d0 + cos(angle - Ts)) * 0.5d0) ** zeta
                ! The lowest of the element indices for atoms j and k
                p = min(n,m) - 1
                ! The highest of the element indices for atoms j and k
                q = max(n,m) - 1
                ! calculate the indices that the three body terms should be added to
                s = nbasis3 * nabasis * (-(p * (p + 1))/2 + q + nelements * p) + 1
                do l = 1, nbasis3
                    ! calculate the indices that the three body terms should be added to
                    z = s + (l-1) * nabasis
                    ! Add the contributions from atoms i,j and k
                    rep_subset(i, z:z + nabasis - 1) = rep_subset(i, z:z + nabasis - 1) + angular * radial(l)
                enddo
            enddo
        enddo
    enddo
    !$OMP END PARALLEL DO

    rep(:, nelements * nbasis2 + 1:) = rep_subset(:,:)

    deallocate(element_types)
    deallocate(rdecay)
    deallocate(distance_matrix)
    deallocate(rep_subset)
    deallocate(a)
    deallocate(b)
    deallocate(c)
    deallocate(radial)
    deallocate(angular)

end subroutine fgenerate_acsf

subroutine fgenerate_acsf_and_gradients(coordinates, nuclear_charges, elements, &
                          & Rs2, Rs3, Ts, eta2, eta3, zeta, rcut, acut, natoms, &
                          & rep_size, rep, grad)

    use acsf_utils, only: decay, calc_angle

    implicit none

    double precision, intent(in), dimension(:, :) :: coordinates
    integer, intent(in), dimension(:) :: nuclear_charges
    integer, intent(in), dimension(:) :: elements
    double precision, intent(in), dimension(:) :: Rs2
    double precision, intent(in), dimension(:) :: Rs3
    double precision, intent(in), dimension(:) :: Ts
    double precision, intent(in) :: eta2
    double precision, intent(in) :: eta3
    double precision, intent(in) :: zeta
    double precision, intent(in) :: rcut
    double precision, intent(in) :: acut
    integer, intent(in) :: natoms
    integer, intent(in) :: rep_size
    double precision, intent(out), dimension(natoms, rep_size) :: rep
    double precision, intent(out), dimension(natoms, rep_size, natoms, 3) :: grad

    integer :: i, j, k, l, n, m, p, q, s, t, z, nelements, nbasis2, nbasis3, nabasis, twobody_size
    integer, allocatable, dimension(:) :: element_types
    double precision :: rij, rik, angle, dot, rij2, rik2, invrij, invrik, invrij2, invrik2, invcut
    double precision, allocatable, dimension(:) :: radial_base, radial, angular, a, b, c, atom_rep
    double precision, allocatable, dimension(:) :: angular_base, d_radial, d_radial_d_i
    double precision, allocatable, dimension(:) :: d_radial_d_j, d_radial_d_k, d_ijdecay, d_ikdecay
    double precision, allocatable, dimension(:) :: d_angular, part, radial_part
    double precision, allocatable, dimension(:) :: d_angular_d_i, d_angular_d_j, d_angular_d_k
    double precision, allocatable, dimension(:, :) :: distance_matrix, rdecay, sq_distance_matrix
    double precision, allocatable, dimension(:, :) :: inv_distance_matrix, inv_sq_distance_matrix
    double precision, allocatable, dimension(:, :) :: rep_subset
    double precision, allocatable, dimension(:, :, :) :: atom_grad
    double precision, allocatable, dimension(:, :, :, :) :: grad_subset

    double precision, parameter :: pi = 4.0d0 * atan(1.0d0)

    if (natoms /= size(nuclear_charges, dim=1)) then
        write(*,*) "ERROR: Atom Centered Symmetry Functions creation"
        write(*,*) natoms, "coordinates, but", &
            & size(nuclear_charges, dim=1), "atom_types!"
        stop
    endif


    ! Number of unique elements
    nelements = size(elements)
    ! Allocate temporary
    allocate(element_types(natoms))

    ! Store element index of every atom
    !$OMP PARALLEL DO
    do i = 1, natoms
        do j = 1, nelements
            if (nuclear_charges(i) .eq. elements(j)) then
                element_types(i) = j
                cycle
            endif
        enddo
    enddo
    !$OMP END PARALLEL DO



    ! Get distance matrix
    ! Allocate temporary
    allocate(distance_matrix(natoms, natoms))
    allocate(sq_distance_matrix(natoms, natoms))
    allocate(inv_distance_matrix(natoms, natoms))
    allocate(inv_sq_distance_matrix(natoms, natoms))
    distance_matrix = 0.0d0
    sq_distance_matrix = 0.0d0
    inv_distance_matrix = 0.0d0
    inv_sq_distance_matrix = 0.0d0


    !$OMP PARALLEL DO PRIVATE(rij,rij2,invrij,invrij2) SCHEDULE(dynamic)
    do i = 1, natoms
        do j = 1, natoms
            if (j .le. i) cycle
            rij = norm2(coordinates(j,:) - coordinates(i,:))
            distance_matrix(i, j) = rij
            distance_matrix(j, i) = rij
            rij2 = rij * rij
            sq_distance_matrix(i, j) = rij2
            sq_distance_matrix(j, i) = rij2
            invrij = 1.0d0 / rij
            inv_distance_matrix(i, j) = invrij
            inv_distance_matrix(j, i) = invrij
            invrij2 = invrij * invrij
            inv_sq_distance_matrix(i, j) = invrij2
            inv_sq_distance_matrix(j, i) = invrij2
        enddo
    enddo
    !$OMP END PARALLEL DO


    ! Number of two body basis functions
    nbasis2 = size(Rs2)

    ! Inverse of the two body cutoff distance
    invcut = 1.0d0 / rcut
    ! Pre-calculate the two body decay
    rdecay = decay(distance_matrix, invcut, natoms)

    ! Allocate temporary
    allocate(radial_base(nbasis2))
    allocate(radial(nbasis2))
    allocate(radial_part(nbasis2))
    allocate(part(nbasis2))
    allocate(rep_subset(natoms, nelements * nbasis2))
    allocate(grad_subset(natoms, nelements * nbasis2, natoms, 3))

    grad_subset = 0.0d0
    rep_subset = 0.0d0

    !$OMP PARALLEL DO PRIVATE(m,n,rij,invrij,radial_base,radial,radial_part,part) REDUCTION(+:rep_subset,grad_subset) &
    !$OMP SCHEDULE(dynamic)
    do i = 1, natoms
        ! The element index of atom i
        m = element_types(i)
        do j = i + 1, natoms
            ! The element index of atom j
            n = element_types(j)
            ! Distance between atoms i and j
            rij = distance_matrix(i,j)
            if (rij <= rcut) then
                invrij = inv_distance_matrix(i,j)
                ! part of the two body terms
                radial_base = exp(-eta2*(rij - Rs2)**2)
                ! The full two body term between atom i and j
                radial = radial_base * rdecay(i,j)
                ! Add the contributions from atoms i and j
                rep_subset(i, (n-1)*nbasis2 + 1:n*nbasis2) = rep_subset(i, (n-1)*nbasis2 + 1:n*nbasis2) + radial
                rep_subset(j, (m-1)*nbasis2 + 1:m*nbasis2) = rep_subset(j, (m-1)*nbasis2 + 1:m*nbasis2) + radial
                ! Part of the gradients that can be reused for x,y and z coordinates
                radial_part = - radial_base * invrij * (2.0d0 * eta2 * (rij - Rs2) * rdecay(i,j) + &
                    & 0.5d0 * pi * sin(pi*rij * invcut) * invcut)
                do k = 1, 3
                    ! The gradients wrt coordinates
                    part = radial_part * (coordinates(i,k) - coordinates(j,k))
                    grad_subset(i, (n-1)*nbasis2 + 1:n*nbasis2, i, k) = &
                        grad_subset(i, (n-1)*nbasis2 + 1:n*nbasis2, i, k) + part
                    grad_subset(i, (n-1)*nbasis2 + 1:n*nbasis2, j, k) = &
                        grad_subset(i, (n-1)*nbasis2 + 1:n*nbasis2, j, k) - part
                    grad_subset(j, (m-1)*nbasis2 + 1:m*nbasis2, j, k) = &
                        grad_subset(j, (m-1)*nbasis2 + 1:m*nbasis2, j, k) - part
                    grad_subset(j, (m-1)*nbasis2 + 1:m*nbasis2, i, k) = &
                        grad_subset(j, (m-1)*nbasis2 + 1:m*nbasis2, i, k) + part
                enddo
            endif
        enddo
    enddo
    !$OMP END PARALLEL DO

    rep(:,:nelements*nbasis2) = rep_subset(:,:)
    grad(:,:nelements*nbasis2,:,:) = grad_subset(:,:,:,:)

    deallocate(radial_base)
    deallocate(radial)
    deallocate(radial_part)
    deallocate(part)
    deallocate(rep_subset)
    deallocate(grad_subset)


    ! Number of radial basis functions in the three body term
    nbasis3 = size(Rs3)
    ! Number of angular basis functions in the three body term
    nabasis = size(Ts)
    ! Size of two body terms
    twobody_size = nelements * nbasis2

    ! Inverse of the three body cutoff distance
    invcut = 1.0d0 / acut
    ! Pre-calculate the three body decay
    rdecay = decay(distance_matrix, invcut, natoms)

    ! Allocate temporary
    allocate(atom_rep(rep_size - twobody_size))
    allocate(atom_grad(rep_size - twobody_size, natoms, 3))
    allocate(a(3))
    allocate(b(3))
    allocate(c(3))
    allocate(radial(nbasis3))
    allocate(angular_base(nabasis))
    allocate(angular(nabasis))
    allocate(d_angular(nabasis))
    allocate(d_angular_d_i(3))
    allocate(d_angular_d_j(3))
    allocate(d_angular_d_k(3))
    allocate(d_radial(nbasis3))
    allocate(d_radial_d_i(3))
    allocate(d_radial_d_j(3))
    allocate(d_radial_d_k(3))
    allocate(d_ijdecay(3))
    allocate(d_ikdecay(3))

    ! This could probably be done more efficiently if it's a bottleneck
    ! The order is a bit wobbly compared to the tensorflow implementation
    !$OMP PARALLEL DO PRIVATE(atom_rep,atom_grad,a,b,c,radial,angular_base, &
    !$OMP angular,d_angular,rij,n,rij2,invrij,invrij2,d_angular_d_i, &
    !$OMP d_angular_d_j,d_angular_d_k,rik,m,rik2,invrik,invrik2,angle, &
    !$OMP p,q,dot,d_radial,d_radial_d_i,d_radial_d_j,d_radial_d_k,s,z, &
    !$OMP d_ijdecay,d_ikdecay) SCHEDULE(dynamic)
    do i = 1, natoms
        atom_rep = 0.0d0
        atom_grad = 0.0d0
        do j = 1, natoms - 1
            if (i .eq. j) cycle
            ! distance between atom i and j
            rij = distance_matrix(i,j)
            if (rij > acut) cycle
            ! index of the element of atom j
            n = element_types(j)
            ! squared distance between atom i and j
            rij2 = sq_distance_matrix(i,j)
            ! inverse distance between atom i and j
            invrij = inv_distance_matrix(i,j)
            ! inverse squared distance between atom i and j
            invrij2 = inv_sq_distance_matrix(i,j)
            do k = j + 1, natoms
                if (i .eq. k) cycle
                ! distance between atom i and k
                rik = distance_matrix(i,k)
                if (rik > acut) cycle
                ! index of the element of atom k
                m = element_types(k)
                ! squared distance between atom i and k
                rik2 = sq_distance_matrix(i,k)
                ! inverse distance between atom i and k
                invrik = inv_distance_matrix(i,k)
                ! inverse squared distance between atom i and k
                invrik2 = inv_sq_distance_matrix(i,k)
                ! coordinates of atoms j, i, k
                a = coordinates(j,:)
                b = coordinates(i,:)
                c = coordinates(k,:)
                ! angle between atom i, j and k, centered on i
                angle = calc_angle(a,b,c)
                ! part of the radial part of the 3body terms
                radial = exp(-eta3*(0.5d0 * (rij+rik) - Rs3)**2)
                ! used in the angular part of the 3body terms and in gradients
                angular_base = ((1.0d0 + cos(angle - Ts)) * 0.5d0)
                ! angular part of the 3body terms
                angular = 2.0d0 * angular_base ** zeta
                ! the lowest index of the elements of j,k
                p = min(n,m) - 1
                ! the highest index of the elements of j,k
                q = max(n,m) - 1
                ! Dot product between the vectors connecting atom i,j and i,k
                dot = dot_product(a-b,c-b)
                ! Part of the derivative of the angular basis functions wrt coordinates (dim(nabasis))
                ! including decay
                d_angular = (zeta * angular * sin(angle-Ts) * rdecay(i,j) * rdecay(i,k)) / &
                    ! & (2.0d0 * sqrt(rij2 * rik2 - dot**2) * angular_base)
                    & (2.0d0 * max(1d-10, sqrt(abs(rij2 * rik2 - dot**2)) * angular_base))
                ! write(*,*) angular_base
                ! Part of the derivative of the angular basis functions wrt atom j (dim(3))
                d_angular_d_j = c - b + dot * ((b - a) * invrij2)
                ! Part of the derivative of the angular basis functions wrt atom k (dim(3))
                d_angular_d_k = a - b + dot * ((b - c) * invrik2)
                ! Part of the derivative of the angular basis functions wrt atom i (dim(3))
                d_angular_d_i = - (d_angular_d_j + d_angular_d_k)
                ! Part of the derivative of the radial basis functions wrt coordinates (dim(nbasis3))
                ! including decay
                d_radial = radial * eta3 * (0.5d0 * (rij+rik) - Rs3) * rdecay(i,j) * rdecay(i,k)
                ! Part of the derivative of the radial basis functions wrt atom j (dim(3))
                d_radial_d_j = (b - a) * invrij
                ! Part of the derivative of the radial basis functions wrt atom k (dim(3))
                d_radial_d_k = (b - c) * invrik
                ! Part of the derivative of the radial basis functions wrt atom i (dim(3))
                d_radial_d_i = - (d_radial_d_j + d_radial_d_k)
                ! Part of the derivative of the i,j decay functions wrt coordinates (dim(3))
                d_ijdecay = - pi * (b - a) * sin(pi * rij * invcut) * 0.5d0 * invrij * invcut
                ! Part of the derivative of the i,k decay functions wrt coordinates (dim(3))
                d_ikdecay = - pi * (b - c) * sin(pi * rik * invcut) * 0.5d0 * invrik * invcut

                ! Get index of where the contributions of atoms i,j,k should be added
                s = nbasis3 * nabasis * (-(p * (p + 1))/2 + q + nelements * p) + 1
                do l = 1, nbasis3
                    ! Get index of where the contributions of atoms i,j,k should be added
                    z = s + (l-1) * nabasis
                    ! Add the contributions for atoms i,j,k
                    atom_rep(z:z + nabasis - 1) = atom_rep(z:z + nabasis - 1) + angular * radial(l) * rdecay(i,j) * rdecay(i,k)
                    do t = 1, 3
                        ! Add up all gradient contributions wrt atom i
                        atom_grad(z:z + nabasis - 1, i, t) = atom_grad(z:z + nabasis - 1, i, t) + &
                            & d_angular * d_angular_d_i(t) * radial(l) + &
                            & angular * d_radial(l) * d_radial_d_i(t) + &
                            & angular * radial(l) * (d_ijdecay(t) * rdecay(i,k) + rdecay(i,j) * d_ikdecay(t))
                        ! Add up all gradient contributions wrt atom j
                        atom_grad(z:z + nabasis - 1, j, t) = atom_grad(z:z + nabasis - 1, j, t) + &
                            & d_angular * d_angular_d_j(t) * radial(l) + &
                            & angular * d_radial(l) * d_radial_d_j(t) - &
                            & angular * radial(l) * d_ijdecay(t) * rdecay(i,k)
                        ! Add up all gradient contributions wrt atom k
                        atom_grad(z:z + nabasis - 1, k, t) = atom_grad(z:z + nabasis - 1, k, t) + &
                            & d_angular * d_angular_d_k(t) * radial(l) + &
                            & angular * d_radial(l) * d_radial_d_k(t) - &
                            & angular * radial(l) * rdecay(i,j) * d_ikdecay(t)
                    enddo
                enddo
            enddo
        enddo
        rep(i, twobody_size + 1:) = atom_rep
        grad(i, twobody_size + 1:,:,:) = atom_grad
    enddo
    !$OMP END PARALLEL DO


    deallocate(rdecay)
    deallocate(element_types)
    deallocate(distance_matrix)
    deallocate(inv_distance_matrix)
    deallocate(sq_distance_matrix)
    deallocate(inv_sq_distance_matrix)
    deallocate(atom_rep)
    deallocate(atom_grad)
    deallocate(a)
    deallocate(b)
    deallocate(c)
    deallocate(radial)
    deallocate(angular_base)
    deallocate(angular)
    deallocate(d_angular)
    deallocate(d_angular_d_i)
    deallocate(d_angular_d_j)
    deallocate(d_angular_d_k)
    deallocate(d_radial)
    deallocate(d_radial_d_i)
    deallocate(d_radial_d_j)
    deallocate(d_radial_d_k)
    deallocate(d_ijdecay)
    deallocate(d_ikdecay)


end subroutine fgenerate_acsf_and_gradients


subroutine fgenerate_fchl_acsf(coordinates, nuclear_charges, elements, &
                          & Rs2, Rs3, Ts, eta2, eta3, zeta, rcut, acut, natoms, rep_size, &
                          & two_body_decay, three_body_decay, three_body_weight, rep)

    use acsf_utils, only: decay, calc_angle, calc_cos_angle

    implicit none

    double precision, intent(in), dimension(:, :) :: coordinates
    integer, intent(in), dimension(:) :: nuclear_charges
    integer, intent(in), dimension(:) :: elements
    double precision, intent(in), dimension(:) :: Rs2
    double precision, intent(in), dimension(:) :: Rs3
    double precision, intent(in), dimension(:) :: Ts
    double precision, intent(in) :: eta2
    double precision, intent(in) :: eta3
    double precision, intent(in) :: zeta
    double precision, intent(in) :: rcut
    double precision, intent(in) :: acut
    integer, intent(in) :: natoms
    integer, intent(in) :: rep_size
    double precision, intent(in) :: two_body_decay
    double precision, intent(in) :: three_body_decay
    double precision, intent(in) :: three_body_weight

    double precision, intent(out), dimension(natoms, rep_size) :: rep

    integer :: i, j, k, l, n, m, o, p, q, s, z, nelements, nbasis2, nbasis3, nabasis
    integer, allocatable, dimension(:) :: element_types
    double precision :: rij, rik, angle, cos_1, cos_2, cos_3, invcut
    ! double precision :: angle_1, angle_2, angle_3
    double precision, allocatable, dimension(:) :: radial, angular, a, b, c
    double precision, allocatable, dimension(:, :) :: distance_matrix, rdecay, rep3

    double precision :: mu, sigma, ksi3

    double precision, parameter :: pi = 4.0d0 * atan(1.0d0)


    if (natoms /= size(nuclear_charges, dim=1)) then
        write(*,*) "ERROR: Atom Centered Symmetry Functions creation"
        write(*,*) natoms, "coordinates, but", &
            & size(nuclear_charges, dim=1), "atom_types!"
        stop
    endif


    ! number of element types
    nelements = size(elements)
    ! Allocate temporary
    allocate(element_types(natoms))

    ! Store element index of every atom
    ! !$OMP PARALLEL DO
    do i = 1, natoms
        do j = 1, nelements
            if (nuclear_charges(i) .eq. elements(j)) then
                element_types(i) = j
                continue
            endif
        enddo
    enddo
    ! !$OMP END PARALLEL DO


    ! Get distance matrix
    ! Allocate temporary
    allocate(distance_matrix(natoms, natoms))
    distance_matrix = 0.0d0


    !  !$OMP PARALLEL DO PRIVATE(rij)
    do i = 1, natoms
        do j = i+1, natoms
            rij = norm2(coordinates(j,:) - coordinates(i,:))
            distance_matrix(i, j) = rij
            distance_matrix(j, i) = rij
        enddo
    enddo
    ! !$OMP END PARALLEL DO

    ! number of basis functions in the two body term
    nbasis2 = size(Rs2)

    ! Inverse of the two body cutoff
    invcut = 1.0d0 / rcut

    ! pre-calculate the radial decay in the two body terms
    rdecay = decay(distance_matrix, invcut, natoms)

    ! Allocate temporary
    allocate(radial(nbasis2))

    radial = 0.0d0
    ! !$OMP PARALLEL DO PRIVATE(n,m,rij,radial) REDUCTION(+:rep)
    do i = 1, natoms
        ! index of the element of atom i
        m = element_types(i)
        do j = i + 1, natoms
            ! index of the element of atom j
            n = element_types(j)
            ! distance between atoms i and j
            rij = distance_matrix(i,j)
            if (rij <= rcut) then

                ! two body term of the representation
                mu    = log(rij / sqrt(1.0d0 + eta2  / rij**2))
                sigma = sqrt(log(1.0d0 + eta2  / rij**2))
                radial(:) = 0.0d0

                do k = 1, nbasis2
                   radial(k) = 1.0d0/(sigma* sqrt(2.0d0*pi) * Rs2(k)) * rdecay(i,j) &
                              & * exp( - (log(Rs2(k)) - mu)**2 / (2.0d0 * sigma**2) ) / rij**two_body_decay
                enddo

                rep(i, (n-1)*nbasis2 + 1:n*nbasis2) = rep(i, (n-1)*nbasis2 + 1:n*nbasis2) + radial
                rep(j, (m-1)*nbasis2 + 1:m*nbasis2) = rep(j, (m-1)*nbasis2 + 1:m*nbasis2) + radial
            endif
        enddo
    enddo
    ! !$OMP END PARALLEL DO

    deallocate(radial)

    ! number of radial basis functions in the three body term
    nbasis3 = size(Rs3)
    ! number of radial basis functions in the three body term
    nabasis = size(Ts)

    ! Inverse of the three body cutoff
    invcut = 1.0d0 / acut
    ! pre-calculate the radial decay in the three body terms
    rdecay = decay(distance_matrix, invcut, natoms)

    ! Allocate temporary
    allocate(rep3(natoms,rep_size))
    allocate(a(3))
    allocate(b(3))
    allocate(c(3))
    allocate(radial(nbasis3))
    allocate(angular(nabasis))

    rep3 = 0.0d0

    ! This could probably be done more efficiently if it's a bottleneck
    ! Also the order is a bit wobbly compared to the tensorflow implementation
    ! !$OMP PARALLEL DO PRIVATE(rij, n, rik, m, a, b, c, angle, radial, angular, &
    ! !$OMP cos_1, cos_2, cos_3, mu, sigma, o, ksi3, &
    ! !$OMP p, q, s, z) REDUCTION(+:rep3) COLLAPSE(2) SCHEDULE(dynamic)
    do i = 1, natoms
        do j = 1, natoms - 1
            if (i .eq. j) cycle
            ! distance between atoms i and j
            rij = distance_matrix(i,j)
            if (rij > acut)  cycle
            ! index of the element of atom j
            n = element_types(j)
            do k = j + 1, natoms
                if (i .eq. k) cycle
                if (j .eq. k) cycle
                ! distance between atoms i and k
                rik = distance_matrix(i,k)
                if (rik > acut) cycle
                ! index of the element of atom k
                m = element_types(k)
                ! coordinates of atoms j, i, k
                a = coordinates(j,:)
                b = coordinates(i,:)
                c = coordinates(k,:)
                ! angle between atoms i, j and k centered on i
                angle   = calc_angle(a,b,c)
                cos_1 = calc_cos_angle(a,b,c)
                cos_2 = calc_cos_angle(a,c,b)
                cos_3 = calc_cos_angle(b,a,c)

                ! The radial part of the three body terms including decay
                radial = exp(-eta3*(0.5d0 * (rij+rik) - Rs3)**2) * rdecay(i,j) * rdecay(i,k)

                ksi3 = (1.0d0 + 3.0d0 * cos_1 * cos_2 * cos_3) &
                     & / (distance_matrix(i,k) * distance_matrix(i,j) * distance_matrix(j,k) &
                 & )**three_body_decay * three_body_weight

                angular = 0.0d0
                do l = 1, nabasis/2

                    o = l*2-1
                    angular(2*l-1) = angular(2*l-1) + 2*cos(o * angle) &
                        & * exp(-(zeta * o)**2 /2)

                    angular(2*l) = angular(2*l) + 2*sin(o * angle) &
                        & * exp(-(zeta * o)**2 /2)

                enddo

                ! The lowest of the element indices for atoms j and k
                p = min(n,m) - 1
                ! The highest of the element indices for atoms j and k
                q = max(n,m) - 1
                ! calculate the indices that the three body terms should be added to
                s = nelements * nbasis2 + nbasis3 * nabasis * (-(p * (p + 1))/2 + q + nelements * p) + 1

                do l = 1, nbasis3
                    ! calculate the indices that the three body terms should be added to
                    z = s + (l-1) * nabasis
                    ! Add the contributions from atoms i,j and k
                    rep3(i, z:z + nabasis - 1) = rep3(i, z:z + nabasis - 1) + angular * radial(l) * ksi3
                enddo
            enddo
        enddo
    enddo
    ! !$OMP END PARALLEL DO

    rep = rep + rep3

    deallocate(element_types)
    deallocate(rdecay)
    deallocate(distance_matrix)
    deallocate(rep3)
    deallocate(a)
    deallocate(b)
    deallocate(c)
    deallocate(radial)
    deallocate(angular)

end subroutine fgenerate_fchl_acsf

subroutine fgenerate_fchl_acsf_and_gradients(coordinates, nuclear_charges, elements, &
                    & Rs2, Rs3, Ts, eta2, eta3, zeta, rcut, acut, natoms, rep_size, &
                    & two_body_decay, three_body_decay, three_body_weight, rep, grad)

    use acsf_utils, only: decay, calc_angle, calc_cos_angle

    implicit none

    double precision, intent(in), dimension(:, :) :: coordinates
    integer, intent(in), dimension(:) :: nuclear_charges
    integer, intent(in), dimension(:) :: elements
    double precision, intent(in), dimension(:) :: Rs2
    double precision, intent(in), dimension(:) :: Rs3
    double precision, intent(in), dimension(:) :: Ts
    double precision, intent(in) :: eta2
    double precision, intent(in) :: eta3
    double precision, intent(in) :: zeta
    double precision, intent(in) :: rcut
    double precision, intent(in) :: acut

    double precision, intent(in) :: two_body_decay
    double precision, intent(in) :: three_body_decay
    double precision, intent(in) :: three_body_weight

    double precision :: mu, sigma, dx, exp_s2, scaling, dscal, ddecay
    double precision :: cos_i, cos_j, cos_k
    double precision, allocatable, dimension(:) :: exp_ln
    double precision, allocatable, dimension(:) :: log_Rs2

    integer, intent(in) :: natoms
    integer, intent(in) :: rep_size
    double precision, intent(out), dimension(natoms, rep_size) :: rep
    double precision, intent(out), dimension(natoms, rep_size, natoms, 3) :: grad

    integer :: i, j, k, l, m, n,  p, q, s, t, z, nelements, nbasis2, nbasis3, nabasis, twobody_size
    integer, allocatable, dimension(:) :: element_types
    double precision :: rij, rik, angle, dot, rij2, rik2, invrij, invrik, invrij2, invrik2, invcut
    double precision, allocatable, dimension(:) :: radial_base, radial, angular, a, b, c, atom_rep
    double precision, allocatable, dimension(:) :: angular_base, d_radial, d_radial_d_i
    double precision, allocatable, dimension(:) :: d_radial_d_j, d_radial_d_k, d_ijdecay, d_ikdecay
    double precision, allocatable, dimension(:) :: d_angular, part, radial_part
    double precision, allocatable, dimension(:) :: d_angular_d_i, d_angular_d_j, d_angular_d_k
    double precision, allocatable, dimension(:, :) :: distance_matrix, rdecay, sq_distance_matrix
    double precision, allocatable, dimension(:, :) :: inv_distance_matrix, inv_sq_distance_matrix
    double precision, allocatable, dimension(:, :, :) :: atom_grad

    double precision :: atm, atm_i, atm_j, atm_k
    double precision :: invrjk, invr_atm, vi, vj, vk
    double precision, allocatable, dimension(:) :: d_atm_i, d_atm_j, d_atm_k
    double precision, allocatable, dimension(:) :: d_atm_ii, d_atm_ji, d_atm_ki
    double precision, allocatable, dimension(:) :: d_atm_ij, d_atm_jj, d_atm_kj
    double precision, allocatable, dimension(:) :: d_atm_ik, d_atm_jk, d_atm_kk
    double precision, allocatable, dimension(:) :: d_atm_i2, d_atm_j2, d_atm_k2
    double precision, allocatable, dimension(:) :: d_atm_i3, d_atm_j3, d_atm_k3
    double precision, allocatable, dimension(:) :: d_atm_extra_i, d_atm_extra_j, d_atm_extra_k

    double precision, parameter :: pi = 4.0d0 * atan(1.0d0)

    if (natoms /= size(nuclear_charges, dim=1)) then
        write(*,*) "ERROR: Atom Centered Symmetry Functions creation"
        write(*,*) natoms, "coordinates, but", &
            & size(nuclear_charges, dim=1), "atom_types!"
        stop
    endif


    ! Number of unique elements
    nelements = size(elements)
    ! Allocate temporary
    allocate(element_types(natoms))

    ! Store element index of every atom
    ! !$OMP PARALLEL DO
    do i = 1, natoms
        do j = 1, nelements
            if (nuclear_charges(i) .eq. elements(j)) then
                element_types(i) = j
                continue
            endif
        enddo
    enddo
    ! !$OMP END PARALLEL DO



    ! Get distance matrix
    ! Allocate temporary
    allocate(distance_matrix(natoms, natoms))
    allocate(sq_distance_matrix(natoms, natoms))
    allocate(inv_distance_matrix(natoms, natoms))
    allocate(inv_sq_distance_matrix(natoms, natoms))
    distance_matrix = 0.0d0
    sq_distance_matrix = 0.0d0
    inv_distance_matrix = 0.0d0
    inv_sq_distance_matrix = 0.0d0


    ! !$OMP PARALLEL DO PRIVATE(rij,rij2,invrij,invrij2) SCHEDULE(dynamic)
    do i = 1, natoms
        do j = i+1, natoms
            rij = norm2(coordinates(j,:) - coordinates(i,:))
            distance_matrix(i, j) = rij
            distance_matrix(j, i) = rij
            rij2 = rij * rij
            sq_distance_matrix(i, j) = rij2
            sq_distance_matrix(j, i) = rij2
            invrij = 1.0d0 / rij
            inv_distance_matrix(i, j) = invrij
            inv_distance_matrix(j, i) = invrij
            invrij2 = invrij * invrij
            inv_sq_distance_matrix(i, j) = invrij2
            inv_sq_distance_matrix(j, i) = invrij2
        enddo
    enddo
    ! !$OMP END PARALLEL DO


    ! Number of two body basis functions
    nbasis2 = size(Rs2)

    ! Inverse of the two body cutoff distance
    invcut = 1.0d0 / rcut
    ! Pre-calculate the two body decay
    rdecay = decay(distance_matrix, invcut, natoms)

    ! Allocate temporary
    allocate(radial_base(nbasis2))
    allocate(radial(nbasis2))
    allocate(radial_part(nbasis2))
    allocate(part(nbasis2))
    allocate(exp_ln(nbasis2))
    allocate(log_Rs2(nbasis2))

    grad =0.0d0
    rep = 0.0d0

    log_Rs2(:) = log(Rs2(:))

    ! !$OMP PARALLEL DO PRIVATE(m,n,rij,invrij,radial_base,radial,radial_part,part) REDUCTION(+:rep,grad) &
    ! !$OMP SCHEDULE(dynamic)
    do i = 1, natoms
        ! The element index of atom i
        m = element_types(i)
        do j = i + 1, natoms
            ! The element index of atom j
            n = element_types(j)
            ! Distance between atoms i and j
            rij = distance_matrix(i,j)
            if (rij <= rcut) then
                invrij = inv_distance_matrix(i,j)

                mu    = log(rij / sqrt(1.0d0 + eta2  * inv_sq_distance_matrix(i, j)))
                sigma = sqrt(log(1.0d0 + eta2  * inv_sq_distance_matrix(i, j)))
                exp_s2 = exp(sigma**2)
                exp_ln = exp(-(log_Rs2(:) - mu)**2 / sigma**2 * 0.5d0) * sqrt(2.0d0)

                scaling = 1.0d0 / rij**two_body_decay


                radial_base(:) = 1.0d0/(sigma* sqrt(2.0d0*pi) * Rs2(:)) * exp(-(log_Rs2(:) - mu)**2 / (2.0d0 * sigma**2))

                radial(:) = radial_base(:) * scaling * rdecay(i,j)

                rep(i, (n-1)*nbasis2 + 1:n*nbasis2) = rep(i, (n-1)*nbasis2 + 1:n*nbasis2) + radial
                rep(j, (m-1)*nbasis2 + 1:m*nbasis2) = rep(j, (m-1)*nbasis2 + 1:m*nbasis2) + radial


                do k = 1, 3

                    dx = -(coordinates(i,k) - coordinates(j,k))

                    part(:) = ((log_Rs2(:) - mu) * (-dx *(rij**2 * exp_s2 + eta2) / (rij * sqrt(exp_s2))**3) &
                        &* sqrt(exp_s2) / (sigma**2 * rij) + (log_Rs2(:) - mu) ** 2 * eta2 * dx / &
                        &(sigma**4 * rij**4 * exp_s2)) * exp_ln / (Rs2(:) * sigma  * sqrt(pi) * 2) &
                        &- exp_ln  * eta2 * dx / (Rs2(:) * sigma**3 *sqrt(pi) * rij**4 * exp_s2 * 2.0d0)

                    dscal = two_body_decay * dx / rij**(two_body_decay+2.0d0)
                    ddecay = dx * 0.5d0 * pi * sin(pi*rij * invcut) * invcut * invrij

                    part(:) = part(:) * scaling * rdecay(i,j) + radial_base(:) * dscal * rdecay(i,j) &
                        & + radial_base(:) * scaling * ddecay

                    ! The gradients wrt coordinates
                    grad(i, (n-1)*nbasis2 + 1:n*nbasis2, i, k) = grad(i, (n-1)*nbasis2 + 1:n*nbasis2, i, k) + part
                    grad(i, (n-1)*nbasis2 + 1:n*nbasis2, j, k) = grad(i, (n-1)*nbasis2 + 1:n*nbasis2, j, k) - part
                    grad(j, (m-1)*nbasis2 + 1:m*nbasis2, j, k) = grad(j, (m-1)*nbasis2 + 1:m*nbasis2, j, k) - part
                    grad(j, (m-1)*nbasis2 + 1:m*nbasis2, i, k) = grad(j, (m-1)*nbasis2 + 1:m*nbasis2, i, k) + part

                enddo
            endif
        enddo
    enddo
    ! !$OMP END PARALLEL DO

    deallocate(radial_base)
    deallocate(radial)
    deallocate(radial_part)
    deallocate(part)


    ! Number of radial basis functions in the three body term
    nbasis3 = size(Rs3)
    ! Number of angular basis functions in the three body term
    nabasis = size(Ts)
    ! Size of two body terms
    twobody_size = nelements * nbasis2

    ! Inverse of the three body cutoff distance
    invcut = 1.0d0 / acut
    ! Pre-calculate the three body decay
    rdecay = decay(distance_matrix, invcut, natoms)

    ! Allocate temporary
    allocate(atom_rep(rep_size - twobody_size))
    allocate(atom_grad(rep_size - twobody_size, natoms, 3))
    allocate(a(3))
    allocate(b(3))
    allocate(c(3))
    allocate(radial(nbasis3))
    allocate(radial_base(nbasis3))
    allocate(angular_base(nabasis))
    allocate(angular(nabasis))
    allocate(d_angular(nabasis))
    allocate(d_angular_d_i(3))
    allocate(d_angular_d_j(3))
    allocate(d_angular_d_k(3))
    allocate(d_radial(nbasis3))
    allocate(d_radial_d_i(3))
    allocate(d_radial_d_j(3))
    allocate(d_radial_d_k(3))
    allocate(d_ijdecay(3))
    allocate(d_ikdecay(3))

    allocate(d_atm_i(3))
    allocate(d_atm_j(3))
    allocate(d_atm_k(3))
    allocate(d_atm_ii(3))
    allocate(d_atm_ij(3))
    allocate(d_atm_ik(3))
    allocate(d_atm_ji(3))
    allocate(d_atm_jj(3))
    allocate(d_atm_jk(3))
    allocate(d_atm_ki(3))
    allocate(d_atm_kj(3))
    allocate(d_atm_kk(3))
    allocate(d_atm_i2(3))
    allocate(d_atm_j2(3))
    allocate(d_atm_k2(3))
    allocate(d_atm_i3(3))
    allocate(d_atm_j3(3))
    allocate(d_atm_k3(3))
    allocate(d_atm_extra_i(3))
    allocate(d_atm_extra_j(3))
    allocate(d_atm_extra_k(3))

    ! ! This could probably be done more efficiently if it's a bottleneck
    ! ! The order is a bit wobbly compared to the tensorflow implementation
    ! !$OMP PARALLEL DO PRIVATE(atom_rep,atom_grad,a,b,c,radial,angular_base, &
    ! !$OMP angular,d_angular,rij,n,rij2,invrij,invrij2,d_angular_d_i, &
    ! !$OMP d_angular_d_j,d_angular_d_k,rik,m,rik2,invrik,invrik2,angle, &
    ! !$OMP p,q,dot,d_radial,d_radial_d_i,d_radial_d_j,d_radial_d_k,s,z, &
    ! !$OMP d_ijdecay,d_ikdecay) SCHEDULE(dynamic)
    do i = 1, natoms
        atom_rep = 0.0d0
        atom_grad = 0.0d0
        do j = 1, natoms - 1
            if (i .eq. j) cycle
            ! distance between atom i and j
            rij = distance_matrix(i,j)
            if (rij > acut) cycle
            ! index of the element of atom j
            n = element_types(j)
            ! squared distance between atom i and j
            rij2 = sq_distance_matrix(i,j)
            ! inverse distance between atom i and j
            invrij = inv_distance_matrix(i,j)
            ! inverse squared distance between atom i and j
            invrij2 = inv_sq_distance_matrix(i,j)
            do k = j + 1, natoms
                if (i .eq. k) cycle
                ! distance between atom i and k
                rik = distance_matrix(i,k)
                if (rik > acut) cycle
                ! index of the element of atom k
                m = element_types(k)
                ! squared distance between atom i and k
                rik2 = sq_distance_matrix(i,k)
                ! inverse distance between atom i and k
                invrik = inv_distance_matrix(i,k)
                ! inverse distance between atom j and k
                invrjk = inv_distance_matrix(j,k)
                ! inverse squared distance between atom i and k
                invrik2 = inv_sq_distance_matrix(i,k)
                ! coordinates of atoms j, i, k
                a = coordinates(j,:)
                b = coordinates(i,:)
                c = coordinates(k,:)
                ! angle between atom i, j and k, centered on i
                angle = calc_angle(a,b,c)
                cos_i = calc_cos_angle(a,b,c)
                cos_k = calc_cos_angle(a,c,b)
                cos_j = calc_cos_angle(b,a,c)

                ! part of the radial part of the 3body terms
                radial_base(:) = exp(-eta3*(0.5d0 * (rij+rik) - Rs3(:))**2)
                radial(:) = radial_base(:) ! * scaling

                p = min(n,m) - 1
                ! the highest index of the elements of j,k
                q = max(n,m) - 1
                ! Dot product between the vectors connecting atom i,j and i,k
                dot = dot_product(a-b,c-b)

                angular(1)   =  exp(-(zeta**2)*0.5d0) * 2 * cos(angle)
                angular(2)   =  exp(-(zeta**2)*0.5d0) * 2 * sin(angle)

                d_angular(1) =  exp(-(zeta**2)*0.5d0) * 2 * sin(angle) / sqrt(max(1d-10, rij2 * rik2 - dot**2))
                d_angular(2) = -exp(-(zeta**2)*0.5d0) * 2 * cos(angle) / sqrt(max(1d-10, rij2 * rik2 - dot**2))

                ! Part of the derivative of the angular basis functions wrt atom j (dim(3))
                d_angular_d_j = c - b + dot * ((b - a) * invrij2)
                ! Part of the derivative of the angular basis functions wrt atom k (dim(3))
                d_angular_d_k = a - b + dot * ((b - c) * invrik2)
                ! Part of the derivative of the angular basis functions wrt atom i (dim(3))
                d_angular_d_i = - (d_angular_d_j + d_angular_d_k)

                ! Part of the derivative of the radial basis functions wrt coordinates (dim(nbasis3))
                ! including decay
                d_radial = radial * eta3 * (0.5d0 * (rij+rik) - Rs3) ! * rdecay(i,j) * rdecay(i,k)
                ! Part of the derivative of the radial basis functions wrt atom j (dim(3))
                d_radial_d_j = (b - a) * invrij
                ! Part of the derivative of the radial basis functions wrt atom k (dim(3))
                d_radial_d_k = (b - c) * invrik
                ! Part of the derivative of the radial basis functions wrt atom i (dim(3))
                d_radial_d_i = - (d_radial_d_j + d_radial_d_k)

                ! Part of the derivative of the i,j decay functions wrt coordinates (dim(3))
                d_ijdecay = - pi * (b - a) * sin(pi * rij * invcut) * 0.5d0 * invrij * invcut
                ! Part of the derivative of the i,k decay functions wrt coordinates (dim(3))
                d_ikdecay = - pi * (b - c) * sin(pi * rik * invcut) * 0.5d0 * invrik * invcut

                invr_atm = (invrij * invrjk *invrik)**three_body_decay

                ! Axilrod-Teller-Muto term
                atm = (1.0d0 + 3.0d0 * cos_i * cos_j * cos_k) * invr_atm * three_body_weight

                atm_i = (3.0d0 * cos_j * cos_k) * invr_atm * invrij * invrik
                atm_j = (3.0d0 * cos_k * cos_i) * invr_atm * invrij * invrjk
                atm_k = (3.0d0 * cos_i * cos_j) * invr_atm * invrjk * invrik

                vi = dot_product(a-b,c-b)
                vj = dot_product(c-a,b-a)
                vk = dot_product(b-c,a-c)

                d_atm_ii(:) = 2 * b - a - c - vi * ((b-a)*invrij**2 + (b-c)*invrik**2)
                d_atm_ij(:) = c - a - vj * (b-a)*invrij**2
                d_atm_ik(:) = a - c - vk * (b-c)*invrik**2

                d_atm_ji(:) = c - b - vi * (a-b)*invrij**2
                d_atm_jj(:) = 2 * a - b - c - vj * ((a-b)*invrij**2 + (a-c)*invrjk**2)
                d_atm_jk(:) = b - c - vk * (a-c)*invrjk**2

                d_atm_ki(:) = a - b - vi * (c-b)*invrik**2
                d_atm_kj(:) = b - a - vj * (c-a)*invrjk**2
                d_atm_kk(:) = 2 * c - a - b - vk * ((c-a)*invrjk**2 + (c-b)*invrik**2)

                d_atm_extra_i(:) = ((a-b)*invrij**2 + (c-b)*invrik**2) * atm * three_body_decay / three_body_weight
                d_atm_extra_j(:) = ((b-a)*invrij**2 + (c-a)*invrjk**2) * atm * three_body_decay / three_body_weight
                d_atm_extra_k(:) = ((a-c)*invrjk**2 + (b-c)*invrik**2) * atm * three_body_decay / three_body_weight

                ! Get index of where the contributions of atoms i,j,k should be added
                s = nbasis3 * nabasis * (-(p * (p + 1))/2 + q + nelements * p) + 1

                do l = 1, nbasis3

                    ! Get index of where the contributions of atoms i,j,k should be added
                    z = s + (l-1) * nabasis

                    ! Add the contributions for atoms i,j,k
                    atom_rep(z:z + nabasis - 1) = atom_rep(z:z + nabasis - 1) &
                        & + angular * radial(l) * atm * rdecay(i,j) * rdecay(i,k)

                    do t = 1, 3

                        ! Add up all gradient contributions wrt atom i
                        atom_grad(z:z + nabasis - 1, i, t) = atom_grad(z:z + nabasis - 1, i, t) + &
                            & d_angular * d_angular_d_i(t) * radial(l) * atm * rdecay(i,j) * rdecay(i,k) + &
                            & angular * d_radial(l) * d_radial_d_i(t) * atm * rdecay(i,j) * rdecay(i,k) + &
                            & angular * radial(l) * (atm_i * d_atm_ii(t) + atm_j * d_atm_ij(t) &
                            & + atm_k * d_atm_ik(t) + d_atm_extra_i(t)) * three_body_weight * rdecay(i,j) * rdecay(i,k) + &
                            & angular * radial(l) * (d_ijdecay(t) * rdecay(i,k) + rdecay(i,j) * d_ikdecay(t)) * atm

                        ! Add up all gradient contributions wrt atom j
                        atom_grad(z:z + nabasis - 1, j, t) = atom_grad(z:z + nabasis - 1, j, t) + &
                            & d_angular * d_angular_d_j(t) * radial(l) * atm * rdecay(i,j) * rdecay(i,k) + &
                            & angular * d_radial(l) * d_radial_d_j(t) * atm * rdecay(i,j) * rdecay(i,k) + &
                            & angular * radial(l) * (atm_i * d_atm_ji(t) + atm_j * d_atm_jj(t) &
                            & + atm_k * d_atm_jk(t) + d_atm_extra_j(t)) * three_body_weight * rdecay(i,j) * rdecay(i,k) - &
                            & angular * radial(l) * d_ijdecay(t) * rdecay(i,k) * atm

                        ! Add up all gradient contributions wrt atom k
                        atom_grad(z:z + nabasis - 1, k, t) = atom_grad(z:z + nabasis - 1, k, t) + &
                            & d_angular * d_angular_d_k(t) * radial(l) * atm * rdecay(i,j) * rdecay(i,k) + &
                            & angular * d_radial(l) * d_radial_d_k(t) * atm * rdecay(i,j) * rdecay(i,k) + &
                            & angular * radial(l) * (atm_i * d_atm_ki(t) + atm_j * d_atm_kj(t) &
                            & + atm_k * d_atm_kk(t) + d_atm_extra_k(t)) * three_body_weight * rdecay(i,j) * rdecay(i,k) - &
                            & angular * radial(l) * rdecay(i,j) * d_ikdecay(t) * atm

                    enddo
                enddo
            enddo
        enddo
        rep(i, twobody_size + 1:) = rep(i, twobody_size + 1:) + atom_rep
        grad(i, twobody_size + 1:,:,:) = grad(i, twobody_size + 1:,:,:) + atom_grad
    enddo
    ! !$OMP END PARALLEL DO

    deallocate(rdecay)
    deallocate(element_types)
    deallocate(distance_matrix)
    deallocate(inv_distance_matrix)
    deallocate(sq_distance_matrix)
    deallocate(inv_sq_distance_matrix)
    deallocate(atom_rep)
    deallocate(atom_grad)
    deallocate(a)
    deallocate(b)
    deallocate(c)
    deallocate(radial)
    deallocate(angular_base)
    deallocate(angular)
    deallocate(d_angular)
    deallocate(d_angular_d_i)
    deallocate(d_angular_d_j)
    deallocate(d_angular_d_k)
    deallocate(d_radial)
    deallocate(d_radial_d_i)
    deallocate(d_radial_d_j)
    deallocate(d_radial_d_k)
    deallocate(d_ijdecay)
    deallocate(d_ikdecay)


end subroutine fgenerate_fchl_acsf_and_gradients

module ffchl_kernel_types
   implicit none

   public

   ! define kernel enums
   integer, parameter :: GAUSSIAN = 1
   integer, parameter :: LINEAR = 2
   integer, parameter :: POLYNOMIAL = 3
   integer, parameter :: SIGMOID = 4
   integer, parameter :: MULTIQUADRATIC = 5
   integer, parameter :: INV_MULTIQUADRATIC = 6
   integer, parameter :: BESSEL = 7
   integer, parameter :: L2 = 8
   integer, parameter :: MATERN = 9
   integer, parameter :: CAUCHY = 10
   integer, parameter :: POLYNOMIAL2 = 11

end module ffchl_kernel_types

module representations

   implicit none

contains

   subroutine get_indices(natoms, nuclear_charges, type1, n, type1_indices)
      integer, intent(in) :: natoms
      integer, intent(in) :: type1
      integer, dimension(:), intent(in) :: nuclear_charges

      integer, intent(inout) :: n
      integer, dimension(:), intent(out) :: type1_indices
      integer :: j

      do j = 1, natoms
         if (nuclear_charges(j) == type1) then
            n = n + 1
            type1_indices(n) = j
         end if
      end do

   end subroutine get_indices

end module representations

subroutine fgenerate_coulomb_matrix(atomic_charges, coordinates, nmax, cm)

   implicit none

   double precision, dimension(:), intent(in) :: atomic_charges
   double precision, dimension(:, :), intent(in) :: coordinates

   integer, intent(in) :: nmax

   double precision, dimension(((nmax + 1)*nmax)/2), intent(out):: cm

   double precision, allocatable, dimension(:) :: row_norms
   double precision :: pair_norm
   double precision :: huge_double

   integer, allocatable, dimension(:) :: sorted_atoms

   double precision, allocatable, dimension(:, :) :: pair_distance_matrix

   integer :: i, j, m, n, idx
   integer :: natoms

   if (size(coordinates, dim=1) /= size(atomic_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(atomic_charges, dim=1), "atom_types!"
      stop
   else
      natoms = size(atomic_charges, dim=1)
   end if

   ! Allocate temporary
   allocate (pair_distance_matrix(natoms, natoms))
   allocate (row_norms(natoms))
   allocate (sorted_atoms(natoms))

   huge_double = huge(row_norms(1))

   ! Calculate row-2-norms and store pair-distances in pair_distance_matrix
   row_norms = 0.0d0

   !$OMP PARALLEL DO PRIVATE(pair_norm) REDUCTION(+:row_norms)
   do i = 1, natoms
      pair_norm = 0.5d0*atomic_charges(i)**2.4d0
      row_norms(i) = row_norms(i) + pair_norm*pair_norm
      pair_distance_matrix(i, i) = pair_norm
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(pair_norm) REDUCTION(+:row_norms)
   do i = 1, natoms
      do j = i + 1, natoms
         pair_norm = atomic_charges(i)*atomic_charges(j) &
             & /sqrt(sum((coordinates(j, :) - coordinates(i, :))**2))

         pair_distance_matrix(i, j) = pair_norm
         pair_distance_matrix(j, i) = pair_norm
         pair_norm = pair_norm*pair_norm
         row_norms(j) = row_norms(j) + pair_norm
         row_norms(i) = row_norms(i) + pair_norm
      end do
   end do
   !$OMP END PARALLEL DO

   !Generate sorted list of atom ids by row_norms - not really (easily) parallelizable
   do i = 1, natoms
      j = minloc(row_norms, dim=1)
      sorted_atoms(natoms - i + 1) = j
      row_norms(j) = huge_double
   end do

   ! Fill coulomb matrix according to sorted row-2-norms
   cm = 0.0d0
   !$OMP PARALLEL DO PRIVATE(idx, i, j)
   do m = 1, natoms
      i = sorted_atoms(m)
      idx = (m*m + m)/2 - m
      do n = 1, m
         j = sorted_atoms(n)
         cm(idx + n) = pair_distance_matrix(i, j)
      end do
   end do
   !$OMP END PARALLEL DO

   ! Clean up
   deallocate (pair_distance_matrix)
   deallocate (row_norms)
   deallocate (sorted_atoms)
end subroutine fgenerate_coulomb_matrix

subroutine fgenerate_unsorted_coulomb_matrix(atomic_charges, coordinates, nmax, cm)

   implicit none

   double precision, dimension(:), intent(in) :: atomic_charges
   double precision, dimension(:, :), intent(in) :: coordinates

   integer, intent(in) :: nmax

   double precision, dimension(((nmax + 1)*nmax)/2), intent(out):: cm

   double precision :: pair_norm

   double precision, allocatable, dimension(:, :) :: pair_distance_matrix

   integer :: i, j, m, n, idx
   integer :: natoms

   if (size(coordinates, dim=1) /= size(atomic_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(atomic_charges, dim=1), "atom_types!"
      stop
   else
      natoms = size(atomic_charges, dim=1)
   end if

   ! Allocate temporary
   allocate (pair_distance_matrix(natoms, natoms))

   !$OMP PARALLEL DO PRIVATE(pair_norm)
   do i = 1, natoms
      pair_norm = 0.5d0*atomic_charges(i)**2.4d0
      pair_distance_matrix(i, i) = pair_norm
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(pair_norm)
   do i = 1, natoms
      do j = i + 1, natoms
         pair_norm = atomic_charges(i)*atomic_charges(j) &
             & /sqrt(sum((coordinates(j, :) - coordinates(i, :))**2))

         pair_distance_matrix(i, j) = pair_norm
         pair_distance_matrix(j, i) = pair_norm
      end do
   end do
   !$OMP END PARALLEL DO

   cm = 0.0d0
   !$OMP PARALLEL DO PRIVATE(idx)
   do m = 1, natoms
      idx = (m*m + m)/2 - m
      do n = 1, m
         cm(idx + n) = pair_distance_matrix(m, n)
      end do
   end do
   !$OMP END PARALLEL DO

   ! Clean up
   deallocate (pair_distance_matrix)

end subroutine fgenerate_unsorted_coulomb_matrix

subroutine fgenerate_local_coulomb_matrix(central_atom_indices, central_natoms, &
        & atomic_charges, coordinates, natoms, nmax, cent_cutoff, cent_decay, &
        & int_cutoff, int_decay, cm)

   implicit none

   integer, intent(in) :: central_natoms
   integer, dimension(:), intent(in) :: central_atom_indices
   double precision, dimension(:), intent(in) :: atomic_charges
   double precision, dimension(:, :), intent(in) :: coordinates
   integer, intent(in) :: natoms
   integer, intent(in) :: nmax
   double precision, intent(inout) :: cent_cutoff, cent_decay, int_cutoff, int_decay

   double precision, dimension(central_natoms, ((nmax + 1)*nmax)/2), intent(out):: cm

   integer :: idx

   double precision, allocatable, dimension(:, :) :: row_norms
   double precision, allocatable, dimension(:) :: row_norms_l
   double precision :: pair_norm
   double precision :: prefactor
   double precision :: norm
   double precision :: huge_double

   integer, allocatable, dimension(:, :) :: sorted_atoms_all
   integer, allocatable, dimension(:) :: cutoff_count

   double precision, allocatable, dimension(:, :, :) :: pair_distance_matrix
   double precision, allocatable, dimension(:, :) :: distance_matrix

   integer i, j, m, n, k, l

   double precision, parameter :: pi = 4.0d0*atan(1.0d0)

   if (size(coordinates, dim=1) /= size(atomic_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(atomic_charges, dim=1), "atom_types!"
      stop
   end if

   ! Allocate temporary
   allocate (distance_matrix(natoms, natoms))
   allocate (cutoff_count(natoms))

   huge_double = huge(distance_matrix(1, 1))

   if (cent_cutoff < 0) then
      cent_cutoff = huge_double
   end if

   if ((int_cutoff < 0) .OR. (int_cutoff > 2*cent_cutoff)) then
      int_cutoff = 2*cent_cutoff
   end if

   if (cent_decay < 0) then
      cent_decay = 0.0d0
   else if (cent_decay > cent_cutoff) then
      cent_decay = cent_cutoff
   end if

   if (int_decay < 0) then
      int_decay = 0.0d0
   else if (int_decay > int_cutoff) then
      int_decay = int_cutoff
   end if

   cutoff_count = 1

   !$OMP PARALLEL DO PRIVATE(norm) REDUCTION(+:cutoff_count)
   do i = 1, natoms
      distance_matrix(i, i) = 0.0d0
      do j = i + 1, natoms
         norm = sqrt(sum((coordinates(j, :) - coordinates(i, :))**2))
         distance_matrix(i, j) = norm
         distance_matrix(j, i) = norm
         if (norm < cent_cutoff) then
            cutoff_count(i) = cutoff_count(i) + 1
            cutoff_count(j) = cutoff_count(j) + 1
         end if
      end do
   end do
   !$OMP END PARALLEL DO

   do i = 1, central_natoms
      j = central_atom_indices(i)
      if (cutoff_count(j) > nmax) then
         write (*, *) "ERROR: Coulomb matrix generation"
         write (*, *) nmax, "size set, but", &
             & cutoff_count(j), "size needed!"
         stop
      end if
   end do

   ! Allocate temporary
   allocate (pair_distance_matrix(natoms, natoms, central_natoms))
   allocate (row_norms(natoms, central_natoms))
   allocate (row_norms_l(natoms))

   pair_distance_matrix = 0.0d0
   row_norms = 0.0d0

   !$OMP PARALLEL DO PRIVATE(pair_norm, prefactor, k, row_norms_l)
   do l = 1, central_natoms
      k = central_atom_indices(l)
      row_norms_l = 0.0d0
      do i = 1, natoms
         ! self interaction
         if (distance_matrix(i, k) > cent_cutoff) then
            cycle
         end if

         prefactor = 1.0d0
         if (distance_matrix(i, k) > cent_cutoff - cent_decay) then
            prefactor = 0.5d0*(cos(pi &
                                  & *(distance_matrix(i, k) - cent_cutoff + cent_decay)/cent_decay) + 1)
         end if

         pair_norm = prefactor*prefactor*0.5d0*atomic_charges(i)**2.4d0
         pair_distance_matrix(i, i, l) = pair_norm
         row_norms_l(i) = row_norms_l(i) + pair_norm*pair_norm

         do j = i + 1, natoms
            if (distance_matrix(j, k) > cent_cutoff) then
               cycle
            end if

            if (distance_matrix(i, j) > int_cutoff) then
               cycle
            end if

            pair_norm = prefactor*atomic_charges(i)*atomic_charges(j) &
                & /distance_matrix(j, i)

            if (distance_matrix(i, j) > int_cutoff - int_decay) then
               pair_norm = pair_norm*0.5d0*(cos(pi &
                                               & *(distance_matrix(i, j) - int_cutoff + int_decay)/int_decay) + 1)
            end if

            if (distance_matrix(j, k) > cent_cutoff - cent_decay) then
               pair_norm = pair_norm*0.5d0*(cos(pi &
                                               & *(distance_matrix(j, k) - cent_cutoff + cent_decay)/cent_decay) + 1)
            end if

            pair_distance_matrix(i, j, l) = pair_norm
            pair_distance_matrix(j, i, l) = pair_norm
            pair_norm = pair_norm*pair_norm
            row_norms_l(i) = row_norms_l(i) + pair_norm
            row_norms_l(j) = row_norms_l(j) + pair_norm
         end do
      end do
      row_norms(:, l) = row_norms_l
   end do
   !$OMP END PARALLEL DO

   ! Clean up
   deallocate (row_norms_l)

   ! Allocate temporary
   allocate (sorted_atoms_all(natoms, central_natoms))

   !$OMP PARALLEL DO PRIVATE(k)
   do l = 1, central_natoms
      k = central_atom_indices(l)
      row_norms(k, l) = huge_double
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(j,k)
   do l = 1, central_natoms
      k = central_atom_indices(l)
      do i = 1, cutoff_count(k)
         j = maxloc(row_norms(:, l), dim=1)
         sorted_atoms_all(i, l) = j
         row_norms(j, l) = 0.0d0
      end do
   end do
   !$OMP END PARALLEL DO

   ! Clean up
   deallocate (row_norms)

   ! Fill coulomb matrix according to sorted row-2-norms
   cm = 0.0d0

   !$OMP PARALLEL DO PRIVATE(i, j, k, idx)
   do l = 1, central_natoms
      k = central_atom_indices(l)
      do m = 1, cutoff_count(k)
         i = sorted_atoms_all(m, l)
         idx = (m*m + m)/2 - m
         do n = 1, m
            j = sorted_atoms_all(n, l)
            cm(l, idx + n) = pair_distance_matrix(i, j, l)
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   ! Clean up
   deallocate (sorted_atoms_all)
   deallocate (pair_distance_matrix)

end subroutine fgenerate_local_coulomb_matrix

subroutine fgenerate_atomic_coulomb_matrix(central_atom_indices, central_natoms, atomic_charges, &
        & coordinates, natoms, nmax, cent_cutoff, cent_decay, int_cutoff, int_decay, cm)

   implicit none

   integer, dimension(:), intent(in) :: central_atom_indices
   integer, intent(in) :: central_natoms
   double precision, dimension(:), intent(in) :: atomic_charges
   double precision, dimension(:, :), intent(in) :: coordinates
   integer, intent(in) :: natoms
   integer, intent(in) :: nmax
   double precision, intent(inout) :: cent_cutoff, cent_decay, int_cutoff, int_decay

   double precision, dimension(central_natoms, ((nmax + 1)*nmax)/2), intent(out):: cm

   integer :: idx

   double precision :: pair_norm
   double precision :: prefactor
   double precision :: norm
   double precision :: huge_double

   integer, allocatable, dimension(:, :) :: sorted_atoms_all
   integer, allocatable, dimension(:) :: cutoff_count

   double precision, allocatable, dimension(:, :) :: pair_distance_matrix
   double precision, allocatable, dimension(:, :) :: distance_matrix
   double precision, allocatable, dimension(:, :) :: distance_matrix_tmp

   integer i, j, m, n, k, l

   double precision, parameter :: pi = 4.0d0*atan(1.0d0)

   if (size(coordinates, dim=1) /= size(atomic_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(atomic_charges, dim=1), "atom_types!"
      stop
   end if

   ! Allocate temporary
   allocate (distance_matrix(natoms, natoms))
   allocate (cutoff_count(natoms))

   huge_double = huge(distance_matrix(1, 1))

   if (cent_cutoff < 0) then
      cent_cutoff = huge_double
   end if

   if ((int_cutoff < 0) .OR. (int_cutoff > 2*cent_cutoff)) then
      int_cutoff = 2*cent_cutoff
   end if

   if (cent_decay < 0) then
      cent_decay = 0.0d0
   else if (cent_decay > cent_cutoff) then
      cent_decay = cent_cutoff
   end if

   if (int_decay < 0) then
      int_decay = 0.0d0
   else if (int_decay > int_cutoff) then
      int_decay = int_cutoff
   end if

   cutoff_count = 1

   !$OMP PARALLEL DO PRIVATE(norm) REDUCTION(+:cutoff_count)
   do i = 1, natoms
      distance_matrix(i, i) = 0.0d0
      do j = i + 1, natoms
         norm = sqrt(sum((coordinates(j, :) - coordinates(i, :))**2))
         distance_matrix(i, j) = norm
         distance_matrix(j, i) = norm
         if (norm < cent_cutoff) then
            cutoff_count(i) = cutoff_count(i) + 1
            cutoff_count(j) = cutoff_count(j) + 1
         end if
      end do
   end do
   !$OMP END PARALLEL DO

   do i = 1, central_natoms
      k = central_atom_indices(i)
      if (cutoff_count(k) > nmax) then
         write (*, *) "ERROR: Coulomb matrix generation"
         write (*, *) nmax, "size set, but", &
             & cutoff_count(k), "size needed!"
         stop
      end if
   end do

   ! Allocate temporary
   allocate (pair_distance_matrix(natoms, natoms))

   pair_distance_matrix = 0.0d0

   !$OMP PARALLEL DO PRIVATE(pair_norm)
   do i = 1, natoms
      pair_distance_matrix(i, i) = 0.5d0*atomic_charges(i)**2.4d0
      do j = i + 1, natoms
         if (distance_matrix(j, i) > int_cutoff) then
            cycle
         end if
         pair_norm = atomic_charges(i)*atomic_charges(j) &
             & /distance_matrix(j, i)
         if (distance_matrix(j, i) > int_cutoff - int_decay) then
            pair_norm = pair_norm*0.5d0*(cos(pi &
                                            & *(distance_matrix(j, i) - int_cutoff + int_decay)/int_decay) + 1)
         end if

         pair_distance_matrix(i, j) = pair_norm
         pair_distance_matrix(j, i) = pair_norm
      end do
   end do
   !$OMP END PARALLEL DO

   ! Allocate temporary
   allocate (distance_matrix_tmp(natoms, natoms))
   allocate (sorted_atoms_all(natoms, central_natoms))

   distance_matrix_tmp = distance_matrix
   !Generate sorted list of atom ids by distance matrix
   !$OMP PARALLEL DO PRIVATE(j, k)
   do l = 1, central_natoms
      k = central_atom_indices(l)
      !$OMP CRITICAL
      do i = 1, cutoff_count(k)
         j = minloc(distance_matrix_tmp(:, k), dim=1)
         sorted_atoms_all(i, l) = j
         distance_matrix_tmp(j, k) = huge_double
      end do
      !$OMP END CRITICAL
   end do
   !$OMP END PARALLEL DO

   ! Clean up
   deallocate (distance_matrix_tmp)

   ! Fill coulomb matrix according to sorted distances
   cm = 0.0d0

   pair_norm = 0.0d0

   !$OMP PARALLEL DO PRIVATE(i, prefactor, idx, j, pair_norm, k)
   do l = 1, central_natoms
      k = central_atom_indices(l)
      do m = 1, cutoff_count(k)
         i = sorted_atoms_all(m, l)

         if (distance_matrix(i, k) > cent_cutoff) then
            cycle
         end if
         prefactor = 1.0d0
         if (distance_matrix(i, k) > cent_cutoff - cent_decay) then
            prefactor = 0.5d0*(cos(pi &
                & *(distance_matrix(i, k) - cent_cutoff + cent_decay) &
                & /cent_decay) + 1.0d0)
         end if

         idx = (m*m + m)/2 - m
         do n = 1, m
            j = sorted_atoms_all(n, l)

            pair_norm = prefactor*pair_distance_matrix(i, j)
            if (distance_matrix(j, k) > cent_cutoff - cent_decay) then
               pair_norm = pair_norm*0.5d0*(cos(pi &
                   & *(distance_matrix(j, k) - cent_cutoff + cent_decay) &
                   & /cent_decay) + 1)
            end if
            cm(l, idx + n) = pair_norm
         end do
      end do
   end do

   ! Clean up
   deallocate (distance_matrix)
   deallocate (pair_distance_matrix)
   deallocate (sorted_atoms_all)
   deallocate (cutoff_count)

end subroutine fgenerate_atomic_coulomb_matrix

subroutine fgenerate_eigenvalue_coulomb_matrix(atomic_charges, coordinates, nmax, sorted_eigenvalues)

   implicit none

   double precision, dimension(:), intent(in) :: atomic_charges
   double precision, dimension(:, :), intent(in) :: coordinates

   integer, intent(in) :: nmax

   double precision, dimension(nmax), intent(out) :: sorted_eigenvalues

   double precision :: pair_norm
   double precision :: huge_double

   double precision, allocatable, dimension(:, :) :: pair_distance_matrix

   double precision, allocatable, dimension(:) :: work
   double precision, allocatable, dimension(:) :: eigenvalues

   integer :: i, j, info, lwork
   integer :: natoms

   if (size(coordinates, dim=1) /= size(atomic_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(atomic_charges, dim=1), "atom_types!"
      stop
   else
      natoms = size(atomic_charges, dim=1)
   end if

   ! Allocate temporary
   allocate (pair_distance_matrix(nmax, nmax))

   huge_double = huge(pair_distance_matrix(1, 1))

   pair_distance_matrix(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(pair_norm)
   do i = 1, natoms
      pair_norm = 0.5d0*atomic_charges(i)**2.4d0
      pair_distance_matrix(i, i) = pair_norm
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(pair_norm)
   do i = 1, natoms
      do j = i + 1, natoms
         pair_norm = atomic_charges(i)*atomic_charges(j) &
             & /sqrt(sum((coordinates(j, :) - coordinates(i, :))**2))

         pair_distance_matrix(i, j) = pair_norm
      end do
   end do
   !$OMP END PARALLEL DO

   lwork = 4*nmax
   ! Allocate temporary
   allocate (work(lwork))
   allocate (eigenvalues(nmax))
   call dsyev("N", "U", nmax, pair_distance_matrix, nmax, eigenvalues, work, lwork, info)
   if (info > 0) then
      write (*, *) "WARNING: Eigenvalue routine DSYEV() exited with error code:", info
   end if

   ! Clean up
   deallocate (work)
   deallocate (pair_distance_matrix)

   !sort
   do i = 1, nmax
      j = minloc(eigenvalues, dim=1)
      sorted_eigenvalues(nmax - i + 1) = eigenvalues(j)
      eigenvalues(j) = huge_double
   end do

   ! Clean up
   deallocate (eigenvalues)

end subroutine fgenerate_eigenvalue_coulomb_matrix

subroutine fgenerate_bob(atomic_charges, coordinates, nuclear_charges, id, &
    & nmax, ncm, cm)

   use representations, only: get_indices
   implicit none

   double precision, dimension(:), intent(in) :: atomic_charges
   double precision, dimension(:, :), intent(in) :: coordinates
   integer, dimension(:), intent(in) :: nuclear_charges
   integer, dimension(:), intent(in) :: id
   integer, dimension(:), intent(in) :: nmax
   integer, intent(in) :: ncm

   double precision, dimension(ncm), intent(out):: cm

   integer :: n, i, j, k, l, idx1, idx2, nid, nbag
   integer :: natoms, natoms1, natoms2, type1, type2

   integer, allocatable, dimension(:) :: type1_indices
   integer, allocatable, dimension(:) :: type2_indices
   integer, allocatable, dimension(:) :: start_indices

   double precision :: pair_norm
   double precision :: huge_double

   double precision, allocatable, dimension(:) :: bag
   double precision, allocatable, dimension(:, :) :: pair_distance_matrix

   if (size(coordinates, dim=1) /= size(atomic_charges, dim=1)) then
      write (*, *) "ERROR: Bag of Bonds generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(atomic_charges, dim=1), "atom_types!"
      stop
   else if (size(coordinates, dim=1) /= size(nuclear_charges, dim=1)) then
      write (*, *) "ERROR: Coulomb matrix generation"
      write (*, *) size(coordinates, dim=1), "coordinates, but", &
          & size(nuclear_charges, dim=1), "atom_types!"
      stop
   else
      natoms = size(atomic_charges, dim=1)
   end if

   if (size(id, dim=1) /= size(nmax, dim=1)) then
      write (*, *) "ERROR: Bag of Bonds generation"
      write (*, *) size(id, dim=1), "unique atom types, but", &
          & size(nmax, dim=1), "max size!"
      stop
   else
      nid = size(id, dim=1)
   end if

   n = 0
   !$OMP PARALLEL DO REDUCTION(+:n)
   do i = 1, nid
      n = n + nmax(i)*(1 + nmax(i))
      do j = 1, i - 1
         n = n + 2*nmax(i)*nmax(j)
      end do
   end do
   !$OMP END PARALLEL DO

   if (n /= 2*ncm) then
      write (*, *) "ERROR: Bag of Bonds generation"
      write (*, *) "Inferred vector size", n, "but given size", ncm
      stop
   end if

   ! Allocate temporary
   allocate (pair_distance_matrix(natoms, natoms))
   huge_double = huge(pair_distance_matrix(1, 1))

   !$OMP PARALLEL DO PRIVATE(pair_norm)
   do i = 1, natoms
      do j = i + 1, natoms
         pair_norm = atomic_charges(i)*atomic_charges(j) &
             & /sqrt(sum((coordinates(j, :) - coordinates(i, :))**2))

         pair_distance_matrix(i, j) = pair_norm
         pair_distance_matrix(j, i) = pair_norm
      end do
   end do
   !$OMP END PARALLEL DO

   ! Allocate temporary
   ! Too large but easier
   allocate (type1_indices(maxval(nmax, dim=1)))
   allocate (type2_indices(maxval(nmax, dim=1)))

   ! Get max bag size
   nbag = 0
   do i = 1, nid
      nbag = max(n, (nmax(i)*(nmax(i) - 1))/2)
      do j = 1, i - 1
         nbag = max(n, nmax(i)*nmax(j))
      end do
   end do

   ! Allocate temporary
   ! Too large but easier
   allocate (bag(nbag))
   allocate (start_indices(nid))

   ! get start indices
   start_indices(1) = 0
   do i = 2, nid
      start_indices(i) = (nmax(i - 1)*(nmax(i - 1) + 1))/2 + start_indices(i - 1)
      do j = i, nid
         start_indices(i) = start_indices(i) + nmax(j)*nmax(i - 1)
      end do
   end do

   cm = 0.0d0

   !$OMP PARALLEL DO PRIVATE(type1, type1_indices, l, &
   !$OMP& bag, natoms1, idx1, idx2, k, nbag, type2, natoms2, type2_indices)
   do i = 1, nid
      type1 = id(i)
      natoms1 = 0

      call get_indices(natoms, nuclear_charges, type1, natoms1, type1_indices)

      bag = 0.0d0

      do j = 1, natoms1
         idx1 = type1_indices(j)
         cm(start_indices(i) + j) = 0.5d0*atomic_charges(idx1)**2.4d0
         k = (j*j - 3*j)/2
         do l = 1, j - 1
            idx2 = type1_indices(l)
            bag(k + l + 1) = pair_distance_matrix(idx1, idx2)
         end do
      end do

      start_indices(i) = start_indices(i) + nmax(i)

      nbag = (nmax(i)*nmax(i) - nmax(i))/2
      ! sort
      do j = 1, nbag
         k = minloc(bag(:nbag), dim=1)
         cm(start_indices(i) + nbag - j + 1) = bag(k)
         bag(k) = huge_double
      end do

      start_indices(i) = start_indices(i) + nbag

      do j = i + 1, nid
         type2 = id(j)
         natoms2 = 0

         call get_indices(natoms, nuclear_charges, type2, natoms2, type2_indices)

         bag = 0.0d0

         do k = 1, natoms1
            idx1 = type1_indices(k)
            do l = 1, natoms2
               idx2 = type2_indices(l)
               bag(natoms2*(k - 1) + l) = pair_distance_matrix(idx1, idx2)
            end do
         end do

         ! sort
         nbag = nmax(i)*nmax(j)
         do k = 1, nbag
            l = minloc(bag(:nbag), dim=1)
            cm(start_indices(i) + nbag - k + 1) = bag(l)
            bag(l) = huge_double
         end do

         start_indices(i) = start_indices(i) + nbag
      end do
   end do
   !$OMP END PARALLEL DO

   ! Clean up
   deallocate (pair_distance_matrix)
   deallocate (bag)
   deallocate (type1_indices)
   deallocate (type2_indices)
   deallocate (start_indices)

end subroutine fgenerate_bob

subroutine fglobal_kernel(x1, x2, q1, q2, n1, n2, nm1, nm2, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1
    double precision, dimension(:,:,:), intent(in) :: x2

    integer, dimension(:,:), intent(in) :: q1
    integer, dimension(:,:), intent(in) :: q2

    integer, dimension(:), intent(in) :: n1
    integer, dimension(:), intent(in) :: n2

    integer, intent(in) :: nm1
    integer, intent(in) :: nm2

    double precision, intent(in) :: sigma

    double precision, dimension(nm2,nm1), intent(out) :: kernel

    integer :: i1, i2
    integer :: j1, j2

    integer :: a, b

    integer :: rep_size
    double precision :: inv_sigma2

    double precision, allocatable, dimension(:) :: d
    double precision, dimension(nm1) :: s11
    double precision, dimension(nm2) :: s22
    double precision :: s12

    double precision :: l2

    kernel = 0.0d0

    rep_size = size(x1, dim=3)
    allocate(d(rep_size))

    inv_sigma2 = -1.0d0 / (2 * sigma**2)

    s11(:) = 0.0d0

    !$OMP PARALLEL DO REDUCTION(+:s11)
    do a = 1, nm1
        do j1 = 1, n1(a)
            do i1 = 1, n1(a)

                if (q1(j1,a) == q1(i1,a)) then
                    s11(a) = s11(a) + dot_product(x1(a,j1,:), x1(a,i1,:))
                endif

            enddo
        enddo
    enddo
    !$OMP END PARALLEL DO


    s22(:) = 0.0d0

    !$OMP PARALLEL DO REDUCTION(+:s22)
    do b = 1, nm2
        do j2 = 1, n2(b)
            do i2 = 1, n2(b)

                if (q2(j2,b) == q2(i2,b)) then
                    s22(b) = s22(b) + dot_product(x2(b,j2,:), x2(b,i2,:))
                endif

            enddo
        enddo
    enddo
    !$OMP END PARALLEL DO

    !$OMP PARALLEL DO private(s12, l2) schedule(dynamic)
    do a = 1, nm1

        ! Molecule 2
        do b = 1, nm2

            s12 = 0.0d0
            ! Atom in Molecule 1
            do j1 = 1, n1(a)

                !Atom in Molecule2
                do j2 = 1, n2(b)

                    if (q1(j1,a) == q2(j2,b)) then

                        s12 = s12 + dot_product(x1(a,j1,:), x2(b,j2,:))

                    endif

                enddo
            enddo

            l2 = s11(a) + s22(b) - 2.0d0*s12
            kernel(b, a) = exp(l2 * inv_sigma2)

        enddo
    enddo
    !$OMP END PARALLEL DO

    deallocate(d)

end subroutine fglobal_kernel


subroutine flocal_kernels(x1, x2, q1, q2, n1, n2, nm1, nm2, sigmas, nsigmas, kernel)

    ! use omp_lib, only: omp_get_thread_num, omp_get_wtime

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1
    double precision, dimension(:,:,:), intent(in) :: x2

    integer, dimension(:,:), intent(in) :: q1
    integer, dimension(:,:), intent(in) :: q2

    integer, dimension(:), intent(in) :: n1
    integer, dimension(:), intent(in) :: n2

    integer, intent(in) :: nm1
    integer, intent(in) :: nm2

    double precision, dimension(:), intent(in) :: sigmas
    integer, intent(in) :: nsigmas

    double precision, dimension(nsigmas,nm2,nm1), intent(out) :: kernel

    ! integer, external :: omp_get_thread_num

    integer :: j1, j2
    integer :: a, b
    integer :: i

    integer :: work_done
    integer :: work_total

    ! integer :: rep_size
    double precision, dimension(nsigmas) :: inv_sigma2
    double precision :: l2
    double precision :: t_start
    double precision :: t_elapsed
    double precision :: t_eta

    kernel = 0.0d0

    do i =1, nsigmas
       inv_sigma2(i) = -1.0d0 / (2 * sigmas(i)**2)
    enddo


    ! !$OMP PARALLEL private(tid)
    ! tid = OMP_get_thread_num()
    ! write(*,*) tid
    ! !$OMP END PARALLEL

    ! work_total = nm1 * nm2
    ! work_done = 0

    ! t_start = omp_get_wtime()

    ! write(*,*) "QML: Non-alchemical Gaussian kernel progess:"
    !$OMP PARALLEL DO private(l2) shared(work_total) schedule(dynamic)
    do a = 1, nm1

        ! if (omp_get_thread_num() == 0) then

            ! t_elapsed = omp_get_wtime() - t_start
            ! t_eta = t_elapsed * work_total / work_done - t_elapsed

         ! write(*,"(F10.1, A, F10.1, A, F10.1, A, F10.1, A)") dble(work_done) / dble(work_total) * 100.0d0 , " %", &
         !     & t_eta, " s", t_elapsed, " s", t_elapsed + t_eta, " s"
          ! write(*,"(A, F10.1, A)") "elapsed", omp_get_wtime() - t_start, "s"




          ! write(*,"(A, F10.1, A)") "eta", (omp_get_wtime() - t_start) * dble(work_total) / dble(work_done) &
          !    & - (omp_get_wtime() - t_start), "s"
        ! endif

        ! Molecule 2
        do b = 1, nm2

            ! Atom in Molecule 1
            do j1 = 1, n1(a)

                !Atom in Molecule2
                do j2 = 1, n2(b)

                    if (q1(j1,a) == q2(j2,b)) then

                        l2 = sum((x1(a,j1,:) - x2(b,j2,:))**2)
                        kernel(:, b, a) = kernel(:, b, a) + exp(l2 * inv_sigma2(:))

                    endif

                enddo
            enddo

        enddo

        ! !$OMP ATOMIC
        ! work_done = work_done + nm2
        ! !$OMP END ATOMIC

    enddo
    !$OMP END PARALLEL do

    ! write(*,"(F10.1, A)") dble(work_done) / dble(work_total) * 100.0d0 , " %"
    ! write(*,*) "QML: Non-alchemical Gaussian kernel completed!"

end subroutine flocal_kernels


subroutine fsymmetric_local_kernels(x1, q1, n1, nm1, sigmas, nsigmas, kernel)

    ! use omp_lib, only: omp_get_thread_num, omp_get_wtime

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1
    integer, dimension(:,:), intent(in) :: q1
    integer, dimension(:), intent(in) :: n1
    integer, intent(in) :: nm1

    double precision, dimension(:), intent(in) :: sigmas
    integer, intent(in) :: nsigmas

    double precision, dimension(nsigmas,nm1,nm1), intent(out) :: kernel

    integer :: j1, j2
    integer :: a, b
    integer :: i

    integer :: work_done
    integer :: work_total

    integer :: rep_size
    double precision, allocatable, dimension(:) :: inv_sigma2
    double precision :: l2

    double precision :: t_start
    double precision :: t_elapsed
    double precision :: t_eta

    kernel = 0.0d0

    rep_size = size(x1, dim=3)
    allocate(inv_sigma2(nsigmas))

    do i =1, nsigmas
       inv_sigma2(i) = -1.0d0 / (2 * sigmas(i)**2)
    enddo

    ! work_total = (nm1 * (nm1 + 1)) / 2
    ! work_done = 0

    ! t_start = omp_get_wtime()

    ! write(*,*) "QML: Non-alchemical Gaussian kernel progess:"
    !$OMP PARALLEL DO private(l2) shared(work_done) schedule(dynamic)
    do a = 1, nm1

        ! ! if (omp_get_thread_num() == 0) then
        ! !     write(*,"(F10.1, A)") dble(work_done) / dble(work_total) * 100.0d0 , " %"
        ! ! endif

        ! if (omp_get_thread_num() == 0) then

        !     t_elapsed = omp_get_wtime() - t_start
        !     t_eta = t_elapsed * work_total / work_done - t_elapsed

        !  write(*,"(F10.1, A, F10.1, A, F10.1, A, F10.1, A)") dble(work_done) / dble(work_total) * 100.0d0 , " %", &
        !      & t_eta, " s", t_elapsed, " s", t_elapsed + t_eta, " s"
        !   ! write(*,"(A, F10.1, A)") "elapsed", omp_get_wtime() - t_start, "s"




        !   ! write(*,"(A, F10.1, A)") "eta", (omp_get_wtime() - t_start) * dble(work_total) / dble(work_done) &
        !   !    & - (omp_get_wtime() - t_start), "s"
        ! endif

        ! Molecule 2
        do b = a, nm1

            ! Atom in Molecule 1
            do j1 = 1, n1(a)

                !Atom in Molecule2
                do j2 = 1, n1(b)

                    if (q1(j1,a) == q1(j2,b)) then

                        l2 = sum((x1(a,j1,:) - x1(b,j2,:))**2)
                        kernel(:, b, a) = kernel(:, b, a) + exp(l2 * inv_sigma2(:))

                    endif

                enddo
            enddo

            if (b > a) then
                kernel(:, a, b) = kernel(:, b, a)

            endif

        enddo

        !$OMP ATOMIC
        work_done = work_done + (nm1 - a + 1)
        !$OMP END ATOMIC

    enddo
    !$OMP END PARALLEL do

    write(*,"(F10.1, A)") dble(work_done) / dble(work_total) * 100.0d0 , " %"
    write(*,*) "QML: Non-alchemical Gaussian kernel completed!"

    deallocate(inv_sigma2)

end subroutine fsymmetric_local_kernels



subroutine flocal_kernel(x1, x2, q1, q2, n1, n2, nm1, nm2, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1
    double precision, dimension(:,:,:), intent(in) :: x2

    integer, dimension(:,:), intent(in) :: q1
    integer, dimension(:,:), intent(in) :: q2

    integer, dimension(:), intent(in) :: n1
    integer, dimension(:), intent(in) :: n2

    integer, intent(in) :: nm1
    integer, intent(in) :: nm2

    double precision, intent(in) :: sigma

    double precision, dimension(nm2,nm1), intent(out) :: kernel

    integer :: j1, j2
    integer :: a, b

    integer :: rep_size
    double precision :: inv_sigma2
    double precision :: l2

    kernel = 0.0d0

    rep_size = size(x1, dim=3)
    inv_sigma2 = -1.0d0 / (2 * sigma**2)

    !$OMP PARALLEL DO private(l2) schedule(dynamic)
    do a = 1, nm1

        ! Molecule 2
        do b = 1, nm2

            ! Atom in Molecule 1
            do j1 = 1, n1(a)

                !Atom in Molecule2
                do j2 = 1, n2(b)

                    if (q1(j1,a) == q2(j2,b)) then

                       l2 = sum((x1(a,j1,:) - x2(b,j2,:))**2)
                       kernel(b, a) = kernel(b, a) + exp(l2 * inv_sigma2)

                    endif

                enddo
            enddo

        enddo
    enddo
    !$OMP END PARALLEL do

end subroutine flocal_kernel


subroutine fsymmetric_local_kernel(x1, q1, n1, nm1, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1

    integer, dimension(:,:), intent(in) :: q1

    integer, dimension(:), intent(in) :: n1

    integer, intent(in) :: nm1

    double precision, intent(in) :: sigma

    double precision, dimension(nm1,nm1), intent(out) :: kernel

    integer :: j1, j2
    integer :: a, b

    integer :: rep_size
    double precision :: inv_sigma2
    double precision :: l2

    kernel = 0.0d0

    rep_size = size(x1, dim=3)
    inv_sigma2 = -1.0d0 / (2 * sigma**2)

    !$OMP PARALLEL DO private(l2) schedule(dynamic)
    do a = 1, nm1

        ! Molecule 2
        do b = a, nm1

            ! Atom in Molecule 1
            do j1 = 1, n1(a)

                !Atom in Molecule2
                do j2 = 1, n1(b)

                    if (q1(j1,a) == q1(j2,b)) then

                        l2 = sum((x1(a,j1,:) - x1(b,j2,:))**2)
                        kernel(a, b) = kernel(a, b) + exp(l2 * inv_sigma2)

                    endif

                enddo
            enddo

            if (b > a) then
                kernel(b, a) = kernel(a, b)

            endif

        enddo
    enddo
    !$OMP END PARALLEL do

end subroutine fsymmetric_local_kernel


subroutine fatomic_local_kernel(x1, x2, q1, q2, n1, n2, nm1, nm2, na1, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1
    double precision, dimension(:,:,:), intent(in) :: x2

    integer, dimension(:,:), intent(in) :: q1
    integer, dimension(:,:), intent(in) :: q2

    integer, dimension(:), intent(in) :: n1
    integer, dimension(:), intent(in) :: n2

    integer, intent(in) :: nm1
    integer, intent(in) :: nm2
    integer, intent(in) :: na1

    double precision, intent(in) :: sigma

    double precision, dimension(nm2,na1), intent(out) :: kernel

    integer :: j1, j2
    integer :: a, b
    integer :: idx1_start, idx1

    integer :: rep_size
    double precision :: inv_sigma2
    double precision :: l2

    kernel = 0.0d0

    rep_size = size(x1, dim=3)

    inv_sigma2 = -1.0d0 / (2 * sigma**2)

    !$OMP PARALLEL DO private(idx1_start, idx1, l2) schedule(dynamic)
    do a = 1, nm1

        idx1_start = sum(n1(:a)) - n1(a)

        ! Molecule 2
        do b = 1, nm2

            ! Atom in Molecule 1
            do j1 = 1, n1(a)

                idx1 = idx1_start + j1

                !Atom in Molecule2
                do j2 = 1, n2(b)

                    if (q1(j1,a) == q2(j2,b)) then

                        l2 = sum((x1(a,j1,:) - x2(b,j2,:))**2)
                        kernel(b,idx1) = kernel(b,idx1) + exp(l2 * inv_sigma2)

                    endif

                enddo
            enddo

        enddo
    enddo
    !$OMP END PARALLEL do

end subroutine fatomic_local_kernel


subroutine fatomic_local_gradient_kernel(x1, x2, dx2, q1, q2, n1, n2, nm1, nm2, na1, naq2, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1
    double precision, dimension(:,:,:), intent(in) :: x2

    double precision, dimension(:,:,:,:,:), intent(in) :: dx2

    integer, dimension(:,:), intent(in) :: q1
    integer, dimension(:,:), intent(in) :: q2

    integer, dimension(:), intent(in) :: n1
    integer, dimension(:), intent(in) :: n2

    integer, intent(in) :: nm1
    integer, intent(in) :: nm2
    integer, intent(in) :: na1
    integer, intent(in) :: naq2

    double precision, intent(in) :: sigma

    double precision, dimension(naq2,na1), intent(out) :: kernel

    integer :: i2, j1, j2
    integer :: xyz2
    integer :: a, b
    integer :: idx1_start, idx2_end, idx2_start, idx2, idx1

    integer :: rep_size

    double precision :: expd
    double precision :: inv_2sigma2
    double precision :: inv_sigma2

    double precision, allocatable, dimension(:) :: d
    double precision, allocatable, dimension(:,:,:,:) :: sorted_derivs


    rep_size = size(x1, dim=3)
    allocate(d(rep_size))

    inv_2sigma2 = -1.0d0 / (2 * sigma**2)
    inv_sigma2 = -1.0d0 / (sigma**2)

    allocate(sorted_derivs(rep_size,maxval(n2)*3,maxval(n2),nm2))

    sorted_derivs = 0.0d0

    ! Presort the representation derivatives
    do b = 1, nm2
        do i2 = 1, n2(b)
            idx2 = 0

            do j2 = 1, n2(b)

                do xyz2 = 1, 3
                    idx2 = idx2 + 1

                    sorted_derivs(:,idx2,i2,b) = dx2(b, i2,:,j2,xyz2)

                enddo
            enddo
        enddo
    enddo

    kernel = 0.0d0

    !$OMP PARALLEL DO PRIVATE(idx2_end,idx2_start,d,expd,idx1_start,idx1) schedule(dynamic)
    do a = 1, nm1

        idx1_start = sum(n1(:a)) - n1(a) + 1

        ! Atom in Molecule 1
        do j1 = 1, n1(a)

            idx1 = idx1_start - 1 + j1

            ! Molecule 2
            do b = 1, nm2

                idx2_start = (sum(n2(:b)) - n2(b))*3 + 1
                idx2_end = sum(n2(:b))*3

                !Atom in Molecule2
                do j2 = 1, n2(b)

                    if (q1(j1,a) == q2(j2,b)) then
                        ! Calculate the distance vector, and some intermediate results
                        d(:) = x1(a,j1,:)- x2(b,j2,:)
                        expd = inv_sigma2 * exp(sum(d**2) * inv_2sigma2)

                        ! Add the dot product to the kernel in one BLAS call
                        call dgemv("T", rep_size, n2(b)*3, expd, sorted_derivs(:,:n2(b)*3,j2,b), &
                            & rep_size, d, 1, 1.0d0, kernel(idx2_start:idx2_end,idx1), 1)
                    endif

                enddo
            enddo
        enddo
    enddo
    !$OMP END PARALLEL do

    deallocate(sorted_derivs)
    deallocate(d)

end subroutine fatomic_local_gradient_kernel


! NOTE: Legacy code without any fancy BLAS calls, for reference

! subroutine fatomic_local_gradient_kernel(x1, x2, dx2, q1, q2, n1, n2, nm1, nm2, na1, naq2, sigma, kernel)

!     implicit none

!     double precision, dimension(:,:,:), intent(in) :: x1
!     double precision, dimension(:,:,:), intent(in) :: x2

!     double precision, dimension(:,:,:,:,:), intent(in) :: dx2

!     integer, dimension(:,:), intent(in) :: q1
!     integer, dimension(:,:), intent(in) :: q2

!     integer, dimension(:), intent(in) :: n1
!     integer, dimension(:), intent(in) :: n2

!     integer, intent(in) :: nm1
!     integer, intent(in) :: nm2
!     integer, intent(in) :: na1
!     integer, intent(in) :: naq2

!     double precision, intent(in) :: sigma

!     double precision, dimension(naq2,na1), intent(out) :: kernel

!     integer :: i2, j1, j2
!     integer :: na, nb, xyz2
!     integer :: a, b
!     integer :: idx1_end, idx1_start, idx2_end, idx2_start, idx2, idx1

!     integer :: rep_size

!     double precision :: expd
!     double precision :: inv_2sigma2
!     double precision :: inv_sigma2

!     double precision, allocatable, dimension(:) :: d

!     rep_size = size(x1, dim=3)
!     allocate(d(rep_size))

!     inv_2sigma2 = -1.0d0 / (2 * sigma**2)
!     inv_sigma2 = -1.0d0 / (sigma**2)

!     kernel = 0.0d0

!     ! Molecule 1
!     do a = 1, nm1

!         na = n1(a)

!         idx1_end = sum(n1(:a))
!         idx1_start = idx1_end - na + 1


!         ! Atom in Molecule 1
!         do j1 = 1, na
!             idx1 = idx1_start - 1 + j1

!             ! Molecule 2
!             do b = 1, nm2
!                 nb = n2(b)

!                 idx2_end = sum(n2(:b))
!                 idx2_start = idx2_end - nb + 1

!                 !Atom in Molecule2
!                 do j2 = 1, nb

!                     if (q1(j1,a) == q2(j2,b)) then

!                         d(:) = x1(a,j1,:)- x2(b,j2,:)
!                         ! expd = -1.0d0/sigma**2 * exp(-(norm2(d)**2) / (2 * sigma**2))
!                         expd = inv_sigma2 * exp((norm2(d)**2) * inv_2sigma2) ! Possibly 4??

!                         ! Derivative WRT this atom in Molecule 2
!                         do i2 = 1, nb

!                                 ! Loop over XYZ
!                                 do xyz2 = 1, 3

!                                     idx2 = (idx2_start-1)*3 + (i2-1)*3 + xyz2
!                                     kernel(idx2, idx1) = kernel(idx2, idx1) +  expd * dot_product(d, dx2(b, j2,:,i2,xyz2))

!                                 enddo

!                             endif
!                         enddo

!                     endif

!                 enddo
!             enddo
!         enddo
!     enddo




! end subroutine fatomic_local_gradient_kernel


subroutine flocal_gradient_kernel(x1, x2, dx2, q1, q2, n1, n2, nm1, nm2, naq2, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1
    double precision, dimension(:,:,:), intent(in) :: x2

    double precision, dimension(:,:,:,:,:), intent(in) :: dx2

    integer, dimension(:,:), intent(in) :: q1
    integer, dimension(:,:), intent(in) :: q2

    integer, dimension(:), intent(in) :: n1
    integer, dimension(:), intent(in) :: n2

    integer, intent(in) :: nm1
    integer, intent(in) :: nm2
    integer, intent(in) :: naq2

    double precision, intent(in) :: sigma

    double precision, dimension(naq2,nm1), intent(out) :: kernel

    integer :: i2, j1, j2
    integer :: nb, xyz2
    integer :: a, b
    integer :: idx2_end, idx2_start, idx2

    integer :: rep_size

    double precision :: expd, inv_2sigma2, inv_sigma2

    double precision, allocatable, dimension(:) :: d
    double precision, allocatable, dimension(:,:,:,:) :: sorted_derivs

    rep_size = size(x1, dim=3)
    allocate(d(rep_size))

    inv_2sigma2 = -1.0d0 / (2 * sigma**2)
    inv_sigma2 = -1.0d0 / (sigma**2)

    kernel = 0.0d0


    allocate(sorted_derivs(rep_size,maxval(n2)*3,maxval(n2),nm2))

    sorted_derivs = 0.0d0

    ! Presort the representation derivatives
    do b = 1, nm2
        do i2 = 1, n2(b)
            idx2 = 0

            do j2 = 1, n2(b)

                do xyz2 = 1, 3
                    idx2 = idx2 + 1

                    sorted_derivs(:,idx2,i2,b) = dx2(b, i2,:,j2,xyz2)

                enddo
            enddo
        enddo
    enddo

    ! Molecule 1
    !$OMP PARALLEL DO PRIVATE(idx2_end,idx2_start,d,expd) schedule(dynamic)
    do a = 1, nm1

        ! Atom in Molecule 1
        do j1 = 1, n1(a)

            ! Molecule 2
            do b = 1, nm2
                nb = n2(b)

                idx2_start = (sum(n2(:b)) - n2(b))*3 + 1
                idx2_end = sum(n2(:b))*3

                !Atom in Molecule2
                do j2 = 1, n2(b)

                    if (q1(j1,a) == q2(j2,b)) then
                        ! Calculate the distance vector, and some intermediate results
                        d(:) = x1(a,j1,:)- x2(b,j2,:)
                        expd = inv_sigma2 * exp(sum(d**2) * inv_2sigma2)

                        ! Add the dot products to the kernel in one BLAS call
                        call dgemv("T", rep_size, n2(b)*3, expd, sorted_derivs(:,:n2(b)*3,j2,b), &
                            & rep_size, d, 1, 1.0d0, kernel(idx2_start:idx2_end,a), 1)
                    endif

                enddo
            enddo
        enddo
    enddo
    !$OMP END PARALLEL do

    deallocate(sorted_derivs)
    deallocate(d)

end subroutine flocal_gradient_kernel


subroutine fgdml_kernel(x1, x2, dx1, dx2, q1, q2, n1, n2, nm1, nm2, na1, na2, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1
    double precision, dimension(:,:,:), intent(in) :: x2

    double precision, dimension(:,:,:,:,:), intent(in) :: dx1
    double precision, dimension(:,:,:,:,:), intent(in) :: dx2

    integer, dimension(:,:), intent(in) :: q1
    integer, dimension(:,:), intent(in) :: q2

    integer, dimension(:), intent(in) :: n1
    integer, dimension(:), intent(in) :: n2

    integer, intent(in) :: nm1
    integer, intent(in) :: nm2
    integer, intent(in) :: na1
    integer, intent(in) :: na2

    double precision, intent(in) :: sigma

    double precision, dimension(na2*3,na1*3), intent(out) :: kernel

    integer :: i1, i2, j2, k
    integer :: xyz2
    integer :: a, b
    integer :: idx1_end, idx1_start, idx2_end, idx2_start, idx2

    integer :: rep_size

    double precision :: expd, expdiag

    double precision :: inv_2sigma2
    double precision :: inv_sigma4
    double precision :: sigma2

    double precision, allocatable, dimension(:) :: d

    double precision, allocatable, dimension(:,:) :: hess
    double precision, allocatable, dimension(:,:) :: partial

    double precision, allocatable, dimension(:,:,:,:) :: sorted_derivs1
    double precision, allocatable, dimension(:,:,:,:) :: sorted_derivs2

    rep_size = size(x1, dim=3)
    allocate(d(rep_size))
    allocate(partial(rep_size,maxval(n2)*3))
    partial = 0.0d0
    allocate(hess(rep_size, rep_size))

    allocate(sorted_derivs1(rep_size,maxval(n1)*3,maxval(n1),nm1))
    allocate(sorted_derivs2(rep_size,maxval(n2)*3,maxval(n2),nm2))

    sorted_derivs1 = 0.0d0
    sorted_derivs2 = 0.0d0

    ! Presort the representation derivatives
    do b = 1, nm2
        do i2 = 1, n2(b)
            idx2 = 0

            do j2 = 1, n2(b)

                do xyz2 = 1, 3
                    idx2 = idx2 + 1

                    sorted_derivs2(:,idx2,i2,b) = dx2(b, i2,:,j2,xyz2)

                enddo
            enddo
        enddo
    enddo

    ! Presort the representation derivatives
    do b = 1, nm1
        do i2 = 1, n1(b)
            idx2 = 0

            do j2 = 1, n1(b)

                do xyz2 = 1, 3
                    idx2 = idx2 + 1

                    sorted_derivs1(:,idx2,i2,b) = dx1(b, i2,:,j2,xyz2)

                enddo
            enddo
        enddo
    enddo

    ! Reset kernel
    kernel = 0.0d0

    ! Calculate these only once
    inv_2sigma2 = -1.0d0 / (2 * sigma**2)
    inv_sigma4 = -1.0d0 / (sigma**4)
    sigma2 = -1.0d0 * sigma**2

    !$OMP PARALLEL DO PRIVATE(idx1_start,idx2_start,d,expd,expdiag,hess,idx1_end,idx2_end,partial) schedule(dynamic)
    do a = 1, nm1
        idx1_start = (sum(n1(:a)) - n1(a))*3 + 1
        idx1_end = sum(n1(:a))*3

        do b = 1, nm2
            idx2_start = (sum(n2(:b)) - n2(b))*3 + 1
            idx2_end = sum(n2(:b))*3

            ! Atoms A and B
            do i1 = 1, n1(a)
                do i2 = 1, n2(b)

                    if (q1(i1,a) == q2(i2,b)) then

                        ! Calculate the distance vector, and some intermediate results
                        d(:) = x1(a,i1,:)- x2(b,i2,:)
                        expd = inv_sigma4 * exp(sum(d**2) * inv_2sigma2)
                        expdiag = sigma2 * expd

                        ! Calculate the outer product of the distance
                        hess = 0.0d0
                        call dsyr("U", rep_size, expd, d, 1, hess, rep_size)

                        do k = 1, rep_size
                           hess(k,k) = hess(k,k) + expdiag
                        enddo

                        ! ! Do the first half of the dot product, save in partial(:,:)
                        ! call dsymm("L", "U", rep_size, n1(a)*3, 1.0d0, hess(:,:), &
                        !     & rep_size, sorted_derivs1(:,:n1(a)*3,i1,a), rep_size, &
                        !     & 0.0d0, partial(:,:n1(a)*3), rep_size)

                        ! ! Add the dot product to the kernel in one BLAS call
                        ! call dgemm("T", "N", n1(a)*3, n2(b)*3, rep_size, 1.0d0, &
                        !     & partial(:,:n1(a)*3), rep_size, &
                        !     & sorted_derivs2(:,:n2(b)*3,i2,b), rep_size, 1.0d0, &
                        !     & kernel(idx1_start:idx1_end,idx2_start:idx2_end), n1(a)*3, 1)

                        ! Do the first half of the dot product, save in partial(:,:)
                        call dsymm("L", "U", rep_size, n2(b)*3, 1.0d0, hess(:,:), &
                            & rep_size, sorted_derivs2(:,:n2(b)*3,i2,b), rep_size, &
                            & 0.0d0, partial(:,:n2(b)*3), rep_size)

                        ! Add the dot product to the kernel in one BLAS call
                        call dgemm("T", "N", n2(b)*3, n1(a)*3, rep_size, 1.0d0, &
                            & partial(:,:n2(b)*3), rep_size, &
                            & sorted_derivs1(:,:n1(a)*3,i1,a), rep_size, 1.0d0, &
                            & kernel(idx2_start:idx2_end,idx1_start:idx1_end), n2(b)*3, 1)

                    endif

                enddo
            enddo

        enddo
    enddo
    !$OMP END PARALLEL do

    deallocate(hess)
    deallocate(sorted_derivs1)
    deallocate(sorted_derivs2)
    deallocate(partial)
    deallocate(d)

end subroutine fgdml_kernel


subroutine fsymmetric_gdml_kernel(x1, dx1, q1, n1, nm1, na1, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1

    double precision, dimension(:,:,:,:,:), intent(in) :: dx1

    integer, dimension(:,:), intent(in) :: q1

    integer, dimension(:), intent(in) :: n1

    integer, intent(in) :: nm1
    integer, intent(in) :: na1

    double precision, intent(in) :: sigma

    double precision, dimension(na1*3,na1*3), intent(out) :: kernel

    integer :: i1, i2, j2, k
    integer :: xyz2
    integer :: a, b
    integer :: idx1_end, idx1_start, idx2_end, idx2_start, idx2

    integer :: rep_size

    double precision :: expd, expdiag

    double precision :: inv_2sigma2
    double precision :: inv_sigma4
    double precision :: sigma2

    double precision, allocatable, dimension(:) :: d

    double precision, allocatable, dimension(:,:) :: hess
    double precision, allocatable, dimension(:,:) :: partial

    double precision, allocatable, dimension(:,:,:,:) :: sorted_derivs1

    rep_size = size(x1, dim=3)
    allocate(d(rep_size))
    allocate(partial(rep_size,maxval(n1)*3))
    partial = 0.0d0
    allocate(hess(rep_size, rep_size))

    allocate(sorted_derivs1(rep_size,maxval(n1)*3,maxval(n1),nm1))

    sorted_derivs1 = 0.0d0

    ! Presort the representation derivatives
    do b = 1, nm1
        do i2 = 1, n1(b)
            idx2 = 0

            do j2 = 1, n1(b)

                do xyz2 = 1, 3
                    idx2 = idx2 + 1

                    sorted_derivs1(:,idx2,i2,b) = dx1(b, i2,:,j2,xyz2)

                enddo
            enddo
        enddo
    enddo

    ! Reset kernel
    kernel = 0.0d0

    ! Calculate these only once
    inv_2sigma2 = -1.0d0 / (2 * sigma**2)
    inv_sigma4 = -1.0d0 / (sigma**4)
    sigma2 = -1.0d0 * sigma**2

    !$OMP PARALLEL DO PRIVATE(idx1_start,idx2_start,d,expd,expdiag,hess,idx1_end,idx2_end,partial) schedule(dynamic)
    do a = 1, nm1
        idx1_start = (sum(n1(:a)) - n1(a))*3 + 1
        idx1_end = sum(n1(:a))*3

        do b = a, nm1
            idx2_start = (sum(n1(:b)) - n1(b))*3 + 1
            idx2_end = sum(n1(:b))*3

            ! Atoms A and B
            do i1 = 1, n1(a)
                do i2 = 1, n1(b)

                    if (q1(i1,a) == q1(i2,b)) then
                        ! Calculate the distance vector, and some intermediate results
                        d(:) = x1(a,i1,:)- x1(b,i2,:)
                        expd = inv_sigma4 * exp(sum(d**2) * inv_2sigma2)
                        expdiag = sigma2 * expd

                        ! Calculate the outer product of the distance
                        hess = 0.0d0
                        call dsyr("U", rep_size, expd, d, 1, hess, rep_size)

                        do k = 1, rep_size
                           hess(k,k) = hess(k,k) + expdiag
                        enddo

                        ! Do the first half of the dot product, save in partial(:,:)
                        call dsymm("L", "U", rep_size, n1(a)*3, 1.0d0, hess(:,:), &
                            & rep_size, sorted_derivs1(:,:n1(a)*3,i1,a), rep_size, &
                            & 0.0d0, partial(:,:n1(a)*3), rep_size)

                        ! Add the dot product to the kernel in one BLAS call
                        call dgemm("T", "N", n1(a)*3, n1(b)*3, rep_size, 1.0d0, &
                            & partial(:,:n1(a)*3), rep_size, &
                            & sorted_derivs1(:,:n1(b)*3,i2,b), rep_size, 1.0d0, &
                            & kernel(idx1_start:idx1_end,idx2_start:idx2_end), n1(a)*3, 1)
                    endif
                enddo
            enddo

            if (b > a) then
               kernel(idx2_start:idx2_end,idx1_start:idx1_end) &
                & = transpose(kernel(idx1_start:idx1_end,idx2_start:idx2_end))
            endif

        enddo
    enddo
    !$OMP END PARALLEL do

    deallocate(hess)
    deallocate(sorted_derivs1)
    deallocate(partial)
    deallocate(d)

end subroutine fsymmetric_gdml_kernel


subroutine fgaussian_process_kernel(x1, x2, dx1, dx2, q1, q2, n1, n2, nm1, nm2, na1, na2, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1
    double precision, dimension(:,:,:), intent(in) :: x2

    double precision, dimension(:,:,:,:,:), intent(in) :: dx1
    double precision, dimension(:,:,:,:,:), intent(in) :: dx2

    integer, dimension(:,:), intent(in) :: q1
    integer, dimension(:,:), intent(in) :: q2

    integer, dimension(:), intent(in) :: n1
    integer, dimension(:), intent(in) :: n2

    integer, intent(in) :: nm1
    integer, intent(in) :: nm2
    integer, intent(in) :: na1
    integer, intent(in) :: na2

    double precision, intent(in) :: sigma

    double precision, dimension(na2*3+nm2,na1*3+nm1), intent(out) :: kernel

    integer :: i1, i2, j1, j2, k
    integer :: xyz2
    integer :: a, b
    integer :: idx1_end, idx1_start, idx2_end, idx2_start, idx2

    integer :: rep_size

    double precision :: expd, expdiag

    double precision :: inv_2sigma2
    double precision :: inv_sigma2
    double precision :: inv_sigma4
    double precision :: sigma2

    double precision, allocatable, dimension(:) :: d

    double precision, allocatable, dimension(:,:) :: hess
    double precision, allocatable, dimension(:,:) :: partial

    double precision, allocatable, dimension(:,:,:,:) :: sorted_derivs1
    double precision, allocatable, dimension(:,:,:,:) :: sorted_derivs2

    ! Reset kernel
    kernel = 0.0d0

    ! Calculate these only once
    inv_2sigma2 = -1.0d0 / (2 * sigma**2)
    inv_sigma2 = -1.0d0 / (sigma**2)
    inv_sigma4 = -1.0d0 / (sigma**4)
    sigma2 = -1.0d0 * sigma**2

    rep_size = size(x1, dim=3)
    allocate(d(rep_size))
    allocate(partial(rep_size,maxval(n2)*3))
    partial = 0.0d0
    allocate(hess(rep_size, rep_size))

    allocate(sorted_derivs1(rep_size,maxval(n1)*3,maxval(n1),nm1))
    allocate(sorted_derivs2(rep_size,maxval(n2)*3,maxval(n2),nm2))

    sorted_derivs1 = 0.0d0
    sorted_derivs2 = 0.0d0


    ! Presort the representation derivatives
    do b = 1, nm1
        do i2 = 1, n1(b)
            idx2 = 0

            do j2 = 1, n1(b)

                do xyz2 = 1, 3
                    idx2 = idx2 + 1

                    sorted_derivs1(:,idx2,i2,b) = dx1(b, i2,:,j2,xyz2)

                enddo
            enddo
        enddo
    enddo


    ! Presort the representation derivatives
    do b = 1, nm2
        do i2 = 1, n2(b)
            idx2 = 0

            do j2 = 1, n2(b)

                do xyz2 = 1, 3
                    idx2 = idx2 + 1

                    sorted_derivs2(:,idx2,i2,b) = dx2(b, i2,:,j2,xyz2)

                enddo
            enddo
        enddo
    enddo

    ! write (*,*) "Kernel"

    !$OMP PARALLEL DO private(d) schedule(dynamic)
    do a = 1, nm1

        ! Molecule 2
        do b = 1, nm2

            ! Atom in Molecule 1
            do j1 = 1, n1(a)

                !Atom in Molecule2
                do j2 = 1, n2(b)

                    if (q1(j1,a) == q2(j2,b)) then
                        d(:) = x1(a,j1,:)- x2(b,j2,:)
                        !kernel(a, b) = kernel(a, b) + exp((norm2(d)**2) * inv_2sigma2)
                        kernel(b, a) = kernel(b, a) + exp(sum(d**2) * inv_2sigma2)
                    endif

                enddo
            enddo

        enddo
    enddo
    !$OMP END PARALLEL do

    ! write (*,*) "Kernel grad 1"

    ! Molecule 1
    !$OMP PARALLEL DO PRIVATE(idx2_end,idx2_start,d,expd) schedule(dynamic)
    do a = 1, nm1

        ! Atom in Molecule 1
        do j1 = 1, n1(a)

            ! Molecule 2
            do b = 1, nm2

                idx2_start = (sum(n2(:b)) - n2(b))*3 + 1
                idx2_end = sum(n2(:b))*3

                !Atom in Molecule2
                do j2 = 1, n2(b)

                    if (q1(j1,a) == q2(j2,b)) then
                        ! Calculate the distance vector, and some intermediate results
                        d(:) = x1(a,j1,:)- x2(b,j2,:)
                        expd = inv_sigma2 * exp(sum(d**2) * inv_2sigma2)

                        ! Add the dot products to the kernel in one BLAS call
                        call dgemv("T", rep_size, n2(b)*3, expd, sorted_derivs2(:,:n2(b)*3,j2,b), &
                            ! & rep_size, d, 1, 1.0d0, kernel(a,idx2_start+nm2:idx2_end+nm2), 1)
                            & rep_size, d, 1, 1.0d0, kernel(idx2_start+nm2:idx2_end+nm2,a), 1)

                    endif

                enddo
            enddo
        enddo
    enddo
    !$OMP END PARALLEL do

    ! write (*,*) "Kernel grad 2"

    ! Molecule 1
    !$OMP PARALLEL DO PRIVATE(idx1_end,idx1_start,d,expd) schedule(dynamic)
    do a = 1, nm2

        ! Atom in Molecule 1
        do j1 = 1, n2(a)

            ! Molecule 2
            do b = 1, nm1

                idx1_start = (sum(n1(:b)) - n1(b))*3 + 1
                idx1_end = sum(n1(:b))*3

                !Atom in Molecule2
                do j2 = 1, n1(b)

                    if (q2(j1,a) == q1(j2,b)) then

                        ! Calculate the distance vector, and some intermediate results
                        d(:) = x2(a,j1,:)- x1(b,j2,:)
                        expd = inv_sigma2 * exp(sum(d**2) * inv_2sigma2)

                        ! write(*,*) nm1,idx1_start+nm1,idx1_end+nm1,a

                        ! Add the dot products to the kernel in one BLAS call
                        call dgemv("T", rep_size, n1(b)*3, expd, sorted_derivs1(:,:n1(b)*3,j2,b), &
                            ! & rep_size, d, 1, 1.0d0, kernel(idx1_start+nm1:idx1_end+nm1,a), 1)
                            & rep_size, d, 1, 1.0d0, kernel(a,idx1_start+nm1:idx1_end+nm1), 1)

                   endif

                enddo
            enddo
        enddo
    enddo
    !$OMP END PARALLEL do

    ! write (*,*) "Kernel hessian"

    !$OMP PARALLEL DO PRIVATE(idx1_start,idx2_start,d,expd,expdiag,hess,idx1_end,idx2_end,partial) schedule(dynamic)
    do a = 1, nm1
        idx1_start = (sum(n1(:a)) - n1(a))*3 + 1 + nm1
        idx1_end = sum(n1(:a))*3 + nm1

        do b = 1, nm2
            idx2_start = (sum(n2(:b)) - n2(b))*3 + 1 + nm2
            idx2_end = sum(n2(:b))*3 + nm2

            ! Atoms A and B
            do i1 = 1, n1(a)
                do i2 = 1, n2(b)

                    if (q1(i1,a) == q2(i2,b)) then

                        ! Calculate the distance vector, and some intermediate results
                        d(:) = x1(a,i1,:)- x2(b,i2,:)
                        expd = inv_sigma4 * exp(sum(d**2) * inv_2sigma2)
                        expdiag = sigma2 * expd

                        ! Calculate the outer product of the distance
                        hess = 0.0d0
                        call dsyr("U", rep_size, expd, d, 1, hess, rep_size)

                        do k = 1, rep_size
                           hess(k,k) = hess(k,k) + expdiag
                        enddo

                        ! ! Do the first half of the dot product, save in partial(:,:)
                        ! call dsymm("L", "U", rep_size, n1(a)*3, 1.0d0, hess(:,:), &
                        !     & rep_size, sorted_derivs1(:,:n1(a)*3,i1,a), rep_size, &
                        !     & 0.0d0, partial(:,:n1(a)*3), rep_size)

                        ! ! Add the dot product to the kernel in one BLAS call
                        ! call dgemm("T", "N", n1(a)*3, n2(b)*3, rep_size, 1.0d0, &
                        !     & partial(:,:n1(a)*3), rep_size, &
                        !     & sorted_derivs2(:,:n2(b)*3,i2,b), rep_size, 1.0d0, &
                        !     & kernel(idx1_start:idx1_end,idx2_start:idx2_end), n1(a)*3, 1)

                        ! Do the first half of the dot product, save in partial(:,:)
                        call dsymm("L", "U", rep_size, n2(b)*3, 1.0d0, hess(:,:), &
                            & rep_size, sorted_derivs2(:,:n2(b)*3,i2,b), rep_size, &
                            & 0.0d0, partial(:,:n2(b)*3), rep_size)

                        ! Add the dot product to the kernel in one BLAS call
                        call dgemm("T", "N", n2(b)*3, n1(a)*3, rep_size, 1.0d0, &
                            & partial(:,:n2(b)*3), rep_size, &
                            & sorted_derivs1(:,:n1(a)*3,i1,a), rep_size, 1.0d0, &
                            & kernel(idx2_start:idx2_end,idx1_start:idx1_end), n2(b)*3, 1)

                    endif

                enddo
            enddo

        enddo
    enddo
    !$OMP END PARALLEL do

    deallocate(hess)
    deallocate(sorted_derivs1)
    deallocate(sorted_derivs2)
    deallocate(partial)
    deallocate(d)

end subroutine fgaussian_process_kernel


subroutine fsymmetric_gaussian_process_kernel(x1, dx1, q1, n1, nm1, na1, sigma, kernel)

    implicit none

    double precision, dimension(:,:,:), intent(in) :: x1

    double precision, dimension(:,:,:,:,:), intent(in) :: dx1

    integer, dimension(:,:), intent(in) :: q1

    integer, dimension(:), intent(in) :: n1

    integer, intent(in) :: nm1
    integer, intent(in) :: na1

    double precision, intent(in) :: sigma

    double precision, dimension(na1*3+nm1,na1*3+nm1), intent(out) :: kernel

    integer :: i1, i2, j1, j2, k
    integer :: xyz2
    integer :: a, b
    integer :: idx1_end, idx1_start, idx2_end, idx2_start, idx2

    integer :: rep_size

    double precision :: expd, expdiag

    double precision :: inv_2sigma2
    double precision :: inv_sigma2
    double precision :: inv_sigma4
    double precision :: sigma2

    double precision, allocatable, dimension(:) :: d

    double precision, allocatable, dimension(:,:) :: hess
    double precision, allocatable, dimension(:,:) :: partial

    double precision, allocatable, dimension(:,:,:,:) :: sorted_derivs1

    ! Reset kernel
    kernel(:,:) = 0.0d0

    ! Calculate these only once
    inv_2sigma2 = -1.0d0 / (2 * sigma**2)
    inv_sigma2 = -1.0d0 / (sigma**2)
    inv_sigma4 = -1.0d0 / (sigma**4)
    sigma2 = -1.0d0 * sigma**2
    rep_size = size(x1, dim=3)

    allocate(d(rep_size))

    allocate(partial(rep_size,maxval(n1)*3))
    partial(:,:) = 0.0d0

    allocate(hess(rep_size, rep_size))

    allocate(sorted_derivs1(rep_size,maxval(n1)*3,maxval(n1),nm1))
    sorted_derivs1(:,:,:,:)= 0.0d0

    ! Presort the representation derivatives
    do b = 1, nm1
        do i2 = 1, n1(b)
            idx2 = 0

            do j2 = 1, n1(b)

                do xyz2 = 1, 3
                    idx2 = idx2 + 1

                    sorted_derivs1(:,idx2,i2,b) = dx1(b, i2,:,j2,xyz2)

                enddo
            enddo
        enddo
    enddo

    ! write (*,*) "Kernel"

    !$OMP PARALLEL DO private(d) schedule(dynamic)
    do a = 1, nm1

        ! Molecule 2
        do b = a, nm1

            ! Atom in Molecule 1
            do j1 = 1, n1(a)

                !Atom in Molecule2
                do j2 = 1, n1(b)

                    if (q1(j1,a) == q1(j2,b)) then
                        d(:) = x1(a,j1,:)- x1(b,j2,:)
                        kernel(a, b) = kernel(a, b) + exp(sum(d**2) * inv_2sigma2)
                    endif

                enddo
            enddo

            if (b > a) then
                kernel(b, a) = kernel(a, b)

            endif

        enddo
    enddo
    !$OMP END PARALLEL do

    ! write (*,*) "Kernel grad 1"

    ! Molecule 1
    !$OMP PARALLEL DO PRIVATE(idx2_end,idx2_start,d,expd) schedule(dynamic)
    do a = 1, nm1

        ! Atom in Molecule 1
        do j1 = 1, n1(a)

            ! Molecule 2
            do b = 1, nm1

                idx2_start = (sum(n1(:b)) - n1(b))*3 + 1
                idx2_end = sum(n1(:b))*3

                !Atom in Molecule2
                do j2 = 1, n1(b)

                    if (q1(j1,a) == q1(j2,b)) then
                        ! Calculate the distance vector, and some intermediate results
                        d(:) = x1(a,j1,:)- x1(b,j2,:)
                        expd = inv_sigma2 * exp(sum(d**2) * inv_2sigma2)

                        ! Add the dot products to the kernel in one BLAS call
                        call dgemv("T", rep_size, n1(b)*3, expd, sorted_derivs1(:,:n1(b)*3,j2,b), &
                            & rep_size, d, 1, 1.0d0, kernel(a,idx2_start+nm1:idx2_end+nm1), 1)
                    endif

                enddo
            enddo
        enddo
    enddo
    !$OMP END PARALLEL do

    kernel(nm1:, :nm1) = transpose(kernel(:nm1, nm1:))

    ! write (*,*) "Kernel hessian"

    !$OMP PARALLEL DO PRIVATE(idx1_start,idx2_start,d,expd,expdiag,hess,idx1_end,idx2_end,partial) schedule(dynamic)
    do a = 1, nm1
        idx1_start = (sum(n1(:a)) - n1(a))*3 + 1 + nm1
        idx1_end = sum(n1(:a))*3 + nm1

        do b = a, nm1
            idx2_start = (sum(n1(:b)) - n1(b))*3 + 1 + nm1
            idx2_end = sum(n1(:b))*3 + nm1

            ! Atoms A and B
            do i1 = 1, n1(a)
                do i2 = 1, n1(b)

                    if (q1(i1,a) == q1(i2,b)) then

                        ! Calculate the distance vector, and some intermediate results
                        d(:) = x1(a,i1,:)- x1(b,i2,:)
                        expd = inv_sigma4 * exp(sum(d**2) * inv_2sigma2)
                        expdiag = sigma2 * expd

                        ! Calculate the outer product of the distance
                        hess = 0.0d0
                        call dsyr("U", rep_size, expd, d, 1, hess, rep_size)

                        do k = 1, rep_size
                           hess(k,k) = hess(k,k) + expdiag
                        enddo

                        ! Do the first half of the dot product, save in partial(:,:)
                        call dsymm("L", "U", rep_size, n1(a)*3, 1.0d0, hess(:,:), &
                            & rep_size, sorted_derivs1(:,:n1(a)*3,i1,a), rep_size, &
                            & 0.0d0, partial(:,:n1(a)*3), rep_size)

                        ! Add the dot product to the kernel in one BLAS call
                        call dgemm("T", "N", n1(a)*3, n1(b)*3, rep_size, 1.0d0, &
                            & partial(:,:n1(a)*3), rep_size, &
                            & sorted_derivs1(:,:n1(b)*3,i2,b), rep_size, 1.0d0, &
                            & kernel(idx1_start:idx1_end,idx2_start:idx2_end), n1(a)*3, 1)

                    endif

                enddo
            enddo

            if (b > a) then
               kernel(idx2_start:idx2_end,idx1_start:idx1_end) &
                & = transpose(kernel(idx1_start:idx1_end,idx2_start:idx2_end))
            endif

        enddo
    enddo
    !$OMP END PARALLEL do

    deallocate(hess)
    deallocate(sorted_derivs1)
    deallocate(partial)
    deallocate(d)

end subroutine fsymmetric_gaussian_process_kernel

subroutine fmanhattan_distance(A, B, D)

   implicit none

   double precision, dimension(:, :), intent(in) :: A
   double precision, dimension(:, :), intent(in) :: B
   double precision, dimension(:, :), intent(inout) :: D

   integer :: na, nb
   integer :: i, j

   na = size(A, dim=2)
   nb = size(B, dim=2)

!$OMP PARALLEL DO
   do i = 1, nb
      do j = 1, na
         D(j, i) = sum(abs(a(:, j) - b(:, i)))
      end do
   end do
!$OMP END PARALLEL DO

end subroutine fmanhattan_distance

subroutine fl2_distance(A, B, D)

   implicit none

   double precision, dimension(:, :), intent(in) :: A
   double precision, dimension(:, :), intent(in) :: B
   double precision, dimension(:, :), intent(inout) :: D

   integer :: na, nb, nv
   integer :: i, j

   double precision, allocatable, dimension(:) :: temp

   nv = size(A, dim=1)

   na = size(A, dim=2)
   nb = size(B, dim=2)

   allocate (temp(nv))

!$OMP PARALLEL DO PRIVATE(temp)
   do i = 1, nb
      do j = 1, na
         temp(:) = A(:, j) - B(:, i)
         D(j, i) = sqrt(sum(temp*temp))
      end do
   end do
!$OMP END PARALLEL DO

   deallocate (temp)

end subroutine fl2_distance

subroutine fp_distance_double(A, B, D, p)

   implicit none

   double precision, dimension(:, :), intent(in) :: A
   double precision, dimension(:, :), intent(in) :: B
   double precision, dimension(:, :), intent(inout) :: D
   double precision, intent(in) :: p

   integer :: na, nb, nv
   integer :: i, j

   double precision, allocatable, dimension(:) :: temp
   double precision :: inv_p

   nv = size(A, dim=1)

   na = size(A, dim=2)
   nb = size(B, dim=2)

   inv_p = 1.0d0/p

   allocate (temp(nv))

!$OMP PARALLEL DO PRIVATE(temp)
   do i = 1, nb
      do j = 1, na
         temp(:) = abs(A(:, j) - B(:, i))
         D(j, i) = (sum(temp**p))**inv_p
      end do
   end do
!$OMP END PARALLEL DO

   deallocate (temp)

end subroutine fp_distance_double

subroutine fp_distance_integer(A, B, D, p)

   implicit none

   double precision, dimension(:, :), intent(in) :: A
   double precision, dimension(:, :), intent(in) :: B
   double precision, dimension(:, :), intent(inout) :: D
   integer, intent(in) :: p

   integer :: na, nb, nv
   integer :: i, j

   double precision, allocatable, dimension(:) :: temp
   double precision :: inv_p

   nv = size(A, dim=1)

   na = size(A, dim=2)
   nb = size(B, dim=2)

   inv_p = 1.0d0/dble(p)

   allocate (temp(nv))

!$OMP PARALLEL DO PRIVATE(temp)
   do i = 1, nb
      do j = 1, na
         temp(:) = abs(A(:, j) - B(:, i))
         D(j, i) = (sum(temp**p))**inv_p
      end do
   end do
!$OMP END PARALLEL DO

   deallocate (temp)

end subroutine fp_distance_integer

subroutine fget_ef_gaussian_process_kernels_fchl(x1, x2, verbose, f1, f2, n1, n2, nneigh1, nneigh2, &
        & nm1, nm2, nsigmas, t_width, d_width, cut_start, cut_distance, order, pd, &
        & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, ef_scale,&
        & df, kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, get_pmax, get_selfscalar

   use ffchl_module_ef, only: get_ksi_ef_field, init_cosp_sinp_ef_field, get_ksi_ef, init_cosp_sinp_ef

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :), intent(in) :: x2

   ! Display output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Electric field perturbations for each molecule
   double precision, dimension(:, :), intent(in) :: f1
   double precision, dimension(:, :), intent(in) :: f2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :), intent(in) :: nneigh2

   ! Angular Gaussian width
   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   double precision, intent(in) :: ef_scale
   double precision, intent(in) :: df

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, 4*nm1, 4*nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j
   integer :: ni, nj
   integer :: a, b
   integer :: xyz, pm
   integer :: xyz1, pm1
   integer :: xyz2, pm2
   integer :: idx_a
   integer :: idx_b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :) :: self_scalar2
   double precision, allocatable, dimension(:, :, :, :) :: self_scalar1_ef
   double precision, allocatable, dimension(:, :, :, :) :: self_scalar2_ef

   ! Pre-computed two-body weights for nummerical differentation of electric field
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :) :: ksi2
   double precision, allocatable, dimension(:, :, :, :, :) :: ksi1_ef
   double precision, allocatable, dimension(:, :, :, :, :) :: ksi2_ef

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp2
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp1_ef
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp1_ef
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp2_ef
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp2_ef

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   ! Work for kernel
   integer :: n
   double precision, allocatable, dimension(:) :: ktmp

   n = size(parameters, dim=1)
   allocate (ktmp(n))

   kernels(:, :, :) = 0.0d0

   ! Get max number of neighbors
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! Calculate angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   ! pmax = max nuclear charge
   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax(x2, n2)

   ! Get two-body weight function
   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   call get_ksi_ef_field(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, &
               & f1, ef_scale, verbose, ksi1)
   !ksi1 = get_ksi_ef_field(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, &
   !            & f1, ef_scale, verbose)

   allocate (ksi1_ef(size(x1, dim=1), 3, 2, maxval(n1), maxval(nneigh1)))
   call get_ksi_ef(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, ef_scale, df, verbose, ksi1_ef)
   !ksi1_ef = get_ksi_ef(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, ef_scale, df, verbose)

   ! Get two-body weight function
   allocate (ksi2(size(x2, dim=1), maxval(n2), maxval(nneigh2)))
   allocate (ksi2_ef(size(x2, dim=1), 3, 2, maxval(n2), maxval(nneigh2)))
   call get_ksi_ef_field(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, &
               & f2, ef_scale, verbose, ksi2)
   call get_ksi_ef(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, ef_scale, df, verbose, ksi2_ef)
   !ksi2 = get_ksi_ef_field(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, &
   !            & f2, ef_scale, verbose)
   !ksi2_ef = get_ksi_ef(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, ef_scale, df, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_ef_field(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, f1, ef_scale, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2(nm2, maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2(nm2, maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_ef_field(x2, n2, nneigh2, three_body_power, order, cut_start, cut_distance, &
       & cosp2, sinp2, f2, ef_scale, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1_ef(nm1, 3, 2, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1_ef(nm1, 3, 2, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_ef(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1_ef, sinp1_ef, ef_scale, df, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2_ef(nm2, 3, 2, maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2_ef(nm2, 3, 2, maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_ef(x2, n2, nneigh2, three_body_power, order, cut_start, cut_distance, &
       & cosp2_ef, sinp2_ef, ef_scale, df, verbose)

   allocate (self_scalar1(nm1, maxval(n1)))
   allocate (self_scalar2(nm2, maxval(n2)))

   ! Pre-calculate self-scalar terms
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   !self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   ! Pre-calculate self-scalar terms
   call get_selfscalar(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)
   !self_scalar2 = get_selfscalar(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   ! Self-scalar derivatives
   allocate (self_scalar1_ef(nm1, 3, 2, maxval(n1)))
   do a = 1, nm1
      ni = n1(a)
      do xyz = 1, 3
         do pm = 1, 2
            do i = 1, ni

               self_scalar1_ef(a, xyz, pm, i) = scalar(x1(a, i, :, :), x1(a, i, :, :), nneigh1(a, i), nneigh1(a, i), &
                   & ksi1_ef(a, xyz, pm, i, :), ksi1_ef(a, xyz, pm, i, :), &
                   & sinp1_ef(a, xyz, pm, i, :, :, :), sinp1_ef(a, xyz, pm, i, :, :, :), &
                   & cosp1_ef(a, xyz, pm, i, :, :, :), cosp1_ef(a, xyz, pm, i, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

            end do
         end do
      end do
   end do

   ! Self-scalar derivatives
   allocate (self_scalar2_ef(nm2, 3, 2, maxval(n2)))
   do a = 1, nm2
      ni = n2(a)
      do xyz = 1, 3
         do pm = 1, 2
            do i = 1, ni

               self_scalar2_ef(a, xyz, pm, i) = scalar(x2(a, i, :, :), x2(a, i, :, :), nneigh2(a, i), nneigh2(a, i), &
                   & ksi2_ef(a, xyz, pm, i, :), ksi2_ef(a, xyz, pm, i, :), &
                   & sinp2_ef(a, xyz, pm, i, :, :, :), sinp2_ef(a, xyz, pm, i, :, :, :), &
                   & cosp2_ef(a, xyz, pm, i, :, :, :), cosp2_ef(a, xyz, pm, i, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

            end do
         end do
      end do
   end do

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj)
   do a = 1, nm1
      ni = n1(a)
      do i = 1, ni
         do b = 1, nm2
            nj = n2(b)
            do j = 1, nj

               s12 = scalar(x1(a, i, :, :), x2(b, j, :, :), &
                   & nneigh1(a, i), nneigh2(b, j), &
                   & ksi1(a, i, :), ksi2(b, j, :), &
                   & sinp1(a, i, :, :, :), sinp2(b, j, :, :, :), &
                   & cosp1(a, i, :, :, :), cosp2(b, j, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

               ktmp = 0.0d0
               call kernel(self_scalar1(a, i), self_scalar2(b, j), s12, kernel_idx, parameters, ktmp)
               kernels(:, a, b) = kernels(:, a, b) + ktmp

               !kernels(:, a, b) = kernels(:, a, b) &
               !    & + kernel(self_scalar1(a, i), self_scalar2(b, j), s12, &
               !    & kernel_idx, parameters)

            end do
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,idx_a,idx_b,ktmp)
   do a = 1, nm1
      ni = n1(a)
      do i = 1, ni

         idx_a = a

         do b = 1, nm2
            nj = n2(b)
            do j = 1, nj
            do xyz = 1, 3
               idx_b = (b - 1)*3 + xyz + nm2

               do pm = 1, 2

                  s12 = scalar(x1(a, i, :, :), x2(b, j, :, :), &
                      & nneigh1(a, i), nneigh2(b, j), &
                      & ksi1(a, i, :), ksi2_ef(b, xyz, pm, j, :), &
                      & sinp1(a, i, :, :, :), sinp2_ef(b, xyz, pm, j, :, :, :), &
                      & cosp1(a, i, :, :, :), cosp2_ef(b, xyz, pm, j, :, :, :), &
                      & t_width, d_width, cut_distance, order, &
                      & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                  ktmp = 0.0d0
                  call kernel(self_scalar1(a, i), self_scalar2_ef(b, xyz, pm, j), s12, kernel_idx, parameters, ktmp)

                  if (pm == 1) then

                     !kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
                     !    & + kernel(self_scalar1(a, i), self_scalar2_ef(b, xyz, pm, j), s12, &
                     !    & kernel_idx, parameters)/(2*df)

                     kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) + ktmp/(2*df)

                  else

                     !kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
                     !    & - kernel(self_scalar1(a, i), self_scalar2_ef(b, xyz, pm, j), s12, &
                     !    & kernel_idx, parameters)/(2*df)

                     kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) - ktmp/(2*df)

                  end if

               end do
            end do
            end do
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,idx_a,idx_b,ktmp)

   do a = 1, nm2
      ni = n2(a)
      do i = 1, ni

         idx_a = a

         do b = 1, nm1
            nj = n1(b)
            do j = 1, nj
            do xyz = 1, 3
               idx_b = (b - 1)*3 + xyz + nm1

               do pm = 1, 2

                  s12 = scalar(x2(a, i, :, :), x1(b, j, :, :), &
                      & nneigh2(a, i), nneigh1(b, j), &
                      & ksi2(a, i, :), ksi1_ef(b, xyz, pm, j, :), &
                      & sinp2(a, i, :, :, :), sinp1_ef(b, xyz, pm, j, :, :, :), &
                      & cosp2(a, i, :, :, :), cosp1_ef(b, xyz, pm, j, :, :, :), &
                      & t_width, d_width, cut_distance, order, &
                      & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                  ktmp = 0.0d0
                  call kernel(self_scalar2(a, i), self_scalar1_ef(b, xyz, pm, j), s12, &
                         & kernel_idx, parameters, ktmp)

                  if (pm == 1) then

                     ! kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
                     kernels(:, idx_b, idx_a) = kernels(:, idx_b, idx_a) + ktmp/(2*df)

                     !kernels(:, idx_b, idx_a) = kernels(:, idx_b, idx_a) &
                     !    & + kernel(self_scalar2(a, i), self_scalar1_ef(b, xyz, pm, j), s12, &
                     !    & kernel_idx, parameters)/(2*df)

                  else

                     ! kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
                     kernels(:, idx_b, idx_a) = kernels(:, idx_b, idx_a) - ktmp/(2*df)

                     !kernels(:, idx_b, idx_a) = kernels(:, idx_b, idx_a) &
                     !    & - kernel(self_scalar2(a, i), self_scalar1_ef(b, xyz, pm, j), s12, &
                     !    & kernel_idx, parameters)/(2*df)

                  end if

               end do
            end do
            end do
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   ! should be zero?

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,idx_a,idx_b)
   do a = 1, nm1

      ni = n1(a)
      do i = 1, ni
      do xyz1 = 1, 3
         idx_a = (a - 1)*3 + xyz1 + nm1
         do pm1 = 1, 2

            do b = 1, nm2

               nj = n2(b)
               do j = 1, nj
               do xyz2 = 1, 3
                  idx_b = (b - 1)*3 + xyz2 + nm2
                  do pm2 = 1, 2

                     s12 = scalar(x1(a, i, :, :), x2(b, j, :, :), &
                         & nneigh1(a, i), nneigh2(b, j), &
                         & ksi1_ef(a, xyz1, pm1, i, :), ksi2_ef(b, xyz2, pm2, j, :), &
                     & sinp1_ef(a, xyz1, pm1, i, :, :, :), sinp2_ef(b, xyz2, pm2, j, :, :, :), &
                     & cosp1_ef(a, xyz1, pm1, i, :, :, :), cosp2_ef(b, xyz2, pm2, j, :, :, :), &
                         & t_width, d_width, cut_distance, order, &
                         & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                     ktmp = 0.0d0
                     call kernel(self_scalar1_ef(a, xyz1, pm1, i), self_scalar2_ef(b, xyz2, pm2, j), s12, &
                            & kernel_idx, parameters, ktmp)

                     if (pm1 == pm2) then

                        kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) + ktmp/(4*df**2)

                        !        kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
                        !& + kernel(self_scalar1_ef(a, xyz1, pm1, i), self_scalar2_ef(b, xyz2, pm2, j), s12, &
                        !            & kernel_idx, parameters)/(4*df**2)

                     else

                        kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) - ktmp/(4*df**2)

                        !        kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
                        !& - kernel(self_scalar1_ef(a, xyz1, pm1, i), self_scalar2_ef(b, xyz2, pm2, j), s12, &
                        !            & kernel_idx, parameters)/(4*df**2)

                     end if

                  end do
               end do
               end do
            end do
         end do
      end do
      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (self_scalar1_ef)
   deallocate (ksi1)
   deallocate (ksi1_ef)
   deallocate (cosp1)
   deallocate (cosp1_ef)
   deallocate (sinp1)
   deallocate (sinp1_ef)

end subroutine fget_ef_gaussian_process_kernels_fchl

subroutine fget_ef_atomic_local_kernels_fchl(x1, x2, verbose, f2, n1, n2, nneigh1, nneigh2, nm1, nm2, nsigmas, na1, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, ef_scale,&
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, get_pmax, &
       & get_selfscalar, get_ksi, init_cosp_sinp

   use ffchl_module_ef, only: get_ksi_ef_field, init_cosp_sinp_ef_field

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :), intent(in) :: x2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Display output
   logical, intent(in) :: verbose

   ! Electric field perturbations for each molecule
   double precision, dimension(:, :), intent(in) :: f2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   integer, intent(in) :: na1

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :), intent(in) :: nneigh2

   ! Angular Gaussian width
   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   double precision, intent(in) :: ef_scale

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, na1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j
   integer :: ni, nj
   integer :: a, b
   integer :: idx1

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :) :: self_scalar2

   ! Pre-computed two-body weights for nummerical differentation of electric field
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :) :: ksi2

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp2

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   ! Work for kernel
   integer :: n
   double precision, allocatable, dimension(:) :: ktmp

   n = size(parameters, dim=1)
   allocate (ktmp(n))

   kernels(:, :, :) = 0.0d0

   ! Get max number of neighbors
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! Calculate angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   ! pmax = max nuclear charge
   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax(x2, n2)

   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), maxval(n2), maxval(nneigh2)))

   ! Get two-body weight function
   ! ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)

   ! Get two-body weight function
   call get_ksi_ef_field(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, &
               & f2, ef_scale, verbose, ksi2)
   !ksi2 = get_ksi_ef_field(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, &
   !            & f2, ef_scale, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2(nm2, maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2(nm2, maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_ef_field(x2, n2, nneigh2, three_body_power, order, cut_start, cut_distance, &
       & cosp2, sinp2, f2, ef_scale, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, maxval(n1)))
   allocate (self_scalar2(nm2, maxval(n2)))
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)
   call get_selfscalar(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)

   !self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   ! Pre-calculate self-scalar terms
   !self_scalar2 = get_selfscalar(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   kernels(:, :, :) = 0.0d0

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(ni,nj,idx1,s12,ktmp)
   do a = 1, nm1
      ni = n1(a)
      do i = 1, ni

         idx1 = sum(n1(:a)) - ni + i

         do b = 1, nm2
            nj = n2(b)
            do j = 1, nj

               s12 = scalar(x1(a, i, :, :), x2(b, j, :, :), &
                   & nneigh1(a, i), nneigh2(b, j), ksi1(a, i, :), ksi2(b, j, :), &
                   & sinp1(a, i, :, :, :), sinp2(b, j, :, :, :), &
                   & cosp1(a, i, :, :, :), cosp2(b, j, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                    & pd, ang_norm2, distance_scale, angular_scale, alchemy)

               ktmp = 0.0d0
               call kernel(self_scalar1(a, i), self_scalar2(b, j), s12, &
                   & kernel_idx, parameters, ktmp)

               kernels(:, idx1, b) = kernels(:, idx1, b) + ktmp

               !kernels(:, idx1, b) = kernels(:, idx1, b) &
               !    & + kernel(self_scalar1(a, i), self_scalar2(b, j), s12, &
               !     & kernel_idx, parameters)

            end do
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (self_scalar2)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (cosp2)
   deallocate (sinp1)
   deallocate (sinp2)

end subroutine fget_ef_atomic_local_kernels_fchl

subroutine fget_ef_atomic_local_gradient_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, nm1, nm2, na1, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, ef_scale,&
       & df, kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, get_pmax, get_ksi, init_cosp_sinp, get_selfscalar

   use ffchl_module_ef, only: get_ksi_ef, init_cosp_sinp_ef

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :), intent(in) :: x2

   ! Display output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of atoms in set 1
   integer, intent(in) :: na1

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :), intent(in) :: nneigh2

   ! Angular Gaussian width
   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   double precision, intent(in) :: ef_scale
   double precision, intent(in) :: df

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, na1, nm2*3), intent(out) :: kernels

   ! Internal counters
   integer :: i, j
   integer :: ni, nj
   integer :: a, b
   integer :: xyz, pm
   integer :: idx_a
   integer :: idx_b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :, :, :) :: self_scalar2_ef

   ! Pre-computed two-body weights for nummerical differentation of electric field
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :, :, :) :: ksi2_ef

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp2_ef
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp2_ef

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   ! Work for kernel
   integer :: n
   double precision, allocatable, dimension(:) :: ktmp

   n = size(parameters, dim=1)
   allocate (ktmp(n))

   kernels(:, :, :) = 0.0d0

   ! Get max number of neighbors
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! Calculate angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   ! pmax = max nuclear charge
   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax(x2, n2)

   ! Get two-body weight function
   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2_ef(size(x2, dim=1), 3, 2, maxval(n2), maxval(nneigh2)))
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi_ef(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, ef_scale, df, verbose, ksi2_ef)
   !ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   !ksi2_ef = get_ksi_ef(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, ef_scale, df, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2_ef(nm2, 3, 2, maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2_ef(nm2, 3, 2, maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_ef(x2, n2, nneigh2, three_body_power, order, cut_start, cut_distance, &
       & cosp2_ef, sinp2_ef, ef_scale, df, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, maxval(n1)))
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   !self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   allocate (self_scalar2_ef(nm2, 3, 2, maxval(n2)))
   do a = 1, nm2
      ni = n2(a)
      do xyz = 1, 3
         do pm = 1, 2
            do i = 1, ni

               self_scalar2_ef(a, xyz, pm, i) = scalar(x2(a, i, :, :), x2(a, i, :, :), nneigh2(a, i), nneigh2(a, i), &
                   & ksi2_ef(a, xyz, pm, i, :), ksi2_ef(a, xyz, pm, i, :), &
                   & sinp2_ef(a, xyz, pm, i, :, :, :), sinp2_ef(a, xyz, pm, i, :, :, :), &
                   & cosp2_ef(a, xyz, pm, i, :, :, :), cosp2_ef(a, xyz, pm, i, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

            end do
         end do
      end do
   end do

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,idx_a,idx_b,ktmp)

   do a = 1, nm1
      ni = n1(a)
      do i = 1, ni

         idx_a = sum(n1(:a)) - ni + i

         do b = 1, nm2
            nj = n2(b)
            do j = 1, nj
            do xyz = 1, 3
               idx_b = (b - 1)*3 + xyz

               do pm = 1, 2

                  s12 = scalar(x1(a, i, :, :), x2(b, j, :, :), &
                      & nneigh1(a, i), nneigh2(b, j), &
                      & ksi1(a, i, :), ksi2_ef(b, xyz, pm, j, :), &
                      & sinp1(a, i, :, :, :), sinp2_ef(b, xyz, pm, j, :, :, :), &
                      & cosp1(a, i, :, :, :), cosp2_ef(b, xyz, pm, j, :, :, :), &
                      & t_width, d_width, cut_distance, order, &
                      & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                  ktmp = 0.0d0
                  call kernel(self_scalar1(a, i), self_scalar2_ef(b, xyz, pm, j), s12, &
                        & kernel_idx, parameters, ktmp)

                  if (pm == 1) then

                     kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) + ktmp

                     !kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
                     !    & + kernel(self_scalar1(a, i), self_scalar2_ef(b, xyz, pm, j), s12, &
                     !    & kernel_idx, parameters)

                  else

                     kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) - ktmp

                     !kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
                     !    & - kernel(self_scalar1(a, i), self_scalar2_ef(b, xyz, pm, j), s12, &
                     !    & kernel_idx, parameters)

                  end if

               end do
            end do
            end do
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   kernels = kernels/(2*df)

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (self_scalar2_ef)
   deallocate (ksi1)
   deallocate (ksi2_ef)
   deallocate (cosp1)
   deallocate (cosp2_ef)
   deallocate (sinp1)
   deallocate (sinp2_ef)

end subroutine fget_ef_atomic_local_gradient_kernels_fchl

! subroutine fget_ef_local_hessian_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, nm1, nm2, nsigmas, &
!        & t_width, d_width, cut_start, cut_distance, order, pd, &
!        & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, &
!        & ef_scale, df, kernel_idx, parameters, kernels)
!
!     use ffchl_module, only: scalar, get_angular_norm2, get_pmax, get_ksi, init_cosp_sinp, &
!         & get_selfscalar, get_ksi_ef, init_cosp_sinp_ef
!
!     use ffchl_kernels, only: kernel
!
!     use omp_lib, only: omp_get_wtime
!
!     implicit none
!
!     ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
!     double precision, dimension(:,:,:,:), intent(in) :: x1
!     double precision, dimension(:,:,:,:), intent(in) :: x2
!
!     ! Display output
!     logical, intent(in) :: verbose
!
!     ! List of numbers of atoms in each molecule
!     integer, dimension(:), intent(in) :: n1
!     integer, dimension(:), intent(in) :: n2
!
!     ! Number of molecules
!     integer, intent(in) :: nm1
!     integer, intent(in) :: nm2
!
!     ! Number of sigmas
!     integer, intent(in) :: nsigmas
!
!     ! Number of neighbors for each atom in each compound
!     integer, dimension(:,:), intent(in) :: nneigh1
!     integer, dimension(:,:), intent(in) :: nneigh2
!
!     ! Angular Gaussian width
!     double precision, intent(in) :: t_width
!
!     ! Distance Gaussian width
!     double precision, intent(in) :: d_width
!
!     ! Fraction of cut_distance at which cut-off starts
!     double precision, intent(in) :: cut_start
!     double precision, intent(in) :: cut_distance
!
!     ! Truncation order for Fourier terms
!     integer, intent(in) :: order
!
!     ! Periodic table distance matrix
!     double precision, dimension(:,:), intent(in) :: pd
!
!     ! Scaling for angular and distance terms
!     double precision, intent(in) :: distance_scale
!     double precision, intent(in) :: angular_scale
!
!     ! Switch alchemy on or off
!     logical, intent(in) :: alchemy
!
!     ! Decaying power laws for two- and three-body terms
!     double precision, intent(in) :: two_body_power
!     double precision, intent(in) :: three_body_power
!
!     double precision, intent(in) :: ef_scale
!     double precision, intent(in) :: df
!
!     ! Kernel ID and corresponding parameters
!     integer, intent(in) :: kernel_idx
!     double precision, dimension(:,:), intent(in) :: parameters
!
!     ! Resulting alpha vector
!     ! double precision, dimension(nsigmas,nm1,nm2), intent(out) :: kernels
!     double precision, dimension(nsigmas,nm1*3,nm2*3), intent(out) :: kernels
!
!     double precision, dimension(nsigmas):: kernel_sum1
!     double precision, dimension(nsigmas):: kernel_sum2
!
!     ! Internal counters
!     integer :: i, j
!     integer :: ni, nj
!     integer :: a, b
!     integer :: xyz, pm
!     integer :: xyz1, pm1
!     integer :: xyz2, pm2
!
!     integer :: idx_a, idx_b
!
!     ! Temporary variables necessary for parallelization
!     double precision :: s12
!
!     ! Pre-computed terms in the full distance matrix
!     double precision, allocatable, dimension(:,:,:,:) :: self_scalar1_ef
!     double precision, allocatable, dimension(:,:,:,:) :: self_scalar2_ef
!
!     ! Pre-computed two-body weights for nummerical differentation of electric field
!     double precision, allocatable, dimension(:,:,:,:,:) :: ksi1_ef
!     double precision, allocatable, dimension(:,:,:,:,:) :: ksi2_ef
!
!     ! ! Pre-computed terms for the Fourier expansion of the three-body term
!     double precision, allocatable, dimension(:,:,:,:,:,:,:) :: sinp1_ef
!     double precision, allocatable, dimension(:,:,:,:,:,:,:) :: sinp2_ef
!     double precision, allocatable, dimension(:,:,:,:,:,:,:) :: cosp1_ef
!     double precision, allocatable, dimension(:,:,:,:,:,:,:) :: cosp2_ef
!
!     ! Max index in the periodic table
!     integer :: pmax1
!     integer :: pmax2
!
!     ! Angular normalization constant
!     double precision :: ang_norm2
!
!     ! Max number of neighbors
!     integer :: maxneigh1
!     integer :: maxneigh2
!
!     ! Variables to calculate time
!     double precision :: t_start, t_end
!
!     write (*,*) "CLEARING KERNEL MEM"
!     kernels(:,:,:) = 0.0d0
!
!     ! Get max number of neighbors
!     maxneigh1 = maxval(nneigh1)
!     maxneigh2 = maxval(nneigh2)
!
!     ! Calculate angular normalization constant
!     ang_norm2 = get_angular_norm2(t_width)
!
!     ! pmax = max nuclear charge
!     pmax1 = get_pmax(x1, n1)
!     pmax2 = get_pmax(x2, n2)
!
!
!     ! Get two-body weight function
!     ksi1_ef = get_ksi_ef(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, ef_scale, df)
!     ksi2_ef = get_ksi_ef(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, ef_scale, df)
!
!
!     ! Allocate three-body Fourier terms
!     allocate(cosp1_ef(nm1, 3, 2, maxval(n1), pmax1, order, maxneigh1))
!     allocate(sinp1_ef(nm1, 3, 2, maxval(n1), pmax1, order, maxneigh1))
!
!     ! Initialize and pre-calculate three-body Fourier terms
!     call init_cosp_sinp_ef(x1, n1, nneigh1, three_body_power, order, cut_start,  cut_distance, &
!         & cosp1_ef, sinp1_ef, ef_scale, df)
!
!
!     ! Allocate three-body Fourier terms
!     allocate(cosp2_ef(nm2, 3, 2, maxval(n2), pmax2, order, maxneigh2))
!     allocate(sinp2_ef(nm2, 3, 2, maxval(n2), pmax2, order, maxneigh2))
!
!     ! Initialize and pre-calculate three-body Fourier terms
!     call init_cosp_sinp_ef(x2, n2, nneigh2, three_body_power, order, cut_start, cut_distance, &
!         & cosp2_ef, sinp2_ef, ef_scale, df)
!
!
!     allocate(self_scalar1_ef(nm1, 3,2, maxval(n1)))
!     do a = 1, nm1
!         ni = n1(a)
!         do xyz = 1, 3
!             do pm = 1, 2
!                 do i = 1, ni
!
!                     self_scalar1_ef(a,xyz,pm,i) = scalar(x1(a,i,:,:), x1(a,i,:,:), nneigh1(a,i), nneigh1(a,i), &
!                         & ksi1_ef(a,xyz,pm,i,:), ksi1_ef(a,xyz,pm,i,:), &
!                         & sinp1_ef(a,xyz,pm,i,:,:,:), sinp1_ef(a,xyz,pm,i,:,:,:), &
!                         & cosp1_ef(a,xyz,pm,i,:,:,:), cosp1_ef(a,xyz,pm,i,:,:,:), &
!                         & t_width, d_width, cut_distance, order, &
!                         & pd, ang_norm2, distance_scale, angular_scale, alchemy)
!
!                 enddo
!             enddo
!         enddo
!     enddo
!
!
!     allocate(self_scalar2_ef(nm2, 3,2, maxval(n2)))
!     do a = 1, nm2
!         ni = n2(a)
!         do xyz = 1, 3
!             do pm = 1, 2
!                 do i = 1, ni
!
!                     self_scalar2_ef(a,xyz,pm,i) = scalar(x2(a,i,:,:), x2(a,i,:,:), nneigh2(a,i), nneigh2(a,i), &
!                         & ksi2_ef(a,xyz,pm,i,:), ksi2_ef(a,xyz,pm,i,:), &
!                         & sinp2_ef(a,xyz,pm,i,:,:,:), sinp2_ef(a,xyz,pm,i,:,:,:), &
!                         & cosp2_ef(a,xyz,pm,i,:,:,:), cosp2_ef(a,xyz,pm,i,:,:,:), &
!                         & t_width, d_width, cut_distance, order, &
!                         & pd, ang_norm2, distance_scale, angular_scale, alchemy)
!
!                 enddo
!             enddo
!         enddo
!     enddo
!
!     t_start = omp_get_wtime()
!     write (*,"(A)", advance="no") "KERNEL"
!
!     !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,idx_a,idx_b,kernel_sum1,kernel_sum2)
!     do b = 1, nm2
!     nj = n2(b)
!     do j = 1, nj
!
!         do a = 1, nm1
!         ni = n1(a)
!         do i = 1, ni
!
!             do xyz1 = 1, 3
!             do xyz2 = 1, 3
!
!                 idx_a = (a - 1) * 3 + xyz1
!                 idx_b = (b - 1) * 3 + xyz2
!
!                 do pm1 = 1, 2
!                 do pm2 = 1, 2
!
!                     s12 = scalar(x1(a,i,:,:), x2(b,j,:,:), &
!                         & nneigh1(a,i), nneigh2(b,j), &
!                         & ksi1_ef(a,xyz1,pm1,i,:), ksi2_ef(b,xyz2,pm2,j,:), &
!                         & sinp1_ef(a,xyz1,pm1,i,:,:,:), sinp2_ef(b,xyz2,pm2,j,:,:,:), &
!                         & cosp1_ef(a,xyz1,pm1,i,:,:,:), cosp2_ef(b,xyz2,pm2,j,:,:,:), &
!                         & t_width, d_width, cut_distance, order, &
!                         & pd, ang_norm2, distance_scale, angular_scale, alchemy)
!
!
!                     if (pm1 == pm2) then
!
!                         kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
!                             & + kernel(self_scalar1_ef(a,xyz1,pm1,i),  self_scalar2_ef(b,xyz2,pm2,j), s12, &
!                             & kernel_idx, parameters)
!                     else
!
!                         kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
!                             & - kernel(self_scalar1_ef(a,xyz1,pm1,i),  self_scalar2_ef(b,xyz2,pm2,j), s12, &
!                             & kernel_idx, parameters)
!
!                     endif
!             enddo
!             enddo
!         enddo
!         enddo
!         enddo
!     enddo
!     enddo
!     enddo
!     !$OMP END PARALLEL DO
!
!     kernels = kernels / (4 * df**2)
!
!     t_end = omp_get_wtime()
!     write (*,"(A,F12.4,A)") "                                  Time = ", t_end - t_start, " s"
!
! end subroutine fget_ef_local_hessian_kernels_fchl

! TODO: Fix, experimental code for polarizability

! subroutine fget_kernels_fchl_ef_2ndderiv(x1, x2, n1, n2, nneigh1, nneigh2, nm1, nm2, na1, nsigmas, &
!        & t_width, d_width, cut_start, cut_distance, order, pd, &
!        & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, ef_scale,&
!        & df, kernel_idx, parameters, kernels)

!     use ffchl_module, only: scalar, get_angular_norm2, get_pmax, get_ksi, init_cosp_sinp, &
!         & get_selfscalar, get_ksi_pol, init_cosp_sinp_pol

!     use ffchl_kernels, only: kernel

!     use omp_lib, only: omp_get_wtime

!     implicit none

!     ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
!     double precision, dimension(:,:,:,:), intent(in) :: x1
!     double precision, dimension(:,:,:,:), intent(in) :: x2

!     ! List of numbers of atoms in each molecule
!     integer, dimension(:), intent(in) :: n1
!     integer, dimension(:), intent(in) :: n2

!     ! Number of molecules
!     integer, intent(in) :: nm1
!     integer, intent(in) :: nm2

!     ! Number of atoms in set 1
!     integer, intent(in) :: na1

!     ! Number of sigmas
!     integer, intent(in) :: nsigmas

!     ! Number of neighbors for each atom in each compound
!     integer, dimension(:,:), intent(in) :: nneigh1
!     integer, dimension(:,:), intent(in) :: nneigh2

!     ! Angular Gaussian width
!     double precision, intent(in) :: t_width

!     ! Distance Gaussian width
!     double precision, intent(in) :: d_width

!     ! Fraction of cut_distance at which cut-off starts
!     double precision, intent(in) :: cut_start
!     double precision, intent(in) :: cut_distance

!     ! Truncation order for Fourier terms
!     integer, intent(in) :: order

!     ! Periodic table distance matrix
!     double precision, dimension(:,:), intent(in) :: pd

!     ! Scaling for angular and distance terms
!     double precision, intent(in) :: distance_scale
!     double precision, intent(in) :: angular_scale

!     ! Switch alchemy on or off
!     logical, intent(in) :: alchemy

!     ! Decaying power laws for two- and three-body terms
!     double precision, intent(in) :: two_body_power
!     double precision, intent(in) :: three_body_power

!     double precision, intent(in) :: ef_scale
!     double precision, intent(in) :: df

!     ! Kernel ID and corresponding parameters
!     integer, intent(in) :: kernel_idx
!     double precision, dimension(:,:), intent(in) :: parameters

!     ! Resulting alpha vector
!     ! double precision, dimension(nsigmas,nm1,nm2), intent(out) :: kernels
!     ! double precision, dimension(nsigmas,na1,nm2*3), intent(out) :: kernels
!     double precision, dimension(nsigmas,na1,na1*3), intent(out) :: kernels

!     ! Internal counters
!     integer :: i, j
!     integer :: ni, nj
!     integer :: a, b
!     integer :: xyz, pm
!     integer :: idx_a
!     integer :: idx_b
!     integer :: qidx

!     ! Temporary variables necessary for parallelization
!     double precision :: s12

!     ! Pre-computed terms in the full distance matrix
!     double precision, allocatable, dimension(:,:) :: self_scalar1
!     double precision, allocatable, dimension(:,:,:) :: self_scalar2_pol

!     ! Pre-computed two-body weights for nummerical differentation of electric field
!     double precision, allocatable, dimension(:,:,:) :: ksi1
!     double precision, allocatable, dimension(:,:,:,:) :: ksi2_pol

!     ! Pre-computed terms for the Fourier expansion of the three-body term
!     double precision, allocatable, dimension(:,:,:,:,:) :: sinp1
!     double precision, allocatable, dimension(:,:,:,:,:) :: cosp1
!     double precision, allocatable, dimension(:,:,:,:,:,:) :: sinp2_pol
!     double precision, allocatable, dimension(:,:,:,:,:,:) :: cosp2_pol

!     double precision, dimension(nsigmas) :: unperturbed
!     double precision, dimension(nsigmas) :: test_plus, test_minus

!     integer, dimension(3,2) :: idx

!     ! Max index in the periodic table
!     integer :: pmax1
!     integer :: pmax2

!     ! Angular normalization constant
!     double precision :: ang_norm2

!     ! Max number of neighbors
!     integer :: maxneigh1
!     integer :: maxneigh2

!     ! Variables to calculate time
!     double precision :: t_start, t_end

!     write (*,*) "CLEARING KERNEL MEM"
!     kernels(:,:,:) = 0.0d0

!     ! Get max number of neighbors
!     maxneigh1 = maxval(nneigh1)
!     maxneigh2 = maxval(nneigh2)

!     ! Calculate angular normalization constant
!     ang_norm2 = get_angular_norm2(t_width)

!     ! pmax = max nuclear charge
!     pmax1 = get_pmax(x1, n1)
!     pmax2 = get_pmax(x2, n2)

!     ! Get two-body weight function
!     ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance)
!     ksi2_pol = get_ksi_pol(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, ef_scale, df)

!     ! Allocate three-body Fourier terms
!     allocate(cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
!     allocate(sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

!     ! Initialize and pre-calculate three-body Fourier terms
!     call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start,  cut_distance, &
!         & cosp1, sinp1)

!     ! Allocate three-body Fourier terms
!     allocate(cosp2_pol(nm2, 19, maxval(n2), pmax2, order, maxneigh2))
!     allocate(sinp2_pol(nm2, 19, maxval(n2), pmax2, order, maxneigh2))

!     ! Initialize and pre-calculate three-body Fourier terms
!     call init_cosp_sinp_pol(x2, n2, nneigh2, three_body_power, order, cut_start, cut_distance, &
!         & cosp2_pol, sinp2_pol, ef_scale, df)

!     ! Pre-calculate self-scalar terms
!     self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
!          & cut_distance, order, pd, ang_norm2,distance_scale, angular_scale, alchemy)

!     allocate(self_scalar2_pol(nm2, 19, maxval(n2)))
!     do a = 1, nm2
!         ni = n2(a)
!         do xyz = 1, 19
!             do i = 1, ni

!                 self_scalar2_pol(a,xyz,i) = scalar(x2(a,i,:,:), x2(a,i,:,:), &
!                     & nneigh2(a,i), nneigh2(a,i), &
!                     & ksi2_pol(a,xyz,i,:), ksi2_pol(a,xyz,i,:), &
!                     & sinp2_pol(a,xyz,i,:,:,:), sinp2_pol(a,xyz,i,:,:,:), &
!                     & cosp2_pol(a,xyz,i,:,:,:), cosp2_pol(a,xyz,i,:,:,:), &
!                     & t_width, d_width, cut_distance, order, &
!                     & pd, ang_norm2, distance_scale, angular_scale, alchemy)

!             enddo
!         enddo
!     enddo

!     t_start = omp_get_wtime()
!     write (*,"(A)", advance="no") "KERNEL EF DERIVATIVE"

!     idx(1,:) = (/ 17,  3 /) !xx = (17) + (3) - 2*10
!     idx(2,:) = (/ 11,  9 /) !yy = (11) + (9) - 2*10
!     idx(3,:) = (/ 13,  7 /) !zz = (13) + (7) - 2*10

!     ! Loop over atoms/basis functions
!     ! !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,idx_a,idx_b)
!     do a = 1, nm1
!     ni = n1(a)
!     do i = 1, ni
!     idx_a = sum(n1(:a)) - ni + i

!         do b = 1, nm2
!             nj = n2(b)

!             do j = 1, nj

!                 ! Precalculate L2 for unperturbed kernel (charge index = 10)
!                 qidx = 10

!                 ! write(*,*) qidx
!                 ! isotropic (XX, YY and ZZ)
!                 s12 = scalar(x1(a,i,:,:), x2(b,j,:,:), &
!                 & nneigh1(a,i), nneigh2(b,j), &
!                 & ksi1(a,i,:), ksi2_pol(b,qidx,j,:), &
!                     & sinp1(a,i,:,:,:), sinp2_pol(b,qidx,j,:,:,:), &
!                     & cosp1(a,i,:,:,:), cosp2_pol(b,qidx,j,:,:,:), &
!                     & t_width, d_width, cut_distance, order, &
!                     & pd, ang_norm2, distance_scale, angular_scale, alchemy)

!                 unperturbed(:) = kernel(self_scalar1(a,i),  self_scalar2_pol(b,qidx,j), s12, &
!                     & kernel_idx, parameters)
!                 ! write(*,*) s12, unperturbed(:)

!                 do xyz = 1, 3

!                     ! idx_b = (b - 1) * 3 + xyz
!                     idx_b = (sum(n2(:b)) - nj + j) * 3 + xyz

!                     qidx = idx(xyz,1)
!                     ! write(*,*) xyz, qidx

!                     s12 = scalar(x1(a,i,:,:), x2(b,j,:,:), &
!                         & nneigh1(a,i), nneigh2(b,j), &
!                         & ksi1(a,i,:), ksi2_pol(b,qidx,j,:), &
!                         & sinp1(a,i,:,:,:), sinp2_pol(b,qidx,j,:,:,:), &
!                         & cosp1(a,i,:,:,:), cosp2_pol(b,qidx,j,:,:,:), &
!                         & t_width, d_width, cut_distance, order, &
!                         & pd, ang_norm2, distance_scale, angular_scale, alchemy)

!                     kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
!                         & + kernel(self_scalar1(a,i),  self_scalar2_pol(b,qidx,j), s12, &
!                         & kernel_idx, parameters)

!                     test_plus(:) = kernel(self_scalar1(a,i),  self_scalar2_pol(b,qidx,j), s12, &
!                         & kernel_idx, parameters)

!                     qidx = idx(xyz,2)
!                     ! write(*,*) qidx
!                     ! write(*,*) xyz, qidx

!                     ! write(*,*) s12, kernel(self_scalar1(a,i),  self_scalar2_pol(b,qidx,j), s12, kernel_idx, parameters)

!                     s12 = scalar(x1(a,i,:,:), x2(b,j,:,:), &
!                         & nneigh1(a,i), nneigh2(b,j), &
!                         & ksi1(a,i,:), ksi2_pol(b,qidx,j,:), &
!                         & sinp1(a,i,:,:,:), sinp2_pol(b,qidx,j,:,:,:), &
!                         & cosp1(a,i,:,:,:), cosp2_pol(b,qidx,j,:,:,:), &
!                         & t_width, d_width, cut_distance, order, &
!                         & pd, ang_norm2, distance_scale, angular_scale, alchemy)

!                     kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) &
!                         & + kernel(self_scalar1(a,i),  self_scalar2_pol(b,qidx,j), s12, &
!                         & kernel_idx, parameters)

!                     test_minus(:) = kernel(self_scalar1(a,i),  self_scalar2_pol(b,qidx,j), s12, &
!                         & kernel_idx, parameters)

!                     ! write(*,*) s12, kernel(self_scalar1(a,i),  self_scalar2_pol(b,qidx,j), s12, kernel_idx, parameters)

!                     write(*,*) kernels(:, idx_a, idx_b)
!                     kernels(:, idx_a, idx_b) = kernels(:, idx_a, idx_b) - 2* unperturbed(:)
!                     write(*,*) kernels(:, idx_a, idx_b)
!                     !  write(*,*) unperturbed(:)
!                     !  write(*,*) - 2* unperturbed(:)
!                     !  write(*,*) test_plus(:)
!                     !  write(*,*) test_minus(:)
!                     !  write(*,*) kernels(:, idx_a, idx_b)

!                 enddo
!             enddo
!         enddo

!     enddo
!     enddo
!     ! !$OMP END PARALLEL DO

!     t_end = omp_get_wtime()
!     write (*,"(A,F12.4,A)") "                    Time = ", t_end - t_start, " s"

!     write(*,*) "DF = ", df

!     write (*,*) kernels(1,1,1)
!     kernels(:,:,:) = kernels(:,:,:) / (df * df)
!     write (*,*) kernels(1,1,1)

!     deallocate(self_scalar1)
!     deallocate(self_scalar2_pol)
!     deallocate(ksi1)
!     deallocate(ksi2_pol)
!     deallocate(cosp1)
!     deallocate(cosp2_pol)
!     deallocate(sinp1)
!     deallocate(sinp2_pol)

! end subroutine fget_kernels_fchl_ef_2ndderiv

subroutine fget_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, nm1, nm2, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, get_pmax, get_ksi, init_cosp_sinp, get_selfscalar

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :), intent(in) :: nneigh2

   ! Angular Gaussian width
   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j
   integer :: ni, nj
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :) :: self_scalar2

   ! Pre-computed two-body weights
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :) :: ksi2

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp2

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   ! Work kernel space
   integer :: n
   double precision, allocatable, dimension(:) :: ktmp

   kernels(:, :, :) = 0.0d0

   ! Get max number of neighbors
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! Calculate angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   ! pmax = max nuclear charge
   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax(x2, n2)

   ! Get two-body weight function
   !ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   !ksi2 = get_ksi(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   !  subroutine get_ksi(x, na, nneigh, two_body_power, cut_start, cut_distance, verbose, ksi)! result(ksi)
   ! maxneigh = maxval(nneigh)
   ! maxatoms = maxval(na)
   ! nm = size(x, dim=1)
   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), maxval(n2), maxval(nneigh2)))
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)

   n = size(parameters, dim=1)
   allocate (ktmp(n))

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2(nm2, maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2(nm2, maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp(x2, n2, nneigh2, three_body_power, order, cut_start, cut_distance, &
       & cosp2, sinp2, verbose)

   ! Pre-calculate self-scalar terms
   !self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)
   allocate (self_scalar1(nm1, maxval(n1)))
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose,&
 &self_scalar1)

   ! Pre-calculate self-scalar terms
   !self_scalar2 = get_selfscalar(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)
   allocate (self_scalar2(nm2, maxval(n2)))
   call get_selfscalar(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose,&
    &self_scalar2)

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,ktmp)
   do b = 1, nm2
      nj = n2(b)
      do a = 1, nm1
         ni = n1(a)

         do i = 1, ni
            do j = 1, nj

               s12 = scalar(x1(a, i, :, :), x2(b, j, :, :), &
                   & nneigh1(a, i), nneigh2(b, j), ksi1(a, i, :), ksi2(b, j, :), &
                   & sinp1(a, i, :, :, :), sinp2(b, j, :, :, :), &
                   & cosp1(a, i, :, :, :), cosp2(b, j, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

               !kernels(:, a, b) = kernels(:, a, b) &
               !    & + kernel(self_scalar1(a, i), self_scalar2(b, j), s12, &
               !    & kernel_idx, parameters)

               ktmp = 0.0d0
               call kernel(self_scalar1(a, i), self_scalar2(b, j), s12, &
               & kernel_idx, parameters, ktmp)
               kernels(:, a, b) = kernels(:, a, b) + ktmp

            end do
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (self_scalar2)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (cosp2)
   deallocate (sinp1)
   deallocate (sinp2)

end subroutine fget_kernels_fchl

subroutine fget_symmetric_kernels_fchl(x1, verbose, n1, nneigh1, nm1, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, get_pmax, get_ksi, init_cosp_sinp, get_selfscalar

   use ffchl_kernels, only: kernel

   implicit none

   ! FCHL descriptors for the training set, format (i,j_1,5,m_1)
   double precision, dimension(:, :, :, :), intent(in) :: x1

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1

   ! Number of molecules
   integer, intent(in) :: nm1

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   double precision, intent(in) :: t_width
   double precision, intent(in) :: d_width
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance
   integer, intent(in) :: order
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   logical, intent(in) :: alchemy
   double precision, dimension(:, :), intent(in) :: pd

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm1), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, ni, nj
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1

   ! Pre-computed terms
   double precision, allocatable, dimension(:, :, :) :: ksi1

   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1

   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! counter for periodic distance
   integer :: pmax1
   ! integer :: nneighi

   double precision :: ang_norm2

   integer :: maxneigh1

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp

   kernels(:, :, :) = 0.0d0

   ang_norm2 = get_angular_norm2(t_width)

   maxneigh1 = maxval(nneigh1)
   pmax1 = get_pmax(x1, n1)

   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   !ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)

   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxval(nneigh1)))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxval(nneigh1)))

   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   allocate (self_scalar1(nm1, maxval(n1)))
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   !self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   allocate (ktmp(size(parameters, dim=1)))

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,ktmp)
   do b = 1, nm1
      nj = n1(b)
      do a = b, nm1
         ni = n1(a)

         do i = 1, ni
            do j = 1, nj

               s12 = scalar(x1(a, i, :, :), x1(b, j, :, :), &
                   & nneigh1(a, i), nneigh1(b, j), ksi1(a, i, :), ksi1(b, j, :), &
                   & sinp1(a, i, :, :, :), sinp1(b, j, :, :, :), &
                   & cosp1(a, i, :, :, :), cosp1(b, j, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

               ktmp(:) = 0.0d0
               call kernel(self_scalar1(a, i), self_scalar1(b, j), s12, &
                   & kernel_idx, parameters, ktmp)

               kernels(:, a, b) = kernels(:, a, b) + ktmp
               !kernels(:, a, b) = kernels(:, a, b) &
               !    & + kernel(self_scalar1(a, i), self_scalar1(b, j), s12, &
               !    & kernel_idx, parameters)

               kernels(:, b, a) = kernels(:, a, b)

            end do
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (ksi1)
   deallocate (cosp1)
   deallocate (sinp1)

end subroutine fget_symmetric_kernels_fchl

subroutine fget_global_symmetric_kernels_fchl(x1, verbose, n1, nneigh1, nm1, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, get_pmax, get_ksi, init_cosp_sinp
   use ffchl_kernels, only: kernel

   implicit none

   ! FCHL descriptors for the training set, format (i,j_1,5,m_1)
   double precision, dimension(:, :, :, :), intent(in) :: x1

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1

   ! Number of molecules
   integer, intent(in) :: nm1

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   double precision, intent(in) :: t_width
   double precision, intent(in) :: d_width
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance
   integer, intent(in) :: order
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale
   logical, intent(in) :: alchemy

   double precision, dimension(:, :), intent(in) :: pd

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm1), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, ni, nj
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:) :: self_scalar1

   ! Pre-computed terms
   double precision, allocatable, dimension(:, :, :) :: ksi1

   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1

   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! counter for periodic distance
   integer :: pmax1

   double precision :: ang_norm2

   double precision :: mol_dist

   integer :: maxneigh1

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   maxneigh1 = maxval(nneigh1)

   ang_norm2 = get_angular_norm2(t_width)

   pmax1 = get_pmax(x1, n1)

   !ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)

   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxval(nneigh1)))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxval(nneigh1)))

   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   allocate (self_scalar1(nm1))

   self_scalar1 = 0.0d0

   !$OMP PARALLEL DO PRIVATE(ni) REDUCTION(+:self_scalar1)
   do a = 1, nm1
      ni = n1(a)
      do i = 1, ni
         do j = 1, ni

            self_scalar1(a) = self_scalar1(a) + scalar(x1(a, i, :, :), x1(a, j, :, :), &
                & nneigh1(a, i), nneigh1(a, j), ksi1(a, i, :), ksi1(a, j, :), &
                & sinp1(a, i, :, :, :), sinp1(a, j, :, :, :), &
                & cosp1(a, i, :, :, :), cosp1(a, j, :, :, :), &
                & t_width, d_width, cut_distance, order, &
                & pd, ang_norm2, distance_scale, angular_scale, alchemy)
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   kernels(:, :, :) = 0.0d0

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,mol_dist,ktmp)
   do b = 1, nm1
      nj = n1(b)
      do a = b, nm1
         ni = n1(a)

         mol_dist = 0.0d0

         do i = 1, ni
            do j = 1, nj

               s12 = scalar(x1(a, i, :, :), x1(b, j, :, :), &
                   & nneigh1(a, i), nneigh1(b, j), ksi1(a, i, :), ksi1(b, j, :), &
                   & sinp1(a, i, :, :, :), sinp1(b, j, :, :, :), &
                   & cosp1(a, i, :, :, :), cosp1(b, j, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

               mol_dist = mol_dist + s12

            end do
         end do

         ktmp = 0.0d0
         call kernel(self_scalar1(a), self_scalar1(b), mol_dist, &
             & kernel_idx, parameters, ktmp)
         kernels(:, a, b) = ktmp
         !kernels(:, a, b) = kernel(self_scalar1(a), self_scalar1(b), mol_dist, &
         !    & kernel_idx, parameters)

         kernels(:, b, a) = kernels(:, a, b)

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (ksi1)
   deallocate (cosp1)
   deallocate (sinp1)

end subroutine fget_global_symmetric_kernels_fchl

subroutine fget_global_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, &
       & nm1, nm2, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, get_pmax, get_ksi, init_cosp_sinp
   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :), intent(in) :: nneigh2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   double precision, intent(in) :: t_width
   double precision, intent(in) :: d_width
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance
   integer, intent(in) :: order
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale
   logical, intent(in) :: alchemy

   double precision, dimension(:, :), intent(in) :: pd

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j
   integer :: ni, nj
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12
   ! double precision, allocatable, dimension(:,:) :: atomic_distance

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:) :: self_scalar1
   double precision, allocatable, dimension(:) :: self_scalar2

   ! Pre-computed terms
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :) :: ksi2

   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp2

   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! counter for periodic distance
   integer :: pmax1
   integer :: pmax2
   ! integer :: nneighi
   double precision :: ang_norm2

   double precision :: mol_dist

   integer :: maxneigh1
   integer :: maxneigh2

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ang_norm2 = get_angular_norm2(t_width)

   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax(x2, n2)

   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), maxval(n2), maxval(nneigh2)))
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)
   !ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   !ksi2 = get_ksi(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxval(nneigh1)))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxval(nneigh1)))

   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   allocate (cosp2(nm2, maxval(n2), pmax2, order, maxval(nneigh2)))
   allocate (sinp2(nm2, maxval(n2), pmax2, order, maxval(nneigh2)))

   call init_cosp_sinp(x2, n2, nneigh2, three_body_power, order, cut_start, cut_distance, &
       & cosp2, sinp2, verbose)

   ! Global self-scalar have their own summation and are not a general function
   allocate (self_scalar1(nm1))
   allocate (self_scalar2(nm2))

   self_scalar1 = 0.0d0
   self_scalar2 = 0.0d0

   !$OMP PARALLEL DO PRIVATE(ni) REDUCTION(+:self_scalar1)
   do a = 1, nm1
      ni = n1(a)
      do i = 1, ni
         do j = 1, ni

            self_scalar1(a) = self_scalar1(a) + scalar(x1(a, i, :, :), x1(a, j, :, :), &
                & nneigh1(a, i), nneigh1(a, j), ksi1(a, i, :), ksi1(a, j, :), &
                & sinp1(a, i, :, :, :), sinp1(a, j, :, :, :), &
                & cosp1(a, i, :, :, :), cosp1(a, j, :, :, :), &
                & t_width, d_width, cut_distance, order, &
                & pd, ang_norm2, distance_scale, angular_scale, alchemy)
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(ni) REDUCTION(+:self_scalar2)
   do a = 1, nm2
      ni = n2(a)
      do i = 1, ni
         do j = 1, ni
            self_scalar2(a) = self_scalar2(a) + scalar(x2(a, i, :, :), x2(a, j, :, :), &
                & nneigh2(a, i), nneigh2(a, j), ksi2(a, i, :), ksi2(a, j, :), &
                & sinp2(a, i, :, :, :), sinp2(a, j, :, :, :), &
                & cosp2(a, i, :, :, :), cosp2(a, j, :, :, :), &
                & t_width, d_width, cut_distance, order, &
                & pd, ang_norm2, distance_scale, angular_scale, alchemy)
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   kernels(:, :, :) = 0.0d0

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12,ni,nj,mol_dist,ktmp)
   do b = 1, nm2
      nj = n2(b)
      do a = 1, nm1
         ni = n1(a)

         mol_dist = 0.0d0

         do i = 1, ni
            do j = 1, nj

               s12 = scalar(x1(a, i, :, :), x2(b, j, :, :), &
                   & nneigh1(a, i), nneigh2(b, j), ksi1(a, i, :), ksi2(b, j, :), &
                   & sinp1(a, i, :, :, :), sinp2(b, j, :, :, :), &
                   & cosp1(a, i, :, :, :), cosp2(b, j, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

               mol_dist = mol_dist + s12

            end do
         end do

         ktmp = 0.0d0
         call kernel(self_scalar1(a), self_scalar2(b), mol_dist, &
             & kernel_idx, parameters, ktmp)
         kernels(:, a, b) = ktmp
         !kernels(:, a, b) = kernel(self_scalar1(a), self_scalar2(b), mol_dist, &
         !    & kernel_idx, parameters)

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (self_scalar2)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (cosp2)
   deallocate (sinp1)
   deallocate (sinp2)

end subroutine fget_global_kernels_fchl

subroutine fget_atomic_kernels_fchl(x1, x2, verbose, nneigh1, nneigh2, &
       & na1, na2, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, &
       & get_pmax_atomic, get_ksi_atomic, init_cosp_sinp_atomic

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :), intent(in) :: x1
   double precision, dimension(:, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! Number of neighbors for each atom in each compound
   integer, dimension(:), intent(in) :: nneigh1
   integer, dimension(:), intent(in) :: nneigh2

   ! Number of molecules
   integer, intent(in) :: na1
   integer, intent(in) :: na2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   double precision, intent(in) :: t_width
   double precision, intent(in) :: d_width
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance
   integer, intent(in) :: order
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale
   logical, intent(in) :: alchemy

   double precision, dimension(:, :), intent(in) :: pd

   ! Resulting alpha vector
   double precision, dimension(nsigmas, na1, na2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:) :: self_scalar1
   double precision, allocatable, dimension(:) :: self_scalar2

   ! Pre-computed terms
   double precision, allocatable, dimension(:, :) :: ksi1
   double precision, allocatable, dimension(:, :) :: ksi2

   double precision, allocatable, dimension(:, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :) :: cosp1
   double precision, allocatable, dimension(:, :, :, :) :: cosp2

   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! counter for periodic distance
   integer :: pmax1
   integer :: pmax2
   double precision :: ang_norm2

   integer :: maxneigh1
   integer :: maxneigh2

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ang_norm2 = get_angular_norm2(t_width)

   pmax1 = get_pmax_atomic(x1, nneigh1)
   pmax2 = get_pmax_atomic(x2, nneigh2)

   allocate (ksi1(na1, maxval(nneigh1)))
   allocate (ksi2(na2, maxval(nneigh2)))
   call get_ksi_atomic(x1, na1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi_atomic(x2, na2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)
   !ksi1 = get_ksi_atomic(x1, na1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   !ksi2 = get_ksi_atomic(x2, na2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   allocate (cosp1(na1, pmax1, order, maxneigh1))
   allocate (sinp1(na1, pmax1, order, maxneigh1))

   call init_cosp_sinp_atomic(x1, na1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   allocate (cosp2(na2, pmax2, order, maxneigh2))
   allocate (sinp2(na2, pmax2, order, maxneigh2))

   call init_cosp_sinp_atomic(x2, na2, nneigh2, three_body_power, order, cut_start, cut_distance, &
       & cosp2, sinp2, verbose)

   allocate (self_scalar1(na1))
   allocate (self_scalar2(na2))

   self_scalar1 = 0.0d0
   self_scalar2 = 0.0d0

   !$OMP PARALLEL DO
   do i = 1, na1
      self_scalar1(i) = scalar(x1(i, :, :), x1(i, :, :), &
          & nneigh1(i), nneigh1(i), ksi1(i, :), ksi1(i, :), &
          & sinp1(i, :, :, :), sinp1(i, :, :, :), &
          & cosp1(i, :, :, :), cosp1(i, :, :, :), &
          & t_width, d_width, cut_distance, order, &
          & pd, ang_norm2, distance_scale, angular_scale, alchemy)
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO
   do i = 1, na2
      self_scalar2(i) = scalar(x2(i, :, :), x2(i, :, :), &
          & nneigh2(i), nneigh2(i), ksi2(i, :), ksi2(i, :), &
          & sinp2(i, :, :, :), sinp2(i, :, :, :), &
          & cosp2(i, :, :, :), cosp2(i, :, :, :), &
          & t_width, d_width, cut_distance, order, &
          & pd, ang_norm2, distance_scale, angular_scale, alchemy)
   end do
   !$OMP END PARALLEL DO

   kernels(:, :, :) = 0.0d0

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12, ktmp)
   do i = 1, na1
      do j = 1, na2

         s12 = scalar(x1(i, :, :), x2(j, :, :), &
             & nneigh1(i), nneigh2(j), ksi1(i, :), ksi2(j, :), &
             & sinp1(i, :, :, :), sinp2(j, :, :, :), &
             & cosp1(i, :, :, :), cosp2(j, :, :, :), &
             & t_width, d_width, cut_distance, order, &
             & pd, ang_norm2, distance_scale, angular_scale, alchemy)

         ktmp = 0.0d0
         call kernel(self_scalar1(i), self_scalar2(j), s12, &
                 & kernel_idx, parameters, ktmp)
         kernels(:, i, j) = ktmp
         !kernels(:, i, j) = kernel(self_scalar1(i), self_scalar2(j), s12, &
         !        & kernel_idx, parameters)

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (self_scalar2)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (cosp2)
   deallocate (sinp1)
   deallocate (sinp2)

end subroutine fget_atomic_kernels_fchl

subroutine fget_atomic_symmetric_kernels_fchl(x1, verbose, nneigh1, na1, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, &
       & get_pmax_atomic, get_ksi_atomic, init_cosp_sinp_atomic
   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :), intent(in) :: x1

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! Number of neighbors for each atom in each compound
   integer, dimension(:), intent(in) :: nneigh1

   ! Number of molecules
   integer, intent(in) :: na1

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   double precision, intent(in) :: t_width
   double precision, intent(in) :: d_width
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance
   integer, intent(in) :: order
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale
   logical, intent(in) :: alchemy

   double precision, dimension(:, :), intent(in) :: pd

   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, na1, na1), intent(out) :: kernels

   ! Internal counters
   integer :: i, j

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:) :: self_scalar1

   ! Pre-computed terms
   double precision, allocatable, dimension(:, :) :: ksi1

   double precision, allocatable, dimension(:, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :) :: cosp1

   ! counter for periodic distance
   integer :: pmax1
   double precision :: ang_norm2

   integer :: maxneigh1

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   maxneigh1 = maxval(nneigh1)

   ang_norm2 = get_angular_norm2(t_width)

   pmax1 = get_pmax_atomic(x1, nneigh1)

   allocate (ksi1(na1, maxval(nneigh1)))
   call get_ksi_atomic(x1, na1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   !ksi1 = get_ksi_atomic(x1, na1, nneigh1, two_body_power, cut_start, cut_distance, verbose)

   allocate (cosp1(na1, pmax1, order, maxneigh1))
   allocate (sinp1(na1, pmax1, order, maxneigh1))

   call init_cosp_sinp_atomic(x1, na1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   allocate (self_scalar1(na1))

   self_scalar1 = 0.0d0

   !$OMP PARALLEL DO
   do i = 1, na1
      self_scalar1(i) = scalar(x1(i, :, :), x1(i, :, :), &
          & nneigh1(i), nneigh1(i), ksi1(i, :), ksi1(i, :), &
          & sinp1(i, :, :, :), sinp1(i, :, :, :), &
          & cosp1(i, :, :, :), cosp1(i, :, :, :), &
          & t_width, d_width, cut_distance, order, &
          & pd, ang_norm2, distance_scale, angular_scale, alchemy)
   end do
   !$OMP END PARALLEL DO

   kernels(:, :, :) = 0.0d0

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(s12, ktmp)
   do i = 1, na1
      do j = i, na1

         s12 = scalar(x1(i, :, :), x1(j, :, :), &
             & nneigh1(i), nneigh1(j), ksi1(i, :), ksi1(j, :), &
             & sinp1(i, :, :, :), sinp1(j, :, :, :), &
             & cosp1(i, :, :, :), cosp1(j, :, :, :), &
             & t_width, d_width, cut_distance, order, &
             & pd, ang_norm2, distance_scale, angular_scale, alchemy)

         !kernels(:, i, j) = kernel(self_scalar1(i), self_scalar1(j), s12, &
         !        & kernel_idx, parameters)

         ktmp = 0.0d0
         call kernel(self_scalar1(i), self_scalar1(j), s12, &
                 & kernel_idx, parameters, ktmp)

         kernels(:, i, j) = ktmp
         kernels(:, j, i) = kernels(:, i, j)

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (ksi1)
   deallocate (cosp1)
   deallocate (sinp1)

end subroutine fget_atomic_symmetric_kernels_fchl

subroutine fget_atomic_local_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, &
       & nm1, nm2, na1, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_threebody_fourier, get_twobody_weights, &
       & get_angular_norm2, get_pmax, get_ksi, init_cosp_sinp, get_selfscalar
   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (i,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :), intent(in) :: nneigh2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   integer, intent(in) :: na1

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   double precision, intent(in) :: t_width
   double precision, intent(in) :: d_width
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance
   integer, intent(in) :: order
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! -1.0 / sigma^2 for use in the kernel

   double precision, dimension(:, :), intent(in) :: pd

   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, na1, nm2), intent(out) :: kernels

   integer :: idx1

   ! Internal counters
   integer :: i, j
   integer :: ni, nj
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :) :: self_scalar2

   ! Pre-computed terms
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :) :: ksi2

   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp2

   logical, intent(in) :: alchemy

   ! Value of PI at full FORTRAN precision.
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)

   ! counter for periodic distance
   integer :: pmax1
   integer :: pmax2
   ! integer :: nneighi

   double precision :: ang_norm2

   integer :: maxneigh1
   integer :: maxneigh2

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ang_norm2 = get_angular_norm2(t_width)

   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax(x2, n2)

   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), maxval(n2), maxval(nneigh2)))
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)
   !ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   !ksi2 = get_ksi(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxval(nneigh1)))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxval(nneigh1)))

   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   allocate (cosp2(nm2, maxval(n2), pmax2, order, maxval(nneigh2)))
   allocate (sinp2(nm2, maxval(n2), pmax2, order, maxval(nneigh2)))

   call init_cosp_sinp(x2, n2, nneigh2, three_body_power, order, cut_start, cut_distance, &
       & cosp2, sinp2, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, maxval(n1)))
   allocate (self_scalar2(nm2, maxval(n2)))
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   call get_selfscalar(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)
   !self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   ! Pre-calculate self-scalar terms
   !self_scalar2 = get_selfscalar(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   kernels(:, :, :) = 0.0d0

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(ni,nj,idx1,s12,ktmp)
   do a = 1, nm1
      ni = n1(a)
      do i = 1, ni

         idx1 = sum(n1(:a)) - ni + i

         do b = 1, nm2
            nj = n2(b)
            do j = 1, nj

               s12 = scalar(x1(a, i, :, :), x2(b, j, :, :), &
                   & nneigh1(a, i), nneigh2(b, j), ksi1(a, i, :), ksi2(b, j, :), &
                   & sinp1(a, i, :, :, :), sinp2(b, j, :, :, :), &
                   & cosp1(a, i, :, :, :), cosp2(b, j, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

               ktmp = 0.0d0
               call kernel(self_scalar1(a, i), self_scalar2(b, j), s12, &
                   & kernel_idx, parameters, ktmp)
               kernels(:, idx1, b) = kernels(:, idx1, b) + ktmp

               !kernels(:, idx1, b) = kernels(:, idx1, b) &
               !    & + kernel(self_scalar1(a, i), self_scalar2(b, j), s12, &
               !    & kernel_idx, parameters)

            end do
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (ktmp)
   deallocate (self_scalar1)
   deallocate (self_scalar2)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (cosp2)
   deallocate (sinp1)
   deallocate (sinp2)

end subroutine fget_atomic_local_kernels_fchl

module ffchl_module

   implicit none

contains

   function get_pmax(x, na) result(pmax)

      implicit none

      ! FCHL descriptors for the set, format (nm1,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Internal counter
      integer :: a

      ! Max nuclear charge
      integer :: pmax

      pmax = 0

      do a = 1, size(na, dim=1)
         pmax = max(pmax, int(maxval(x(a, 1, 2, :na(a)))))
      end do

   end function get_pmax

   function get_pmax_atomic(x, nneigh) result(pmax)

      implicit none

      ! FCHL descriptors for the set, format (nm1,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: nneigh

      ! Internal counter
      integer :: a

      ! Max nuclear charge
      integer :: pmax

      pmax = 0

      do a = 1, size(nneigh, dim=1)
         pmax = max(pmax, int(maxval(x(a, 2, :nneigh(a)))))
      end do

   end function get_pmax_atomic

   function get_pmax_displaced(x, na) result(pmax)

      implicit none

      ! FCHL descriptors for the training set, format (nm1,3,2,maxatoms,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Internal counter
      integer :: a, b, i, xyz, pm

      ! Max nuclear charge
      integer :: pmax

      pmax = 0

      do a = 1, size(na, dim=1)
         b = na(a)
         do xyz = 1, 3
            do pm = 1, size(x, dim=3)
               do i = 1, b
                  pmax = max(pmax, int(maxval(x(a, xyz, pm, i, 1, 2, :na(a)))))
               end do
            end do
         end do
      end do

   end function get_pmax_displaced

   pure function cut_function(r, cut_start, cut_distance) result(f)

      implicit none

      ! Distance
      double precision, intent(in) :: r

      ! Lower limit of damping
      double precision, intent(in) :: cut_start

      ! Upper limit of damping
      double precision, intent(in) :: cut_distance

      ! Intermediate variables
      double precision :: x
      double precision :: rl
      double precision :: ru

      ! Damping function at distance r
      double precision :: f

      ru = cut_distance
      rl = cut_start*cut_distance

      if (r > ru) then

         f = 0.0d0

      else if (r < rl) then

         f = 1.0d0

      else

         x = (ru - r)/(ru - rl)
         f = (10.0d0*x**3) - (15.0d0*x**4) + (6.0d0*x**5)

      end if

   end function cut_function

   pure function get_angular_norm2(t_width) result(ang_norm2)

      implicit none

      ! Theta-width
      double precision, intent(in) :: t_width

      ! The resulting angular norm (squared)
      double precision ang_norm2

      ! Integration limit - bigger than 100 should suffice.
      integer, parameter :: limit = 10000

      ! Pi at double precision.
      double precision, parameter :: pi = 4.0d0*atan(1.0d0)

      integer :: n

      ang_norm2 = 0.0d0

      do n = -limit, limit
         ang_norm2 = ang_norm2 + exp(-((t_width*n)**2)) &
                    & *(2.0d0 - 2.0d0*cos(n*pi))
      end do

      ang_norm2 = sqrt(ang_norm2*pi)*2.0d0

   end function

   function get_twobody_weights(x, neighbors, power, cut_start, cut_distance, dim1) result(ksi)

      implicit none

      double precision, dimension(:, :), intent(in) :: x
      integer, intent(in) :: neighbors
      double precision, intent(in) :: power
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance
      integer, intent(in) :: dim1

      double precision, dimension(dim1) :: ksi
      integer :: i

      ksi = 0.0d0

      do i = 2, neighbors

         ksi(i) = cut_function(x(1, i), cut_start, cut_distance)/x(1, i)**power

      end do

   end function get_twobody_weights

! Calculate the Fourier terms for the FCHL three-body expansion
   function get_threebody_fourier(x, neighbors, order, power, cut_start, cut_distance, &
       & dim1, dim2, dim3) result(fourier)

      implicit none

      ! Input representation, dimension=(5,n).
      double precision, dimension(:, :), intent(in) :: x

      ! Number of neighboring atoms to iterate over.
      integer, intent(in) :: neighbors

      ! Fourier-expansion order.
      integer, intent(in) :: order

      ! Power law
      double precision, intent(in) :: power

      ! Lower limit of damping function
      double precision, intent(in) :: cut_start

      ! Upper limit of damping function
      double precision, intent(in) :: cut_distance

      ! Dimensions or the output array.
      integer, intent(in) :: dim1, dim2, dim3

      ! dim(1,:,:,:) are cos terms, dim(2,:,:,:) are sine terms.
      double precision, dimension(2, dim1, dim2, dim3) :: fourier

      ! Pi at double precision.
      double precision, parameter :: pi = 4.0d0*atan(1.0d0)

      ! Internal counters.
      integer :: j, k, m

      ! Indexes for the periodic-table distance matrix.
      integer :: pj, pk

      ! Angle between atoms for the three-body term.
      double precision :: theta

      ! Three-body weight
      double precision :: ksi3

      ! Temporary variables for cos and sine Fourier terms.
      double precision :: cos_m, sin_m

      fourier = 0.0d0

      do j = 2, neighbors
         do k = j + 1, neighbors

            ksi3 = calc_ksi3(X(:, :), j, k, power, cut_start, cut_distance)
            theta = calc_angle(x(3:5, j), x(3:5, 1), x(3:5, k))

            pj = int(x(2, k))
            pk = int(x(2, j))

            do m = 1, order

               cos_m = (cos(m*theta) - cos((theta + pi)*m))*ksi3
               sin_m = (sin(m*theta) - sin((theta + pi)*m))*ksi3

               fourier(1, pj, m, j) = fourier(1, pj, m, j) + cos_m
               fourier(2, pj, m, j) = fourier(2, pj, m, j) + sin_m

               fourier(1, pk, m, k) = fourier(1, pk, m, k) + cos_m
               fourier(2, pk, m, k) = fourier(2, pk, m, k) + sin_m

            end do

         end do
      end do

      return

   end function get_threebody_fourier

   pure function calc_angle(a, b, c) result(angle)

      implicit none

      double precision, intent(in), dimension(3) :: a
      double precision, intent(in), dimension(3) :: b
      double precision, intent(in), dimension(3) :: c

      double precision, dimension(3) :: v1
      double precision, dimension(3) :: v2

      double precision :: cos_angle
      double precision :: angle

      v1 = a - b
      v2 = c - b

      v1 = v1/norm2(v1)
      v2 = v2/norm2(v2)

      cos_angle = dot_product(v1, v2)

      ! Clipping
      if (cos_angle > 1.0d0) cos_angle = 1.0d0
      if (cos_angle < -1.0d0) cos_angle = -1.0d0

      angle = acos(cos_angle)

   end function calc_angle

   pure function calc_cos_angle(a, b, c) result(cos_angle)

      implicit none

      double precision, intent(in), dimension(3) :: a
      double precision, intent(in), dimension(3) :: b
      double precision, intent(in), dimension(3) :: c

      double precision, dimension(3) :: v1
      double precision, dimension(3) :: v2

      double precision :: cos_angle

      v1 = a - b
      v2 = c - b

      v1 = v1/norm2(v1)
      v2 = v2/norm2(v2)

      cos_angle = dot_product(v1, v2)

   end function calc_cos_angle

   function calc_ksi3(X, j, k, power, cut_start, cut_distance) result(ksi3)

      implicit none

      double precision, dimension(:, :), intent(in) :: X

      integer, intent(in) :: j
      integer, intent(in) :: k
      double precision, intent(in) :: power
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance

      double precision :: cos_i, cos_j, cos_k
      double precision :: di, dj, dk

      double precision :: ksi3
      double precision :: cut

      cos_i = calc_cos_angle(x(3:5, k), x(3:5, 1), x(3:5, j))
      cos_j = calc_cos_angle(x(3:5, j), x(3:5, k), x(3:5, 1))
      cos_k = calc_cos_angle(x(3:5, 1), x(3:5, j), x(3:5, k))

      dk = x(1, j)
      dj = x(1, k)
      di = norm2(x(3:5, j) - x(3:5, k))

      cut = cut_function(dk, cut_start, cut_distance)* &
          & cut_function(dj, cut_start, cut_distance)* &
          & cut_function(di, cut_start, cut_distance)

      ksi3 = cut*(1.0d0 + 3.0d0*cos_i*cos_j*cos_k)/(di*dj*dk)**power

   end function calc_ksi3

   pure function scalar(X1, X2, N1, N2, ksi1, ksi2, sin1, sin2, cos1, cos2, &
       & t_width, d_width, cut_distance, order, pd, ang_norm2, &
       & distance_scale, angular_scale, alchemy) result(aadist)

      implicit none

      double precision, dimension(:, :), intent(in) :: X1
      double precision, dimension(:, :), intent(in) :: X2

      integer, intent(in) :: N1
      integer, intent(in) :: N2

      double precision, dimension(:), intent(in) :: ksi1
      double precision, dimension(:), intent(in) :: ksi2

      double precision, dimension(:, :, :), intent(in) :: sin1
      double precision, dimension(:, :, :), intent(in) :: sin2
      double precision, dimension(:, :, :), intent(in) :: cos1
      double precision, dimension(:, :, :), intent(in) :: cos2

      double precision, intent(in) :: t_width
      double precision, intent(in) :: d_width
      double precision, intent(in) :: cut_distance
      integer, intent(in) :: order
      double precision, dimension(:, :), intent(in) :: pd
      double precision, intent(in) :: angular_scale
      double precision, intent(in) :: distance_scale

      double precision :: true_angular_scale
      double precision :: true_distance_scale

      double precision, intent(in):: ang_norm2

      double precision :: aadist

      logical, intent(in) :: alchemy

      ! We changed the convention for the scaling factors when the paper was under review
      ! so this is a quick fix
      true_angular_scale = angular_scale/sqrt(8.0d0)
      true_distance_scale = distance_scale/16.0d0

      if (alchemy) then
         aadist = scalar_alchemy(X1, X2, N1, N2, ksi1, ksi2, sin1, sin2, cos1, cos2, &
             & t_width, d_width, order, pd, ang_norm2, &
             & true_distance_scale, true_angular_scale)
      else
         aadist = scalar_noalchemy(X1, X2, N1, N2, ksi1, ksi2, sin1, sin2, cos1, cos2, &
             & t_width, d_width, ang_norm2, &
             & true_distance_scale, true_angular_scale)
      end if

   end function scalar

   pure function scalar_noalchemy(X1, X2, N1, N2, ksi1, ksi2, sin1, sin2, cos1, cos2, &
       & t_width, d_width, ang_norm2, &
       & distance_scale, angular_scale) result(aadist)

      implicit none

      double precision, dimension(:, :), intent(in) :: X1
      double precision, dimension(:, :), intent(in) :: X2

      integer, intent(in) :: N1
      integer, intent(in) :: N2

      double precision, dimension(:), intent(in) :: ksi1
      double precision, dimension(:), intent(in) :: ksi2

      double precision, dimension(:, :, :), intent(in) :: sin1
      double precision, dimension(:, :, :), intent(in) :: sin2
      double precision, dimension(:, :, :), intent(in) :: cos1
      double precision, dimension(:, :, :), intent(in) :: cos2

      double precision, intent(in) :: t_width
      double precision, intent(in) :: d_width

      double precision, intent(in) :: angular_scale
      double precision, intent(in) :: distance_scale

      double precision :: aadist

      double precision :: d

      integer :: i, j, p
      double precision :: angular
      double precision :: maxgausdist2

      integer :: pmax1
      integer :: pmax2
      integer :: pmax

      double precision :: inv_width
      double precision :: r2

      double precision :: s

      double precision, parameter :: pi = 4.0d0*atan(1.0d0)

      double precision :: g1

      logical, allocatable, dimension(:) :: mask1
      logical, allocatable, dimension(:) :: mask2

      double precision, intent(in):: ang_norm2

      ! cached sine and cos terms
      double precision, allocatable, dimension(:, :) :: cos1c, cos2c, sin1c, sin2c

      if (int(x1(2, 1)) /= int(x2(2, 1))) then
         aadist = 0.0d0
         return
      end if

      pmax1 = int(maxval(x1(2, :n1)))
      pmax2 = int(maxval(x2(2, :n2)))

      pmax = min(pmax1, pmax2)

      allocate (mask1(pmax1))
      allocate (mask2(pmax2))
      mask1 = .true.
      mask2 = .true.

      do i = 1, n1
         mask1(int(x1(2, i))) = .false.
      end do

      do i = 1, n2
         mask2(int(x2(2, i))) = .false.
      end do

      allocate (cos1c(pmax, n1))
      allocate (cos2c(pmax, n2))
      allocate (sin1c(pmax, n1))
      allocate (sin2c(pmax, n2))

      cos1c = 0.0d0
      cos2c = 0.0d0
      sin1c = 0.0d0
      sin2c = 0.0d0

      p = 0

      do i = 1, pmax
         if (mask1(i)) cycle
         if (mask2(i)) cycle

         p = p + 1

         cos1c(p, :n1) = cos1(i, 1, :n1)
         cos2c(p, :n2) = cos2(i, 1, :n2)
         sin1c(p, :n1) = sin1(i, 1, :n1)
         sin2c(p, :n2) = sin2(i, 1, :n2)

      end do

      pmax = p

      ! Pre-computed constants
      g1 = sqrt(2.0d0*pi)/ang_norm2
      s = g1*exp(-(t_width)**2/2.0d0)
      inv_width = -1.0d0/(4.0d0*d_width**2)
      maxgausdist2 = (8.0d0*d_width)**2

      ! Initialize scalar product
      aadist = 1.0d0

      do i = 2, n1
         do j = 2, n2

            if (int(x1(2, i)) /= int(x2(2, j))) cycle

            r2 = (x2(1, j) - x1(1, i))**2
            if (r2 >= maxgausdist2) cycle

            d = exp(r2*inv_width)

            angular = (sum(cos1c(:pmax, i)*cos2c(:pmax, j)) &
                   & + sum(sin1c(:pmax, i)*sin2c(:pmax, j)))*s

            aadist = aadist + d*(ksi1(i)*ksi2(j)*distance_scale &
                & + angular*angular_scale)

         end do
      end do

      deallocate (mask1)
      deallocate (mask2)
      deallocate (cos1c)
      deallocate (cos2c)
      deallocate (sin1c)
      deallocate (sin2c)

   end function scalar_noalchemy

   pure function scalar_alchemy(X1, X2, N1, N2, ksi1, ksi2, sin1, sin2, cos1, cos2, &
       & t_width, d_width, order, pd, ang_norm2, &
       & distance_scale, angular_scale) result(aadist)

      implicit none

      double precision, dimension(:, :), intent(in) :: X1
      double precision, dimension(:, :), intent(in) :: X2

      integer, intent(in) :: N1
      integer, intent(in) :: N2

      double precision, dimension(:), intent(in) :: ksi1
      double precision, dimension(:), intent(in) :: ksi2

      double precision, dimension(:, :, :), intent(in) :: sin1
      double precision, dimension(:, :, :), intent(in) :: sin2
      double precision, dimension(:, :, :), intent(in) :: cos1
      double precision, dimension(:, :, :), intent(in) :: cos2

      double precision, intent(in) :: t_width
      double precision, intent(in) :: d_width
      ! double precision, intent(in) :: cut_distance
      integer, intent(in) :: order
      double precision, dimension(:, :), intent(in) :: pd
      double precision, intent(in) :: angular_scale
      double precision, intent(in) :: distance_scale

      double precision :: aadist

      double precision :: d

      integer :: m_1, m_2

      integer :: i, m, p1, p2

      double precision :: angular
      double precision :: maxgausdist2

      integer :: pmax1
      integer :: pmax2

      double precision :: inv_width
      double precision :: r2

      double precision, dimension(order) :: s

      double precision, parameter :: pi = 4.0d0*atan(1.0d0)

      double precision :: g1
      double precision :: a0

      logical, allocatable, dimension(:) :: mask1
      logical, allocatable, dimension(:) :: mask2

      double precision :: temp, sin1_temp, cos1_temp
      double precision, intent(in):: ang_norm2

      pmax1 = int(maxval(x1(2, :n1)))
      pmax2 = int(maxval(x2(2, :n2)))

      allocate (mask1(pmax1))
      allocate (mask2(pmax2))
      mask1 = .true.
      mask2 = .true.

      do i = 1, n1
         mask1(int(x1(2, i))) = .false.
      end do

      do i = 1, n2
         mask2(int(x2(2, i))) = .false.
      end do

      a0 = 0.0d0
      g1 = sqrt(2.0d0*pi)/ang_norm2

      do m = 1, order
         s(m) = g1*exp(-(t_width*m)**2/2.0d0)
      end do

      inv_width = -1.0d0/(4.0d0*d_width**2)

      maxgausdist2 = (8.0d0*d_width)**2

      aadist = 1.0d0

      do m_1 = 2, N1

         ! if (X1(1, m_1) > cut_distance) exit

         do m_2 = 2, N2

            ! if (X2(1, m_2) > cut_distance) exit

            r2 = (X2(1, m_2) - X1(1, m_1))**2

            if (r2 < maxgausdist2) then

               d = exp(r2*inv_width)*pd(int(x1(2, m_1)), int(x2(2, m_2)))

               angular = a0*a0

               do m = 1, order

                  temp = 0.0d0

                  do p1 = 1, pmax1
                     if (mask1(p1)) cycle
                     cos1_temp = cos1(p1, m, m_1)
                     sin1_temp = sin1(p1, m, m_1)

                     do p2 = 1, pmax2
                        if (mask2(p2)) cycle

                        temp = temp + (cos1_temp*cos2(p2, m, m_2) &
                            & + sin1_temp*sin2(p2, m, m_2))*pd(p2, p1)

                     end do
                  end do

                  angular = angular + temp*s(m)

               end do

               aadist = aadist + d*(ksi1(m_1)*ksi2(m_2)*distance_scale &
                   & + angular*angular_scale)

            end if
         end do
      end do

      aadist = aadist*pd(int(x1(2, 1)), int(x2(2, 1)))

      deallocate (mask1)
      deallocate (mask2)
   end function scalar_alchemy

   subroutine get_ksi(x, na, nneigh, two_body_power, cut_start, cut_distance, verbose, ksi)! result(ksi)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: two_body_power

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance

      ! Whether to be verbose with output
      logical, intent(in) :: verbose

      ! Pre-computed two-body weights
      !double precision, allocatable, dimension(:, :, :) :: ksi
      double precision, dimension(:, :, :) :: ksi

      ! Internal counters
      integer :: maxneigh, maxatoms, nm, a, ni, i

      maxneigh = maxval(nneigh)
      maxatoms = maxval(na)
      nm = size(x, dim=1)

      !allocate (ksi(nm, maxatoms, maxneigh))

      ksi = 0.0d0

      !$OMP PARALLEL DO PRIVATE(ni)
      do a = 1, nm
         ni = na(a)
         do i = 1, ni
            ksi(a, i, :) = get_twobody_weights(x(a, i, :, :), nneigh(a, i), &
                & two_body_power, cut_start, cut_distance, maxneigh)
         end do
      end do
      !$OMP END PARALLEL do

      !end function get_ksi
   end subroutine get_ksi

   !function get_ksi_displaced(x, na, nneigh, two_body_power, cut_start, cut_distance, verbose) result(ksi)
   subroutine get_ksi_displaced(x, na, nneigh, two_body_power, cut_start, cut_distance, verbose, ksi)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :, :, :, :), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: two_body_power

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance

      ! Whether to be verbose with output
      logical, intent(in) :: verbose

      ! Pre-computed two-body weights
      !double precision, allocatable, dimension(:, :, :, :, :, :) :: ksi
      double precision, dimension(:, :, :, :, :, :), intent(out) :: ksi

      ! Internal counters
      integer :: maxneigh, maxatoms, nm, a, ni, i, j, pm, xyz, ndisp

      maxneigh = maxval(nneigh)
      maxatoms = maxval(na)
      nm = size(x, dim=1)
      ndisp = size(x, dim=3)

      !allocate (ksi(nm, 3, ndisp, maxatoms, maxatoms, maxneigh))

      ksi = 0.0d0

      !$OMP PARALLEL DO PRIVATE(ni)
      do a = 1, nm
         ni = na(a)
         do xyz = 1, 3
            do pm = 1, ndisp
               do i = 1, ni
                  do j = 1, ni
                     ksi(a, xyz, pm, i, j, :) = get_twobody_weights( &
             & x(a, xyz, pm, i, j, :, :), nneigh(a, xyz, pm, i, j), &
             & two_body_power, cut_start, cut_distance, maxneigh)
                  end do
               end do
            end do
         end do
      end do
      !$OMP END PARALLEL do

      !end function get_ksi_displaced
   end subroutine get_ksi_displaced

   !function get_ksi_atomic(x, na, nneigh, two_body_power, cut_start, cut_distance, verbose) result(ksi)
   subroutine get_ksi_atomic(x, na, nneigh, two_body_power, cut_start, cut_distance, verbose, ksi)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :), intent(in) :: x

      ! List of numbers of atoms
      integer, intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: two_body_power

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance

      ! Whether to be verbose with output
      logical, intent(in) :: verbose

      ! Pre-computed two-body weights
      ! double precision, allocatable, dimension(:, :) :: ksi
      double precision, dimension(:, :), intent(out) :: ksi

      ! Internal counters
      integer :: maxneigh, nm, i

      maxneigh = maxval(nneigh)
      nm = size(x, dim=1)

      ! allocate (ksi(na, maxneigh))

      ksi = 0.0d0

      !$OMP PARALLEL DO
      do i = 1, na
         ksi(i, :) = get_twobody_weights(x(i, :, :), nneigh(i), &
             & two_body_power, cut_start, cut_distance, maxneigh)
      end do
      !$OMP END PARALLEL do

      !end function get_ksi_atomic
   end subroutine get_ksi_atomic

   subroutine init_cosp_sinp(x, na, nneigh, three_body_power, order, cut_start, cut_distance, cosp, sinp, verbose)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: three_body_power

      integer, intent(in) :: order

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance

      ! Whether to be verbose with output
      logical, intent(in) :: verbose

      ! Cosine and sine terms for each atomtype
      double precision, dimension(:, :, :, :, :), intent(out) :: cosp
      double precision, dimension(:, :, :, :, :), intent(out) :: sinp

      ! Internal counters
      integer :: maxneigh, maxatoms, pmax, nm, a, ni, i

      double precision, allocatable, dimension(:, :, :, :) :: fourier

      maxneigh = maxval(nneigh)
      maxatoms = maxval(na)
      nm = size(x, dim=1)

      pmax = get_pmax(x, na)

      cosp = 0.0d0
      sinp = 0.0d0

      !$OMP PARALLEL DO PRIVATE(ni, fourier) schedule(dynamic)
      do a = 1, nm
         ni = na(a)
         do i = 1, ni

            fourier = get_threebody_fourier(x(a, i, :, :), &
                & nneigh(a, i), order, three_body_power, cut_start, cut_distance, pmax, order, maxneigh)

            cosp(a, i, :, :, :) = fourier(1, :, :, :)
            sinp(a, i, :, :, :) = fourier(2, :, :, :)

         end do
      end do
      !$OMP END PARALLEL DO

   end subroutine init_cosp_sinp

   subroutine init_cosp_sinp_displaced(x, na, nneigh, three_body_power, order, cut_start, cut_distance, cosp, sinp, verbose)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :, :, :, :), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: three_body_power

      integer, intent(in) :: order

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance

      ! Whether to be verbose with output
      logical, intent(in) :: verbose

      ! Cosine and sine terms for each atomtype
      double precision, dimension(:, :, :, :, :, :, :) :: sinp
      double precision, dimension(:, :, :, :, :, :, :) :: cosp

      ! Internal counters
      integer :: maxneigh, maxatoms, pmax, nm, a, ni, i, j, xyz, pm, xyz_pm

      double precision, allocatable, dimension(:, :, :, :) :: fourier

      integer :: ndisp

      maxneigh = maxval(nneigh)
      maxatoms = maxval(na)
      nm = size(x, dim=1)

      ndisp = size(x, dim=3)

      pmax = get_pmax_displaced(x, na)

      cosp = 0.0d0
      sinp = 0.0d0

      !$OMP PARALLEL DO PRIVATE(ni, fourier, xyz_pm) schedule(dynamic)
      do a = 1, nm
         ni = na(a)
         do xyz = 1, 3
         do pm = 1, ndisp
         do i = 1, ni
            do j = 1, ni

               xyz_pm = ndisp*(xyz - 1) + pm

               fourier = get_threebody_fourier(x(a, xyz, pm, i, j, :, :), &
                   & nneigh(a, xyz, pm, i, j), &
                   & order, three_body_power, cut_start, cut_distance, &
                   & pmax, order, maxneigh)

               cosp(a, xyz_pm, i, j, :, :, :) = fourier(1, :, :, :)
               sinp(a, xyz_pm, i, j, :, :, :) = fourier(2, :, :, :)

            end do
         end do
         end do
         end do
      end do
      !$OMP END PARALLEL do

   end subroutine init_cosp_sinp_displaced

   subroutine init_cosp_sinp_atomic(x, na, nneigh, three_body_power, order, cut_start, cut_distance, cosp, sinp, verbose)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :), intent(in) :: x

      ! List of numbers of atom
      integer, intent(in) :: na

      ! Number of neighbors for each atom
      integer, dimension(:), intent(in) :: nneigh

      ! Decaying powerlaws for two-body term
      double precision, intent(in) :: three_body_power

      ! Fourier truncation order
      integer, intent(in) :: order

      ! Fraction of cut_distance at which cut-off starts
      double precision, intent(in) :: cut_start
      double precision, intent(in) :: cut_distance

      ! Whether to be verbose with output
      logical, intent(in) :: verbose

      ! Cosine and sine terms for each atomtype
      double precision, dimension(:, :, :, :), intent(out) :: cosp
      double precision, dimension(:, :, :, :), intent(out) :: sinp

      ! Internal counters
      integer :: maxneigh, pmax, nm, i

      ! Internal temporary variable
      double precision, allocatable, dimension(:, :, :, :) :: fourier

      maxneigh = maxval(nneigh)
      nm = size(x, dim=1)

      pmax = get_pmax_atomic(x, nneigh)

      cosp = 0.0d0
      sinp = 0.0d0

      !$OMP PARALLEL DO PRIVATE(fourier)
      do i = 1, na

         fourier = get_threebody_fourier(x(i, :, :), &
             & nneigh(i), order, three_body_power, cut_start, cut_distance, pmax, order, maxneigh)

         cosp(i, :, :, :) = fourier(1, :, :, :)
         sinp(i, :, :, :) = fourier(2, :, :, :)

      end do
      !$OMP END PARALLEL DO

   end subroutine init_cosp_sinp_atomic

   !function get_selfscalar(x, nm, na, nneigh, ksi, sinp, cosp, t_width, d_width, &
   !        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose) result(self_scalar)
   subroutine get_selfscalar(x, nm, na, nneigh, ksi, sinp, cosp, t_width, d_width, &
           & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :), intent(in) :: x

      ! Number of molecules molecule
      integer, intent(in) :: nm

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :), intent(in) :: nneigh

      ! Pre-computed two-body weights
      double precision, dimension(:, :, :), intent(in) :: ksi

      ! Cosine and sine terms for each atomtype
      double precision, dimension(:, :, :, :, :), intent(in) :: sinp
      double precision, dimension(:, :, :, :, :), intent(in) :: cosp

      ! Angular Gaussian width
      double precision, intent(in) :: t_width

      ! Distance Gaussian width
      double precision, intent(in) :: d_width

      double precision, intent(in) :: cut_distance

      ! Truncation order for Fourier terms
      integer, intent(in) :: order

      ! Periodic table distance matrix
      double precision, dimension(:, :), intent(in) :: pd

      ! Angular normalization constant
      double precision, intent(in) :: ang_norm2

      ! Scaling for angular and distance terms
      double precision, intent(in) :: distance_scale
      double precision, intent(in) :: angular_scale

      ! Switch alchemy on or off
      logical, intent(in) :: alchemy

      ! Whether to be verbose with output
      logical, intent(in) :: verbose

      !double precision, allocatable, dimension(:, :) :: self_scalar
      double precision, dimension(:, :) :: self_scalar

      ! Internal counters
      integer :: a, ni, i

      !allocate (self_scalar(nm, maxval(na)))

      !$OMP PARALLEL DO PRIVATE(ni)
      do a = 1, nm
         ni = na(a)
         do i = 1, ni
            self_scalar(a, i) = scalar(x(a, i, :, :), x(a, i, :, :), &
                & nneigh(a, i), nneigh(a, i), ksi(a, i, :), ksi(a, i, :), &
                & sinp(a, i, :, :, :), sinp(a, i, :, :, :), &
                & cosp(a, i, :, :, :), cosp(a, i, :, :, :), &
                & t_width, d_width, cut_distance, order, &
                & pd, ang_norm2, distance_scale, angular_scale, alchemy)
         end do
      end do
      !$OMP END PARALLEL DO

      !end function get_selfscalar
   end subroutine get_selfscalar

   !function get_selfscalar_displaced(x, nm, na, nneigh, ksi, sinp, cosp, t_width, d_width, &
   !        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose) result(self_scalar)
   subroutine get_selfscalar_displaced(x, nm, na, nneigh, ksi, sinp, cosp, t_width, d_width, &
           & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar)

      implicit none

      ! FCHL descriptors for the training set, format (i,maxatoms,5,maxneighbors)
      double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x

      ! Number of molecules molecule
      integer, intent(in) :: nm

      ! List of numbers of atoms in each molecule
      integer, dimension(:), intent(in) :: na

      ! Number of neighbors for each atom in each compound
      integer, dimension(:, :, :, :, :), intent(in) :: nneigh

      ! Pre-computed two-body weights
      double precision, dimension(:, :, :, :, :, :), intent(in) :: ksi

      ! Cosine and sine terms for each atomtype
      double precision, dimension(:, :, :, :, :, :, :), intent(in) :: sinp
      double precision, dimension(:, :, :, :, :, :, :), intent(in) :: cosp

      ! Angular Gaussian width
      double precision, intent(in) :: t_width

      ! Distance Gaussian width
      double precision, intent(in) :: d_width

      double precision, intent(in) :: cut_distance

      ! Truncation order for Fourier terms
      integer, intent(in) :: order

      ! Periodic table distance matrix
      double precision, dimension(:, :), intent(in) :: pd

      ! Angular normalization constant
      double precision, intent(in) :: ang_norm2

      ! Scaling for angular and distance terms
      double precision, intent(in) :: distance_scale
      double precision, intent(in) :: angular_scale

      ! Switch alchemy on or off
      logical, intent(in) :: alchemy

      ! Whether to be verbose with output
      logical, intent(in) :: verbose

      !double precision, allocatable, dimension(:, :, :, :, :) :: self_scalar
      double precision, dimension(:, :, :, :, :) :: self_scalar

      ! Internal counters
      integer :: a, ni, i, j, pm, xyz, xyz_pm, ndisp

      ndisp = size(x, dim=3)
      ! allocate (self_scalar(nm, 3, ndisp, maxval(na), maxval(na)))
      self_scalar = 0.0d0

      !$OMP PARALLEL DO PRIVATE(ni, xyz_pm) schedule(dynamic)
      do a = 1, nm
         ni = na(a)
         do xyz = 1, 3
         do pm = 1, ndisp
         do i = 1, ni
            do j = 1, ni

               ! z_pm = 2*xyz + pm - 2
               xyz_pm = ndisp*(xyz - 1) + pm

               self_scalar(a, xyz, pm, i, j) = scalar(x(a, xyz, pm, i, j, :, :), x(a, xyz, pm, i, j, :, :), &
                   & nneigh(a, xyz, pm, i, j), nneigh(a, xyz, pm, i, j), &
                   & ksi(a, xyz, pm, i, j, :), ksi(a, xyz, pm, i, j, :), &
                   & sinp(a, xyz_pm, i, j, :, :, :), sinp(a, xyz_pm, i, j, :, :, :), &
                   & cosp(a, xyz_pm, i, j, :, :, :), cosp(a, xyz_pm, i, j, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)
            end do
         end do
         end do
         end do
      end do
      !$OMP END PARALLEL do

      !end function get_selfscalar_displaced
   end subroutine get_selfscalar_displaced

end module ffchl_module

subroutine fget_local_kernels_gaussian(q1, q2, n1, n2, sigmas, &
        & nm1, nm2, nsigmas, kernels)

   implicit none

   double precision, dimension(:, :), intent(in) :: q1
   double precision, dimension(:, :), intent(in) :: q2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: a, b, i, j, k, ni, nj

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance

   integer, allocatable, dimension(:) :: i_starts
   integer, allocatable, dimension(:) :: j_starts

   allocate (i_starts(nm1))
   allocate (j_starts(nm2))

   !$OMP PARALLEL DO
   do i = 1, nm1
      i_starts(i) = sum(n1(:i)) - n1(i)
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO
   do j = 1, nm2
      j_starts(j) = sum(n2(:j)) - n2(j)
   end do
   !$OMP END PARALLEL DO

   inv_sigma2(:) = -0.5d0/(sigmas(:))**2
   kernels(:, :, :) = 0.0d0

   allocate (atomic_distance(maxval(n1), maxval(n2)))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj) SCHEDULE(dynamic) COLLAPSE(2)
   do a = 1, nm1
      do b = 1, nm2
         nj = n2(b)
         ni = n1(a)

         atomic_distance(:, :) = 0.0d0
         do i = 1, ni
            do j = 1, nj

               atomic_distance(i, j) = sum((q1(:, i + i_starts(a)) - q2(:, j + j_starts(b)))**2)

            end do
         end do

         do k = 1, nsigmas
            kernels(k, a, b) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (i_starts)
   deallocate (j_starts)

end subroutine fget_local_kernels_gaussian

subroutine fget_local_kernels_laplacian(q1, q2, n1, n2, sigmas, &
        & nm1, nm2, nsigmas, kernels)

   implicit none

   double precision, dimension(:, :), intent(in) :: q1
   double precision, dimension(:, :), intent(in) :: q2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: a, b, i, j, k, ni, nj

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance

   integer, allocatable, dimension(:) :: i_starts
   integer, allocatable, dimension(:) :: j_starts

   allocate (i_starts(nm1))
   allocate (j_starts(nm2))

   !$OMP PARALLEL DO
   do i = 1, nm1
      i_starts(i) = sum(n1(:i)) - n1(i)
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO
   do j = 1, nm2
      j_starts(j) = sum(n2(:j)) - n2(j)
   end do
   !$OMP END PARALLEL DO

   inv_sigma2(:) = -1.0d0/sigmas(:)
   kernels(:, :, :) = 0.0d0

   allocate (atomic_distance(maxval(n1), maxval(n2)))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj) SCHEDULE(dynamic) COLLAPSE(2)
   do a = 1, nm1
      do b = 1, nm2
         nj = n2(b)
         ni = n1(a)

         atomic_distance(:, :) = 0.0d0
         do i = 1, ni
            do j = 1, nj

               atomic_distance(i, j) = sum(abs(q1(:, i + i_starts(a)) - q2(:, j + j_starts(b))))

            end do
         end do

         do k = 1, nsigmas
            kernels(k, a, b) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (i_starts)
   deallocate (j_starts)

end subroutine fget_local_kernels_laplacian

subroutine fget_vector_kernels_laplacian(q1, q2, n1, n2, sigmas, &
        & nm1, nm2, nsigmas, kernels)

   implicit none

   ! Descriptors for the training set
   double precision, dimension(:, :, :), intent(in) :: q1
   double precision, dimension(:, :, :), intent(in) :: q2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni, nj, ia, ja

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance

   inv_sigma(:) = -1.0d0/sigmas(:)

   kernels(:, :, :) = 0.0d0

   allocate (atomic_distance(maxval(n1), maxval(n2)))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj) SCHEDULE(dynamic) COLLAPSE(2)
   do j = 1, nm2
      do i = 1, nm1
         ni = n1(i)
         nj = n2(j)

         atomic_distance(:, :) = 0.0d0

         do ja = 1, nj
            do ia = 1, ni

               atomic_distance(ia, ja) = sum(abs(q1(:, ia, i) - q2(:, ja, j)))

            end do
         end do

         do k = 1, nsigmas
            kernels(k, i, j) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma(k)))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)

end subroutine fget_vector_kernels_laplacian

subroutine fget_vector_kernels_gaussian(q1, q2, n1, n2, sigmas, &
        & nm1, nm2, nsigmas, kernels)

   implicit none

   ! Representations (n_samples, n_max_atoms, rep_size)
   double precision, dimension(:, :, :), intent(in) :: q1
   double precision, dimension(:, :, :), intent(in) :: q2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni, nj, ia, ja

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance

   inv_sigma2(:) = -0.5d0/(sigmas(:))**2

   kernels(:, :, :) = 0.0d0

   allocate (atomic_distance(maxval(n1), maxval(n2)))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj,ja,ia) SCHEDULE(dynamic) COLLAPSE(2)
   do j = 1, nm2
      do i = 1, nm1
         ni = n1(i)
         nj = n2(j)

         atomic_distance(:, :) = 0.0d0

         do ja = 1, nj
            do ia = 1, ni

               atomic_distance(ia, ja) = sum((q1(:, ia, i) - q2(:, ja, j))**2)

            end do
         end do

         do k = 1, nsigmas
            kernels(k, i, j) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)

end subroutine fget_vector_kernels_gaussian

subroutine fget_vector_kernels_gaussian_symmetric(q, n, sigmas, &
        & nm, nsigmas, kernels)

   implicit none

   ! Representations (rep_size, n_samples, n_max_atoms)
   double precision, dimension(:, :, :), intent(in) :: q

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! Resulting kernels
   double precision, dimension(nsigmas, nm, nm), intent(out) :: kernels

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance
   double precision, allocatable, dimension(:) :: inv_sigma2

   ! Internal counters
   integer :: i, j, k, ni, nj, ia, ja
   double precision :: val

   allocate (inv_sigma2(nsigmas))

   inv_sigma2 = -0.5d0/(sigmas)**2

   kernels = 1.0d0

   i = size(q, dim=3)
   allocate (atomic_distance(i, i))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj,ja,ia,val) SCHEDULE(dynamic) COLLAPSE(2)
   do j = 1, nm
      do i = 1, nm
         if (i .lt. j) cycle
         ni = n(i)
         nj = n(j)

         atomic_distance(:, :) = 0.0d0

         do ja = 1, nj
            do ia = 1, ni

               atomic_distance(ia, ja) = sum((q(:, ia, i) - q(:, ja, j))**2)

            end do
         end do

         do k = 1, nsigmas
            val = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
            kernels(k, i, j) = val
            kernels(k, j, i) = val
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (inv_sigma2)

end subroutine fget_vector_kernels_gaussian_symmetric

subroutine fget_vector_kernels_laplacian_symmetric(q, n, sigmas, &
        & nm, nsigmas, kernels)

   implicit none

   ! Representations (rep_size, n_samples, n_max_atoms)
   double precision, dimension(:, :, :), intent(in) :: q

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n

   ! Sigma in the Laplacian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! Resulting kernels
   double precision, dimension(nsigmas, nm, nm), intent(out) :: kernels

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance
   double precision, allocatable, dimension(:) :: inv_sigma2

   ! Internal counters
   integer :: i, j, k, ni, nj, ia, ja
   double precision :: val

   allocate (inv_sigma2(nsigmas))

   inv_sigma2 = -1.0d0/sigmas

   kernels = 1.0d0

   i = size(q, dim=3)
   allocate (atomic_distance(i, i))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj,ja,ia,val) SCHEDULE(dynamic) COLLAPSE(2)
   do j = 1, nm
      do i = 1, nm
         if (i .lt. j) cycle
         ni = n(i)
         nj = n(j)

         atomic_distance(:, :) = 0.0d0

         do ja = 1, nj
            do ia = 1, ni

               atomic_distance(ia, ja) = sum(abs(q(:, ia, i) - q(:, ja, j)))

            end do
         end do

         do k = 1, nsigmas
            val = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
            kernels(k, i, j) = val
            kernels(k, j, i) = val
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (inv_sigma2)

end subroutine fget_vector_kernels_laplacian_symmetric

subroutine fgaussian_kernel(a, na, b, nb, k, sigma)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision, allocatable, dimension(:) :: temp

   double precision :: inv_sigma
   integer :: i, j

   inv_sigma = -0.5d0/(sigma*sigma)

   allocate (temp(size(a, dim=1)))

   !$OMP PARALLEL DO PRIVATE(temp) COLLAPSE(2)
   do i = 1, nb
      do j = 1, na
         temp(:) = a(:, j) - b(:, i)
         k(j, i) = exp(inv_sigma*dot_product(temp, temp))
      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (temp)

end subroutine fgaussian_kernel

subroutine fgaussian_kernel_symmetric(x, n, k, sigma)

   implicit none

   double precision, dimension(:, :), intent(in) :: x

   integer, intent(in) :: n

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision, allocatable, dimension(:) :: temp
   double precision :: val

   double precision :: inv_sigma
   integer :: i, j

   inv_sigma = -0.5d0/(sigma*sigma)

   k = 1.0d0

   allocate (temp(size(x, dim=1)))

   !$OMP PARALLEL DO PRIVATE(temp, val) SCHEDULE(dynamic)
   do i = 1, n
      do j = i, n
         temp = x(:, j) - x(:, i)
         val = exp(inv_sigma*dot_product(temp, temp))
         k(j, i) = val
         k(i, j) = val
      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (temp)

end subroutine fgaussian_kernel_symmetric

subroutine flaplacian_kernel(a, na, b, nb, k, sigma)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision :: inv_sigma

   integer :: i, j

   inv_sigma = -1.0d0/sigma

   !$OMP PARALLEL DO COLLAPSE(2)
   do i = 1, nb
      do j = 1, na
         k(j, i) = exp(inv_sigma*sum(abs(a(:, j) - b(:, i))))
      end do
   end do
   !$OMP END PARALLEL DO

end subroutine flaplacian_kernel

subroutine flaplacian_kernel_symmetric(x, n, k, sigma)

   implicit none

   double precision, dimension(:, :), intent(in) :: x

   integer, intent(in) :: n

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision :: val

   double precision :: inv_sigma
   integer :: i, j

   inv_sigma = -1.0d0/sigma

   k = 1.0d0

   !$OMP PARALLEL DO PRIVATE(val) SCHEDULE(dynamic)
   do i = 1, n
      do j = i, n
         val = exp(inv_sigma*sum(abs(x(:, j) - x(:, i))))
         k(j, i) = val
         k(i, j) = val
      end do
   end do
   !$OMP END PARALLEL DO

end subroutine flaplacian_kernel_symmetric

subroutine flinear_kernel(a, na, b, nb, k)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k

   integer :: i, j

!$OMP PARALLEL DO COLLAPSE(2)
   do i = 1, nb
      do j = 1, na
         k(j, i) = dot_product(a(:, j), b(:, i))
      end do
   end do
!$OMP END PARALLEL DO

end subroutine flinear_kernel

subroutine fmatern_kernel_l2(a, na, b, nb, k, sigma, order)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma
   integer, intent(in) :: order

   double precision, allocatable, dimension(:) :: temp

   double precision :: inv_sigma, inv_sigma2, d, d2
   integer :: i, j

   allocate (temp(size(a, dim=1)))

   if (order == 0) then
      inv_sigma = -1.0d0/sigma

      !$OMP PARALLEL DO PRIVATE(temp) COLLAPSE(2)
      do i = 1, nb
         do j = 1, na
            temp(:) = a(:, j) - b(:, i)
            k(j, i) = exp(inv_sigma*sqrt(sum(temp*temp)))
         end do
      end do
      !$OMP END PARALLEL DO
   else if (order == 1) then
      inv_sigma = -sqrt(3.0d0)/sigma

      !$OMP PARALLEL DO PRIVATE(temp, d) COLLAPSE(2)
      do i = 1, nb
         do j = 1, na
            temp(:) = a(:, j) - b(:, i)
            d = sqrt(sum(temp*temp))
            k(j, i) = exp(inv_sigma*d)*(1.0d0 - inv_sigma*d)
         end do
      end do
      !$OMP END PARALLEL DO
   else
      inv_sigma = -sqrt(5.0d0)/sigma
      inv_sigma2 = 5.0d0/(3.0d0*sigma*sigma)

      !$OMP PARALLEL DO PRIVATE(temp, d, d2) COLLAPSE(2)
      do i = 1, nb
         do j = 1, na
            temp(:) = a(:, j) - b(:, i)
            d2 = sum(temp*temp)
            d = sqrt(d2)
            k(j, i) = exp(inv_sigma*d)*(1.0d0 - inv_sigma*d + inv_sigma2*d2)
         end do
      end do
      !$OMP END PARALLEL DO
   end if

   deallocate (temp)

end subroutine fmatern_kernel_l2

subroutine fsargan_kernel(a, na, b, nb, k, sigma, gammas, ng)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b
   double precision, dimension(:), intent(in) :: gammas

   integer, intent(in) :: na, nb, ng

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision, allocatable, dimension(:) :: prefactor
   double precision :: inv_sigma
   double precision :: d

   integer :: i, j, m

   inv_sigma = -1.0d0/sigma

   ! Allocate temporary
   allocate (prefactor(ng))

   !$OMP PARALLEL DO PRIVATE(d, prefactor) SCHEDULE(dynamic) COLLAPSE(2)
   do i = 1, nb
      do j = 1, na
         d = sum(abs(a(:, j) - b(:, i)))
         do m = 1, ng
            prefactor(m) = gammas(m)*(-inv_sigma*d)**m
         end do
         k(j, i) = exp(inv_sigma*d)*(1 + sum(prefactor(:)))
      end do
   end do
   !$OMP END PARALLEL DO

   ! Clean up
   deallocate (prefactor)

end subroutine fsargan_kernel

! fib.f90
subroutine fib(a, n)
   USE OMP_LIB
   use iso_c_binding
   integer(c_int), intent(in) :: n
   integer(c_int), intent(out) :: a(n)

   !$OMP PARALLEL
   PRINT *, "Hello from process: ", OMP_GET_THREAD_NUM()
!$OMP END PARALLEL

   do i = 1, n
      if (i .eq. 1) then
         a(i) = 0.0d0
      elseif (i .eq. 2) then
         a(i) = 1.0d0
      else
         a(i) = a(i - 1) + a(i - 2)
      end if
   end do
end

function searchsorted(all_values, sorted) result(cdf_idx)

   implicit none

   double precision, dimension(:), intent(in) :: all_values
   double precision, dimension(:), intent(in) :: sorted

   integer, allocatable, dimension(:) :: cdf_idx

   double precision :: val

   integer :: i, j, n, m

   n = size(all_values) - 1
   m = size(sorted)

   allocate (cdf_idx(n))

   cdf_idx(:) = 0

   do i = 1, n

      val = all_values(i)

      do j = 1, m

         !write (*,*) i, j, sorted(j), val

         ! if ((sorted(j) <= val) .and. (val < sorted(j+1)))  then
         if (sorted(j) > val) then

            cdf_idx(i) = j - 1
            !write(*,*) "found"
            exit

            !  endif
         else !iif (val > maxval(sorted)) then
            cdf_idx(i) = m
         end if

      end do

   end do

end function searchsorted

recursive subroutine quicksort(a, first, last)
   implicit none
   double precision ::  a(*), x, t
   integer first, last
   integer i, j

   x = a((first + last)/2)
   i = first
   j = last
   do
      do while (a(i) < x)
         i = i + 1
      end do
      do while (x < a(j))
         j = j - 1
      end do
      if (i >= j) exit
      t = a(i); a(i) = a(j); a(j) = t
      i = i + 1
      j = j - 1
   end do
   if (first < i - 1) call quicksort(a, first, i - 1)
   if (j + 1 < last) call quicksort(a, j + 1, last)
end subroutine quicksort

subroutine fget_local_kernels_gaussian(q1, q2, n1, n2, sigmas, &
        & nm1, nm2, nsigmas, kernels)

   implicit none

   double precision, dimension(:, :), intent(in) :: q1
   double precision, dimension(:, :), intent(in) :: q2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: a, b, i, j, k, ni, nj

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance

   integer, allocatable, dimension(:) :: i_starts
   integer, allocatable, dimension(:) :: j_starts

   allocate (i_starts(nm1))
   allocate (j_starts(nm2))

   !$OMP PARALLEL DO
   do i = 1, nm1
      i_starts(i) = sum(n1(:i)) - n1(i)
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO
   do j = 1, nm2
      j_starts(j) = sum(n2(:j)) - n2(j)
   end do
   !$OMP END PARALLEL DO

   inv_sigma2(:) = -0.5d0/(sigmas(:))**2
   kernels(:, :, :) = 0.0d0

   allocate (atomic_distance(maxval(n1), maxval(n2)))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj) SCHEDULE(dynamic) COLLAPSE(2)
   do a = 1, nm1
      do b = 1, nm2
         nj = n2(b)
         ni = n1(a)

         atomic_distance(:, :) = 0.0d0
         do i = 1, ni
            do j = 1, nj

               atomic_distance(i, j) = sum((q1(:, i + i_starts(a)) - q2(:, j + j_starts(b)))**2)

            end do
         end do

         do k = 1, nsigmas
            kernels(k, a, b) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (i_starts)
   deallocate (j_starts)

end subroutine fget_local_kernels_gaussian

subroutine fget_local_kernels_laplacian(q1, q2, n1, n2, sigmas, &
        & nm1, nm2, nsigmas, kernels)

   implicit none

   double precision, dimension(:, :), intent(in) :: q1
   double precision, dimension(:, :), intent(in) :: q2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: a, b, i, j, k, ni, nj

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance

   integer, allocatable, dimension(:) :: i_starts
   integer, allocatable, dimension(:) :: j_starts

   allocate (i_starts(nm1))
   allocate (j_starts(nm2))

   !$OMP PARALLEL DO
   do i = 1, nm1
      i_starts(i) = sum(n1(:i)) - n1(i)
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO
   do j = 1, nm2
      j_starts(j) = sum(n2(:j)) - n2(j)
   end do
   !$OMP END PARALLEL DO

   inv_sigma2(:) = -1.0d0/sigmas(:)
   kernels(:, :, :) = 0.0d0

   allocate (atomic_distance(maxval(n1), maxval(n2)))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj) SCHEDULE(dynamic) COLLAPSE(2)
   do a = 1, nm1
      do b = 1, nm2
         nj = n2(b)
         ni = n1(a)

         atomic_distance(:, :) = 0.0d0
         do i = 1, ni
            do j = 1, nj

               atomic_distance(i, j) = sum(abs(q1(:, i + i_starts(a)) - q2(:, j + j_starts(b))))

            end do
         end do

         do k = 1, nsigmas
            kernels(k, a, b) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (i_starts)
   deallocate (j_starts)

end subroutine fget_local_kernels_laplacian

subroutine fget_vector_kernels_laplacian(q1, q2, n1, n2, sigmas, &
        & nm1, nm2, nsigmas, kernels)

   implicit none

   ! Descriptors for the training set
   double precision, dimension(:, :, :), intent(in) :: q1
   double precision, dimension(:, :, :), intent(in) :: q2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni, nj, ia, ja

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance

   inv_sigma(:) = -1.0d0/sigmas(:)

   kernels(:, :, :) = 0.0d0

   allocate (atomic_distance(maxval(n1), maxval(n2)))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj) SCHEDULE(dynamic) COLLAPSE(2)
   do j = 1, nm2
      do i = 1, nm1
         ni = n1(i)
         nj = n2(j)

         atomic_distance(:, :) = 0.0d0

         do ja = 1, nj
            do ia = 1, ni

               atomic_distance(ia, ja) = sum(abs(q1(:, ia, i) - q2(:, ja, j)))

            end do
         end do

         do k = 1, nsigmas
            kernels(k, i, j) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma(k)))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)

end subroutine fget_vector_kernels_laplacian

subroutine fget_vector_kernels_gaussian(q1, q2, n1, n2, sigmas, &
        & nm1, nm2, nsigmas, kernels)

   implicit none

   ! Representations (n_samples, n_max_atoms, rep_size)
   double precision, dimension(:, :, :), intent(in) :: q1
   double precision, dimension(:, :, :), intent(in) :: q2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni, nj, ia, ja

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance

   inv_sigma2(:) = -0.5d0/(sigmas(:))**2

   kernels(:, :, :) = 0.0d0

   allocate (atomic_distance(maxval(n1), maxval(n2)))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj,ja,ia) SCHEDULE(dynamic) COLLAPSE(2)
   do j = 1, nm2
      do i = 1, nm1
         ni = n1(i)
         nj = n2(j)

         atomic_distance(:, :) = 0.0d0

         do ja = 1, nj
            do ia = 1, ni

               atomic_distance(ia, ja) = sum((q1(:, ia, i) - q2(:, ja, j))**2)

            end do
         end do

         do k = 1, nsigmas
            kernels(k, i, j) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)

end subroutine fget_vector_kernels_gaussian

subroutine fget_vector_kernels_gaussian_symmetric(q, n, sigmas, &
        & nm, nsigmas, kernels)

   implicit none

   ! Representations (rep_size, n_samples, n_max_atoms)
   double precision, dimension(:, :, :), intent(in) :: q

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! Resulting kernels
   double precision, dimension(nsigmas, nm, nm), intent(out) :: kernels

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance
   double precision, allocatable, dimension(:) :: inv_sigma2

   ! Internal counters
   integer :: i, j, k, ni, nj, ia, ja
   double precision :: val

   allocate (inv_sigma2(nsigmas))

   inv_sigma2 = -0.5d0/(sigmas)**2

   kernels = 1.0d0

   i = size(q, dim=3)
   allocate (atomic_distance(i, i))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj,ja,ia,val) SCHEDULE(dynamic) COLLAPSE(2)
   do j = 1, nm
      do i = 1, nm
         if (i .lt. j) cycle
         ni = n(i)
         nj = n(j)

         atomic_distance(:, :) = 0.0d0

         do ja = 1, nj
            do ia = 1, ni

               atomic_distance(ia, ja) = sum((q(:, ia, i) - q(:, ja, j))**2)

            end do
         end do

         do k = 1, nsigmas
            val = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
            kernels(k, i, j) = val
            kernels(k, j, i) = val
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (inv_sigma2)

end subroutine fget_vector_kernels_gaussian_symmetric

subroutine fget_vector_kernels_laplacian_symmetric(q, n, sigmas, &
        & nm, nsigmas, kernels)

   implicit none

   ! Representations (rep_size, n_samples, n_max_atoms)
   double precision, dimension(:, :, :), intent(in) :: q

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n

   ! Sigma in the Laplacian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! Resulting kernels
   double precision, dimension(nsigmas, nm, nm), intent(out) :: kernels

   ! Temporary variables necessary for parallelization
   double precision, allocatable, dimension(:, :) :: atomic_distance
   double precision, allocatable, dimension(:) :: inv_sigma2

   ! Internal counters
   integer :: i, j, k, ni, nj, ia, ja
   double precision :: val

   allocate (inv_sigma2(nsigmas))

   inv_sigma2 = -1.0d0/sigmas

   kernels = 1.0d0

   i = size(q, dim=3)
   allocate (atomic_distance(i, i))
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(atomic_distance,ni,nj,ja,ia,val) SCHEDULE(dynamic) COLLAPSE(2)
   do j = 1, nm
      do i = 1, nm
         if (i .lt. j) cycle
         ni = n(i)
         nj = n(j)

         atomic_distance(:, :) = 0.0d0

         do ja = 1, nj
            do ia = 1, ni

               atomic_distance(ia, ja) = sum(abs(q(:, ia, i) - q(:, ja, j)))

            end do
         end do

         do k = 1, nsigmas
            val = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
            kernels(k, i, j) = val
            kernels(k, j, i) = val
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (inv_sigma2)

end subroutine fget_vector_kernels_laplacian_symmetric

subroutine fgaussian_kernel(a, na, b, nb, k, sigma)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision, allocatable, dimension(:) :: temp

   double precision :: inv_sigma
   integer :: i, j

   inv_sigma = -0.5d0/(sigma*sigma)

   allocate (temp(size(a, dim=1)))

   !$OMP PARALLEL DO PRIVATE(temp) COLLAPSE(2)
   do i = 1, nb
      do j = 1, na
         temp(:) = a(:, j) - b(:, i)
         k(j, i) = exp(inv_sigma*dot_product(temp, temp))
      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (temp)

end subroutine fgaussian_kernel

subroutine fgaussian_kernel_symmetric(x, n, k, sigma)

   implicit none

   double precision, dimension(:, :), intent(in) :: x

   integer, intent(in) :: n

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision, allocatable, dimension(:) :: temp
   double precision :: val

   double precision :: inv_sigma
   integer :: i, j

   inv_sigma = -0.5d0/(sigma*sigma)

   k = 1.0d0

   allocate (temp(size(x, dim=1)))

   !$OMP PARALLEL DO PRIVATE(temp, val) SCHEDULE(dynamic)
   do i = 1, n
      do j = i, n
         temp = x(:, j) - x(:, i)
         val = exp(inv_sigma*dot_product(temp, temp))
         k(j, i) = val
         k(i, j) = val
      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (temp)

end subroutine fgaussian_kernel_symmetric

subroutine flaplacian_kernel(a, na, b, nb, k, sigma)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision :: inv_sigma

   integer :: i, j

   inv_sigma = -1.0d0/sigma

   !$OMP PARALLEL DO COLLAPSE(2)
   do i = 1, nb
      do j = 1, na
         k(j, i) = exp(inv_sigma*sum(abs(a(:, j) - b(:, i))))
      end do
   end do
   !$OMP END PARALLEL DO

end subroutine flaplacian_kernel

subroutine flaplacian_kernel_symmetric(x, n, k, sigma)

   implicit none

   double precision, dimension(:, :), intent(in) :: x

   integer, intent(in) :: n

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision :: val

   double precision :: inv_sigma
   integer :: i, j

   inv_sigma = -1.0d0/sigma

   k = 1.0d0

   !$OMP PARALLEL DO PRIVATE(val) SCHEDULE(dynamic)
   do i = 1, n
      do j = i, n
         val = exp(inv_sigma*sum(abs(x(:, j) - x(:, i))))
         k(j, i) = val
         k(i, j) = val
      end do
   end do
   !$OMP END PARALLEL DO

end subroutine flaplacian_kernel_symmetric

subroutine flinear_kernel(a, na, b, nb, k)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k

   integer :: i, j

!$OMP PARALLEL DO COLLAPSE(2)
   do i = 1, nb
      do j = 1, na
         k(j, i) = dot_product(a(:, j), b(:, i))
      end do
   end do
!$OMP END PARALLEL DO

end subroutine flinear_kernel

subroutine fmatern_kernel_l2(a, na, b, nb, k, sigma, order)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma
   integer, intent(in) :: order

   double precision, allocatable, dimension(:) :: temp

   double precision :: inv_sigma, inv_sigma2, d, d2
   integer :: i, j

   allocate (temp(size(a, dim=1)))

   if (order == 0) then
      inv_sigma = -1.0d0/sigma

      !$OMP PARALLEL DO PRIVATE(temp) COLLAPSE(2)
      do i = 1, nb
         do j = 1, na
            temp(:) = a(:, j) - b(:, i)
            k(j, i) = exp(inv_sigma*sqrt(sum(temp*temp)))
         end do
      end do
      !$OMP END PARALLEL DO
   else if (order == 1) then
      inv_sigma = -sqrt(3.0d0)/sigma

      !$OMP PARALLEL DO PRIVATE(temp, d) COLLAPSE(2)
      do i = 1, nb
         do j = 1, na
            temp(:) = a(:, j) - b(:, i)
            d = sqrt(sum(temp*temp))
            k(j, i) = exp(inv_sigma*d)*(1.0d0 - inv_sigma*d)
         end do
      end do
      !$OMP END PARALLEL DO
   else
      inv_sigma = -sqrt(5.0d0)/sigma
      inv_sigma2 = 5.0d0/(3.0d0*sigma*sigma)

      !$OMP PARALLEL DO PRIVATE(temp, d, d2) COLLAPSE(2)
      do i = 1, nb
         do j = 1, na
            temp(:) = a(:, j) - b(:, i)
            d2 = sum(temp*temp)
            d = sqrt(d2)
            k(j, i) = exp(inv_sigma*d)*(1.0d0 - inv_sigma*d + inv_sigma2*d2)
         end do
      end do
      !$OMP END PARALLEL DO
   end if

   deallocate (temp)

end subroutine fmatern_kernel_l2

subroutine fsargan_kernel(a, na, b, nb, k, sigma, gammas, ng)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b
   double precision, dimension(:), intent(in) :: gammas

   integer, intent(in) :: na, nb, ng

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   double precision, allocatable, dimension(:) :: prefactor
   double precision :: inv_sigma
   double precision :: d

   integer :: i, j, m

   inv_sigma = -1.0d0/sigma

   ! Allocate temporary
   allocate (prefactor(ng))

   !$OMP PARALLEL DO PRIVATE(d, prefactor) SCHEDULE(dynamic) COLLAPSE(2)
   do i = 1, nb
      do j = 1, na
         d = sum(abs(a(:, j) - b(:, i)))
         do m = 1, ng
            prefactor(m) = gammas(m)*(-inv_sigma*d)**m
         end do
         k(j, i) = exp(inv_sigma*d)*(1 + sum(prefactor(:)))
      end do
   end do
   !$OMP END PARALLEL DO

   ! Clean up
   deallocate (prefactor)

end subroutine fsargan_kernel

subroutine fwasserstein_kernel(a, na, b, nb, k, sigma, p, q)

   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   double precision, allocatable, dimension(:, :) :: asorted
   double precision, allocatable, dimension(:, :) :: bsorted

   double precision, allocatable, dimension(:) :: rep

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   integer, intent(in) :: p
   integer, intent(in) :: q

   double precision :: inv_sigma

   integer :: i, j, l
   integer :: rep_size

   double precision, allocatable, dimension(:) :: deltas
   double precision, allocatable, dimension(:) :: all_values

   double precision, allocatable, dimension(:) :: a_cdf
   double precision, allocatable, dimension(:) :: b_cdf
   integer, allocatable, dimension(:) :: a_cdf_idx
   integer, allocatable, dimension(:) :: b_cdf_idx

   rep_size = size(a, dim=1)
   allocate (asorted(rep_size, na))
   allocate (bsorted(rep_size, nb))
   allocate (rep(rep_size))

   allocate (all_values(rep_size*2))
   allocate (deltas(rep_size*2 - 1))

   allocate (a_cdf(rep_size*2 - 1))
   allocate (b_cdf(rep_size*2 - 1))

   allocate (a_cdf_idx(rep_size*2 - 1))
   allocate (b_cdf_idx(rep_size*2 - 1))

   asorted(:, :) = a(:, :)
   bsorted(:, :) = b(:, :)

   do i = 1, na
      rep(:) = asorted(:, i)
      call quicksort(rep, 1, rep_size)
      asorted(:, i) = rep(:)
   end do

   do i = 1, nb
      rep(:) = bsorted(:, i)
      call quicksort(rep, 1, rep_size)
      bsorted(:, i) = rep(:)
   end do

   !$OMP PARALLEL DO PRIVATE(all_values,a_cdf_idx,b_cdf_idx,a_cdf,b_cdf,deltas)
   do j = 1, nb
      do i = 1, na

         all_values(:rep_size) = asorted(:, i)
         all_values(rep_size + 1:) = bsorted(:, j)

         call quicksort(all_values, 1, 2*rep_size)

         do l = 1, 2*rep_size - 1
            deltas(l) = all_values(l + 1) - all_values(l)
         end do

         a_cdf_idx = searchsorted(all_values, asorted(:, i))
         b_cdf_idx = searchsorted(all_values, bsorted(:, j))

         a_cdf(:) = a_cdf_idx(:)
         b_cdf(:) = b_cdf_idx(:)
         a_cdf(:) = a_cdf(:)/rep_size
         b_cdf(:) = b_cdf(:)/rep_size

         ! k(i,j) = exp(-sum(abs(a_cdf-b_cdf)*deltas)/sigma)
         k(i, j) = exp(-(sum((abs(a_cdf - b_cdf)**p)*deltas)**(1.0d0/p))**q/sigma)

      end do
   end do
   !$OMP END PARALLEL DO
end subroutine fwasserstein_kernel

module arad

   implicit none

contains

   function atomic_distl2(X1, X2, N1, N2, sin1, sin2, width, cut_distance, r_width, c_width) result(aadist)

      implicit none

      double precision, dimension(:, :), intent(in) :: X1
      double precision, dimension(:, :), intent(in) :: X2

      integer, intent(in) :: N1
      integer, intent(in) :: N2

      double precision, dimension(:), intent(in) :: sin1
      double precision, dimension(:), intent(in) :: sin2

      double precision, intent(in) :: width
      double precision, intent(in) :: cut_distance
      double precision, intent(in) :: r_width
      double precision, intent(in) :: c_width

      double precision :: aadist

      double precision :: d

      integer :: m_1, m_2

      double precision :: maxgausdist2

      double precision :: inv_width
      double precision :: c_width2, r_width2, r2

      inv_width = -1.0d0/(4.0d0*width**2)

      maxgausdist2 = (8.0d0*width)**2
      r_width2 = r_width**2
      c_width2 = c_width**2

      aadist = 0.0d0

      do m_1 = 1, N1

         if (X1(1, m_1) > cut_distance) exit

         do m_2 = 1, N2

            if (X2(1, m_2) > cut_distance) exit

            r2 = (X2(1, m_2) - X1(1, m_1))**2

            if (r2 < maxgausdist2) then

               d = exp(r2*inv_width)*sin1(m_1)*sin2(m_2)

               d = d*(r_width2/(r_width2 + (x1(2, m_1) - x2(2, m_2))**2)* &
                   & c_width2/(c_width2 + (x1(3, m_1) - x2(3, m_2))**2))

               aadist = aadist + d*(1.0d0 + x1(4, m_1)*x2(4, m_2) + x1(5, m_1)*x2(5, m_2))

            end if
         end do
      end do

   end function atomic_distl2

end module arad

subroutine fget_local_kernels_arad(q1, q2, z1, z2, n1, n2, sigmas, nm1, nm2, nsigmas, &
        & width, cut_distance, r_width, c_width, kernels)

   use arad, only: atomic_distl2

   implicit none

   ! ARAD descriptors for the training set, format (i,j_1,5,m_1)
   double precision, dimension(:, :, :, :), intent(in) :: q1
   double precision, dimension(:, :, :, :), intent(in) :: q2

   ! ARAD atom-types for each atom in each molecule, format (i, j_1, 2)
   double precision, dimension(:, :, :), intent(in) :: z1
   double precision, dimension(:, :, :), intent(in) :: z2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! ARAD parameters
   double precision, intent(in) :: width
   double precision, intent(in) :: cut_distance
   double precision, intent(in) :: r_width
   double precision, intent(in) :: c_width

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni, nj
   integer :: m_1, i_1, j_1

   ! Pre-computed constants
   double precision :: r_width2
   double precision :: c_width2
   double precision :: inv_cut

   ! Temporary variables necessary for parallelization
   double precision :: l2dist
   double precision, allocatable, dimension(:, :) :: atomic_distance

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: selfl21
   double precision, allocatable, dimension(:, :) :: selfl22

   ! Pre-computed sine terms
   double precision, allocatable, dimension(:, :, :) :: sin1
   double precision, allocatable, dimension(:, :, :) :: sin2

   ! Value of PI at full FORTRAN precision.
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)

   r_width2 = r_width**2
   c_width2 = c_width**2

   inv_cut = pi/(2.0d0*cut_distance)
   inv_sigma2(:) = -1.0d0/(sigmas(:))**2

   allocate (sin1(nm1, maxval(n1), maxval(n1)))
   allocate (sin2(nm2, maxval(n2), maxval(n2)))

   sin1 = 0.0d0
   sin2 = 0.0d0

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, nm1
      ni = n1(i)
      do m_1 = 1, ni
         do i_1 = 1, ni
            if (q1(i, i_1, 1, m_1) < cut_distance) then
               sin1(i, i_1, m_1) = 1.0d0 - sin(q1(i, i_1, 1, m_1)*inv_cut)
            end if
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, nm2
      ni = n2(i)
      do m_1 = 1, ni
         do i_1 = 1, ni
            if (q2(i, i_1, 1, m_1) < cut_distance) then
               sin2(i, i_1, m_1) = 1.0d0 - sin(q2(i, i_1, 1, m_1)*inv_cut)
            end if
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (selfl21(nm1, maxval(n1)))
   allocate (selfl22(nm2, maxval(n2)))

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, nm1
      ni = n1(i)
      do i_1 = 1, ni
         selfl21(i, i_1) = atomic_distl2(q1(i, i_1, :, :), q1(i, i_1, :, :), n1(i), n1(i), &
             & sin1(i, i_1, :), sin1(i, i_1, :), width, cut_distance, r_width, c_width)
      end do
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, nm2
      ni = n2(i)
      do i_1 = 1, ni
         selfl22(i, i_1) = atomic_distl2(q2(i, i_1, :, :), q2(i, i_1, :, :), n2(i), n2(i), &
             & sin2(i, i_1, :), sin2(i, i_1, :), width, cut_distance, r_width, c_width)
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (atomic_distance(maxval(n1), maxval(n2)))

   kernels(:, :, :) = 0.0d0
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(l2dist,atomic_distance,ni,nj) schedule(dynamic)
   do j = 1, nm2
      nj = n2(j)
      do i = 1, nm1
         ni = n1(i)

         atomic_distance(:, :) = 0.0d0

         do i_1 = 1, ni
            do j_1 = 1, nj

               l2dist = atomic_distl2(q1(i, i_1, :, :), q2(j, j_1, :, :), n1(i), n2(j), &
                   & sin1(i, i_1, :), sin2(j, j_1, :), width, cut_distance, r_width, c_width)

               l2dist = selfl21(i, i_1) + selfl22(j, j_1) - 2.0d0*l2dist &
                   & *(r_width2/(r_width2 + (z1(i, i_1, 1) - z2(j, j_1, 1))**2)* &
                   & c_width2/(c_width2 + (z1(i, i_1, 2) - z2(j, j_1, 2))**2))

               atomic_distance(i_1, j_1) = l2dist

            end do
         end do

         do k = 1, nsigmas
            kernels(k, i, j) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (selfl21)
   deallocate (selfl22)
   deallocate (sin1)
   deallocate (sin2)

end subroutine fget_local_kernels_arad

subroutine fget_local_symmetric_kernels_arad(q1, z1, n1, sigmas, nm1, nsigmas, &
        & width, cut_distance, r_width, c_width, kernels)

   use arad, only: atomic_distl2

   implicit none

   ! ARAD descriptors for the training set, format (i,j_1,5,m_1)
   double precision, dimension(:, :, :, :), intent(in) :: q1

   ! ARAD atom-types for each atom in each molecule, format (i, j_1, 2)
   double precision, dimension(:, :, :), intent(in) :: z1

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! ARAD parameters
   double precision, intent(in) :: width
   double precision, intent(in) :: cut_distance
   double precision, intent(in) :: r_width
   double precision, intent(in) :: c_width

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm1), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni, nj
   integer :: m_1, i_1, j_1

   ! Pre-computed constants
   double precision :: r_width2
   double precision :: c_width2
   double precision :: inv_cut

   ! Temporary variables necessary for parallelization
   double precision :: l2dist
   double precision, allocatable, dimension(:, :) :: atomic_distance

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: selfl21

   ! Pre-computed sine terms
   double precision, allocatable, dimension(:, :, :) :: sin1

   ! Value of PI at full FORTRAN precision.
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)

   r_width2 = r_width**2
   c_width2 = c_width**2

   inv_cut = pi/(2.0d0*cut_distance)
   inv_sigma2(:) = -1.0d0/(sigmas(:))**2

   allocate (sin1(nm1, maxval(n1), maxval(n1)))

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, nm1
      ni = n1(i)
      do m_1 = 1, ni
         do i_1 = 1, ni
            sin1(i, i_1, m_1) = 1.0d0 - sin(q1(i, i_1, 1, m_1)*inv_cut)
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (selfl21(nm1, maxval(n1)))

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, nm1
      ni = n1(i)
      do i_1 = 1, ni
         selfl21(i, i_1) = atomic_distl2(q1(i, i_1, :, :), q1(i, i_1, :, :), n1(i), n1(i), &
             & sin1(i, i_1, :), sin1(i, i_1, :), width, cut_distance, r_width, c_width)
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (atomic_distance(maxval(n1), maxval(n1)))

   kernels(:, :, :) = 0.0d0
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(l2dist,atomic_distance,ni,nj) schedule(dynamic)
   do j = 1, nm1
      nj = n1(j)
      do i = 1, j
         ni = n1(i)

         atomic_distance(:, :) = 0.0d0

         do i_1 = 1, ni
            do j_1 = 1, nj

               l2dist = atomic_distl2(q1(i, i_1, :, :), q1(j, j_1, :, :), n1(i), n1(j), &
                   & sin1(i, i_1, :), sin1(j, j_1, :), width, cut_distance, r_width, c_width)

               l2dist = selfl21(i, i_1) + selfl21(j, j_1) - 2.0d0*l2dist &
                       & *(r_width2/(r_width2 + (z1(i, i_1, 1) - z1(j, j_1, 1))**2) &
                          & *c_width2/(c_width2 + (z1(i, i_1, 2) - z1(j, j_1, 2))**2))

               atomic_distance(i_1, j_1) = l2dist

            end do
         end do

         do k = 1, nsigmas
            kernels(k, i, j) = sum(exp(atomic_distance(:ni, :nj)*inv_sigma2(k)))
            kernels(k, j, i) = kernels(k, i, j)
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (selfl21)
   deallocate (sin1)

end subroutine fget_local_symmetric_kernels_arad

subroutine fget_atomic_kernels_arad(q1, q2, z1, z2, n1, n2, sigmas, na1, na2, nsigmas, &
        & width, cut_distance, r_width, c_width, kernels)

   use arad, only: atomic_distl2

   implicit none

   ! ARAD descriptors for each atom in the training set, format (i,5,m_1)
   double precision, dimension(:, :, :), intent(in) :: q1
   double precision, dimension(:, :, :), intent(in) :: q2

   ! ARAD atom-types for each atom, format (i, 2)
   double precision, dimension(:, :), intent(in) :: z1
   double precision, dimension(:, :), intent(in) :: z2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of atom
   integer, intent(in) :: na1
   integer, intent(in) :: na2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! ARAD parameters
   double precision, intent(in) :: width
   double precision, intent(in) :: cut_distance
   double precision, intent(in) :: r_width
   double precision, intent(in) :: c_width

   ! Resulting alpha vector
   double precision, dimension(nsigmas, na1, na2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni
   integer :: m_1

   ! Pre-computed constants
   double precision :: r_width2
   double precision :: c_width2
   double precision :: inv_cut

   ! Temporary variables necessary for parallelization
   double precision :: l2dist

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:) :: selfl21
   double precision, allocatable, dimension(:) :: selfl22

   ! Pre-computed sine terms
   double precision, allocatable, dimension(:, :) :: sin1
   double precision, allocatable, dimension(:, :) :: sin2

   ! Value of PI at full FORTRAN precision.
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)

   r_width2 = r_width**2
   c_width2 = c_width**2

   inv_cut = pi/(2.0d0*cut_distance)
   inv_sigma2(:) = -1.0d0/(sigmas(:))**2

   allocate (sin1(na1, maxval(n1)))
   allocate (sin2(na2, maxval(n2)))

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, na1
      ni = n1(i)
      do m_1 = 1, ni
         sin1(i, m_1) = 1.0d0 - sin(q1(i, 1, m_1)*inv_cut)
      end do
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, na2
      ni = n2(i)
      do m_1 = 1, ni
         sin2(i, m_1) = 1.0d0 - sin(q2(i, 1, m_1)*inv_cut)
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (selfl21(na1))
   allocate (selfl22(na2))

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, na1
      selfl21(i) = atomic_distl2(q1(i, :, :), q1(i, :, :), n1(i), n1(i), &
          & sin1(i, :), sin1(i, :), width, cut_distance, r_width, c_width)
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, na2
      selfl22(i) = atomic_distl2(q2(i, :, :), q2(i, :, :), n2(i), n2(i), &
          & sin2(i, :), sin2(i, :), width, cut_distance, r_width, c_width)
   end do
   !$OMP END PARALLEL DO

   kernels(:, :, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(l2dist) schedule(dynamic)
   do j = 1, na2
      do i = 1, na1

         l2dist = atomic_distl2(q1(i, :, :), q2(j, :, :), n1(i), n2(j), &
             & sin1(i, :), sin2(j, :), width, cut_distance, r_width, c_width)

         l2dist = selfl21(i) + selfl22(j) - 2.0d0*l2dist &
             & *(r_width2/(r_width2 + (z1(i, 1) - z2(j, 1))**2)* &
             & c_width2/(c_width2 + (z1(i, 2) - z2(j, 2))**2))

         do k = 1, nsigmas
            kernels(k, i, j) = exp(l2dist*inv_sigma2(k))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (selfl21)
   deallocate (selfl22)
   deallocate (sin1)
   deallocate (sin2)

end subroutine fget_atomic_kernels_arad

subroutine fget_atomic_symmetric_kernels_arad(q1, z1, n1, sigmas, na1, nsigmas, &
        & width, cut_distance, r_width, c_width, kernels)

   use arad, only: atomic_distl2

   implicit none

   ! ARAD descriptors for each atom in the training set, format (i,5,m_1)
   double precision, dimension(:, :, :), intent(in) :: q1

   ! ARAD atom-types for each atom, format (i, 2)
   double precision, dimension(:, :), intent(in) :: z1

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1

   ! Number of atom
   integer, intent(in) :: na1

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! ARAD parameters
   double precision, intent(in) :: width
   double precision, intent(in) :: cut_distance
   double precision, intent(in) :: r_width
   double precision, intent(in) :: c_width

   ! Resulting alpha vector
   double precision, dimension(nsigmas, na1, na1), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni
   integer :: m_1

   ! Pre-computed constants
   double precision :: r_width2
   double precision :: c_width2
   double precision :: inv_cut

   ! Temporary variables necessary for parallelization
   double precision :: l2dist

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:) :: selfl21

   ! Pre-computed sine terms
   double precision, allocatable, dimension(:, :) :: sin1

   ! Value of PI at full FORTRAN precision.
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)

   r_width2 = r_width**2
   c_width2 = c_width**2

   inv_cut = pi/(2.0d0*cut_distance)
   inv_sigma2(:) = -1.0d0/(sigmas(:))**2

   allocate (sin1(na1, maxval(n1)))

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, na1
      ni = n1(i)
      do m_1 = 1, ni
         sin1(i, m_1) = 1.0d0 - sin(q1(i, 1, m_1)*inv_cut)
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (selfl21(na1))

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, na1
      selfl21(i) = atomic_distl2(q1(i, :, :), q1(i, :, :), n1(i), n1(i), &
          & sin1(i, :), sin1(i, :), width, cut_distance, r_width, c_width)
   end do
   !$OMP END PARALLEL DO

   kernels(:, :, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(l2dist) schedule(dynamic)
   do j = 1, na1
      do i = j, na1

         l2dist = atomic_distl2(q1(i, :, :), q1(j, :, :), n1(i), n1(j), &
             & sin1(i, :), sin1(j, :), width, cut_distance, r_width, c_width)

         l2dist = selfl21(i) + selfl21(j) - 2.0d0*l2dist &
             & *(r_width2/(r_width2 + (z1(i, 1) - z1(j, 1))**2)* &
             & c_width2/(c_width2 + (z1(i, 2) - z1(j, 2))**2))

         do k = 1, nsigmas
            kernels(k, i, j) = exp(l2dist*inv_sigma2(k))
            kernels(k, j, i) = exp(l2dist*inv_sigma2(k))
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (selfl21)
   deallocate (sin1)

end subroutine fget_atomic_symmetric_kernels_arad

subroutine fget_global_symmetric_kernels_arad(q1, z1, n1, sigmas, nm1, nsigmas, &
        & width, cut_distance, r_width, c_width, kernels)

   use arad, only: atomic_distl2

   implicit none

   ! ARAD descriptors for the training set, format (i,j_1,5,m_1)
   double precision, dimension(:, :, :, :), intent(in) :: q1

   ! ARAD atom-types for each atom in each molecule, format (i, j_1, 2)
   double precision, dimension(:, :, :), intent(in) :: z1

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! ARAD parameters
   double precision, intent(in) :: width
   double precision, intent(in) :: cut_distance
   double precision, intent(in) :: r_width
   double precision, intent(in) :: c_width

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm1), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni, nj
   integer :: m_1, i_1, j_1

   ! Pre-computed constants
   double precision :: r_width2
   double precision :: c_width2
   double precision :: inv_cut

   ! Temporary variables necessary for parallelization
   double precision :: l2dist
   double precision, allocatable, dimension(:, :) :: atomic_distance

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:) :: selfl21

   ! Pre-computed sine terms
   double precision, allocatable, dimension(:, :, :) :: sin1

   ! Value of PI at full FORTRAN precision.
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)
   double precision :: mol_dist

   r_width2 = r_width**2
   c_width2 = c_width**2

   inv_cut = pi/(2.0d0*cut_distance)
   inv_sigma2(:) = -1.0d0/(sigmas(:))**2

   allocate (sin1(nm1, maxval(n1), maxval(n1)))

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, nm1
      ni = n1(i)
      do m_1 = 1, ni
         do i_1 = 1, ni
            sin1(i, i_1, m_1) = 1.0d0 - sin(q1(i, i_1, 1, m_1)*inv_cut)
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (selfl21(nm1))

   selfl21 = 0.0d0

   !$OMP PARALLEL DO PRIVATE(ni) REDUCTION(+:selfl21)
   do i = 1, nm1
      ni = n1(i)
      do i_1 = 1, ni
         do j_1 = 1, ni

            selfl21(i) = selfl21(i) + atomic_distl2(q1(i, i_1, :, :), q1(i, j_1, :, :), n1(i), n1(i), &
                & sin1(i, i_1, :), sin1(i, j_1, :), width, cut_distance, r_width, c_width) &
                & *(r_width2/(r_width2 + (z1(i, i_1, 1) - z1(i, j_1, 1))**2)* &
                   & c_width2/(c_width2 + (z1(i, i_1, 2) - z1(i, j_1, 2))**2))

         end do
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (atomic_distance(maxval(n1), maxval(n1)))

   kernels(:, :, :) = 0.0d0
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(l2dist,atomic_distance,ni,nj,mol_dist) schedule(dynamic)
   do j = 1, nm1
      nj = n1(j)
      do i = 1, j! nm1

         ni = n1(i)

         atomic_distance(:, :) = 0.0d0

         do i_1 = 1, ni
            do j_1 = 1, nj

               l2dist = atomic_distl2(q1(i, i_1, :, :), q1(j, j_1, :, :), n1(i), n1(j), &
                   & sin1(i, i_1, :), sin1(j, j_1, :), width, cut_distance, r_width, c_width)

               L2dist = l2dist*(r_width2/(r_width2 + (z1(i, i_1, 1) - z1(j, j_1, 1))**2)* &
                                 & c_width2/(c_width2 + (z1(i, i_1, 2) - z1(j, j_1, 2))**2))

               atomic_distance(i_1, j_1) = l2dist

            end do
         end do

         mol_dist = selfl21(i) + selfl21(j) - 2.0d0*sum(atomic_distance(:ni, :nj))

         do k = 1, nsigmas
            kernels(k, i, j) = exp(mol_dist*inv_sigma2(k))
            kernels(k, j, i) = kernels(k, i, j)
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (selfl21)
   deallocate (sin1)

end subroutine fget_global_symmetric_kernels_arad

subroutine fget_global_kernels_arad(q1, q2, z1, z2, n1, n2, sigmas, nm1, nm2, nsigmas, &
        & width, cut_distance, r_width, c_width, kernels)

   use arad, only: atomic_distl2

   implicit none

   ! ARAD descriptors for the training set, format (i,j_1,5,m_1)
   double precision, dimension(:, :, :, :), intent(in) :: q1
   double precision, dimension(:, :, :, :), intent(in) :: q2

   ! ARAD atom-types for each atom in each molecule, format (i, j_1, 2)
   double precision, dimension(:, :, :), intent(in) :: z1
   double precision, dimension(:, :, :), intent(in) :: z2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Sigma in the Gaussian kernel
   double precision, dimension(:), intent(in) :: sigmas

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of sigmas
   integer, intent(in) :: nsigmas

   ! -1.0 / sigma^2 for use in the kernel
   double precision, dimension(nsigmas) :: inv_sigma2

   ! ARAD parameters
   double precision, intent(in) :: width
   double precision, intent(in) :: cut_distance
   double precision, intent(in) :: r_width
   double precision, intent(in) :: c_width

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, nm2), intent(out) :: kernels

   ! Internal counters
   integer :: i, j, k, ni, nj
   integer :: m_1, i_1, j_1

   ! Pre-computed constants
   double precision :: r_width2
   double precision :: c_width2
   double precision :: inv_cut

   ! Temporary variables necessary for parallelization
   double precision :: l2dist
   double precision, allocatable, dimension(:, :) :: atomic_distance

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:) :: selfl21
   double precision, allocatable, dimension(:) :: selfl22

   ! Pre-computed sine terms
   double precision, allocatable, dimension(:, :, :) :: sin1
   double precision, allocatable, dimension(:, :, :) :: sin2

   ! Value of PI at full FORTRAN precision.
   double precision, parameter :: pi = 4.0d0*atan(1.0d0)

   double precision :: mol_dist

   r_width2 = r_width**2
   c_width2 = c_width**2

   inv_cut = pi/(2.0d0*cut_distance)
   inv_sigma2(:) = -1.0d0/(sigmas(:))**2

   allocate (sin1(nm1, maxval(n1), maxval(n1)))
   allocate (sin2(nm2, maxval(n2), maxval(n2)))

   sin1 = 0.0d0
   sin2 = 0.0d0

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, nm1
      ni = n1(i)
      do m_1 = 1, ni
         do i_1 = 1, ni
            if (q1(i, i_1, 1, m_1) < cut_distance) then
               sin1(i, i_1, m_1) = 1.0d0 - sin(q1(i, i_1, 1, m_1)*inv_cut)
            end if
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(ni)
   do i = 1, nm2
      ni = n2(i)
      do m_1 = 1, ni
         do i_1 = 1, ni
            if (q2(i, i_1, 1, m_1) < cut_distance) then
               sin2(i, i_1, m_1) = 1.0d0 - sin(q2(i, i_1, 1, m_1)*inv_cut)
            end if
         end do
      end do
   end do
   !$OMP END PARALLEL DO

   allocate (selfl21(nm1))
   allocate (selfl22(nm2))

   selfl21 = 0.0d0
   selfl22 = 0.0d0

   !$OMP PARALLEL DO PRIVATE(ni) REDUCTION(+:selfl21)
   do i = 1, nm1
      ni = n1(i)
      do i_1 = 1, ni
         do j_1 = 1, ni

            selfl21(i) = selfl21(i) + atomic_distl2(q1(i, i_1, :, :), q1(i, j_1, :, :), n1(i), n1(i), &
                & sin1(i, i_1, :), sin1(i, j_1, :), width, cut_distance, r_width, c_width) &
                & *(r_width2/(r_width2 + (z1(i, i_1, 1) - z1(i, j_1, 1))**2)* &
                   & c_width2/(c_width2 + (z1(i, i_1, 2) - z1(i, j_1, 2))**2))

         end do

      end do
   end do
   !$OMP END PARALLEL DO

   !$OMP PARALLEL DO PRIVATE(ni) REDUCTION(+:selfl22)
   do i = 1, nm2
      ni = n2(i)
      do i_1 = 1, ni
         do j_1 = 1, ni

            selfl22(i) = selfl22(i) + atomic_distl2(q2(i, i_1, :, :), q2(i, j_1, :, :), n2(i), n2(i), &
                & sin2(i, i_1, :), sin2(i, j_1, :), width, cut_distance, r_width, c_width) &
                &*(r_width2/(r_width2 + (z2(i, i_1, 1) - z2(i, j_1, 1))**2)* &
                  & c_width2/(c_width2 + (z2(i, i_1, 2) - z2(i, j_1, 2))**2))

         end do

      end do
   end do
   !$OMP END PARALLEL DO

   allocate (atomic_distance(maxval(n1), maxval(n2)))

   kernels(:, :, :) = 0.0d0
   atomic_distance(:, :) = 0.0d0

   !$OMP PARALLEL DO PRIVATE(l2dist,atomic_distance,ni,nj,mol_dist) schedule(dynamic)

   do j = 1, nm2
      nj = n2(j)
      do i = 1, nm1
         ni = n1(i)

         atomic_distance(:, :) = 0.0d0

         do i_1 = 1, ni
            do j_1 = 1, nj

               l2dist = atomic_distl2(q1(i, i_1, :, :), q2(j, j_1, :, :), n1(i), n2(j), &
                   & sin1(i, i_1, :), sin2(j, j_1, :), width, cut_distance, r_width, c_width)

               L2dist = l2dist*(r_width2/(r_width2 + (z1(i, i_1, 1) - z2(j, j_1, 1))**2)* &
                  & c_width2/(c_width2 + (z1(i, i_1, 2) - z2(j, j_1, 2))**2))

               atomic_distance(i_1, j_1) = l2dist

            end do
         end do

         mol_dist = selfl21(i) + selfl22(j) - 2.0d0*sum(atomic_distance(:ni, :nj))

         do k = 1, nsigmas
            kernels(k, i, j) = exp(mol_dist*inv_sigma2(k))

         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (atomic_distance)
   deallocate (selfl21)
   deallocate (selfl22)
   deallocate (sin1)
   deallocate (sin2)

end subroutine fget_global_kernels_arad

   subroutine check_openmp(compiled_with_openmp)

      implicit none
      logical, intent(out):: compiled_with_openmp

      compiled_with_openmp = .false.

!$    compiled_with_openmp = .true.

   end subroutine check_openmp

   function get_threads() result(nt)
!$    use omp_lib
      implicit none
      integer :: nt

      nt = 0
!$    nt = omp_get_max_threads()

   end function get_threads

module searchtools

   implicit none

contains

   subroutine searchsorted(all_values, sorted, cdf_idx)
      !function searchsorted(all_values, sorted) result(cdf_idx)

      implicit none

      double precision, dimension(:), intent(in) :: all_values
      double precision, dimension(:), intent(in) :: sorted

      integer, dimension(:), intent(out) :: cdf_idx
      !integer, allocatable, dimension(:) :: cdf_idx
!      integer, allocatable, dimension(:) :: searchsorted

      double precision :: val

      integer :: i, j, n, m

      n = size(all_values) - 1
      m = size(sorted)

      !allocate (cdf_idx(n))

      cdf_idx(:) = 0

      do i = 1, n

         val = all_values(i)

         do j = 1, m

            !write (*,*) i, j, sorted(j), val

            ! if ((sorted(j) <= val) .and. (val < sorted(j+1)))  then
            if (sorted(j) > val) then

               cdf_idx(i) = j - 1
               !write(*,*) "found"
               exit

               !  endif
            else !iif (val > maxval(sorted)) then
               cdf_idx(i) = m
            end if

         end do

      end do

   end subroutine searchsorted
   !end function searchsorted

   recursive subroutine quicksort(a, first, last)
      implicit none
      double precision ::  a(*), x, t
      integer first, last
      integer i, j

      x = a((first + last)/2)
      i = first
      j = last
      do
         do while (a(i) < x)
            i = i + 1
         end do
         do while (x < a(j))
            j = j - 1
         end do
         if (i >= j) exit
         t = a(i); a(i) = a(j); a(j) = t
         i = i + 1
         j = j - 1
      end do
      if (first < i - 1) call quicksort(a, first, i - 1)
      if (j + 1 < last) call quicksort(a, j + 1, last)
   end subroutine quicksort

end module searchtools

subroutine fwasserstein_kernel(a, na, b, nb, k, sigma, p, q)

   use searchtools
   implicit none

   double precision, dimension(:, :), intent(in) :: a
   double precision, dimension(:, :), intent(in) :: b

   double precision, allocatable, dimension(:, :) :: asorted
   double precision, allocatable, dimension(:, :) :: bsorted

   double precision, allocatable, dimension(:) :: rep

   integer, intent(in) :: na, nb

   double precision, dimension(:, :), intent(inout) :: k
   double precision, intent(in) :: sigma

   integer, intent(in) :: p
   integer, intent(in) :: q

   double precision :: inv_sigma

   integer :: i, j, l
   integer :: rep_size

   double precision, allocatable, dimension(:) :: deltas
   double precision, allocatable, dimension(:) :: all_values

   double precision, allocatable, dimension(:) :: a_cdf
   double precision, allocatable, dimension(:) :: b_cdf
   integer, allocatable, dimension(:) :: a_cdf_idx
   integer, allocatable, dimension(:) :: b_cdf_idx

   rep_size = size(a, dim=1)
   allocate (asorted(rep_size, na))
   allocate (bsorted(rep_size, nb))
   allocate (rep(rep_size))

   allocate (all_values(rep_size*2))
   allocate (deltas(rep_size*2 - 1))

   allocate (a_cdf(rep_size*2 - 1))
   allocate (b_cdf(rep_size*2 - 1))

   allocate (a_cdf_idx(rep_size*2 - 1))
   allocate (b_cdf_idx(rep_size*2 - 1))

   asorted(:, :) = a(:, :)
   bsorted(:, :) = b(:, :)

   do i = 1, na
      rep(:) = asorted(:, i)
      call quicksort(rep, 1, rep_size)
      asorted(:, i) = rep(:)
   end do

   do i = 1, nb
      rep(:) = bsorted(:, i)
      call quicksort(rep, 1, rep_size)
      bsorted(:, i) = rep(:)
   end do

   !$OMP PARALLEL DO PRIVATE(all_values,a_cdf_idx,b_cdf_idx,a_cdf,b_cdf,deltas)
   do j = 1, nb
      do i = 1, na

         all_values(:rep_size) = asorted(:, i)
         all_values(rep_size + 1:) = bsorted(:, j)

         call quicksort(all_values, 1, 2*rep_size)

         do l = 1, 2*rep_size - 1
            deltas(l) = all_values(l + 1) - all_values(l)
         end do

         !a_cdf_idx = searchsorted(all_values, asorted(:, i))
         !b_cdf_idx = searchsorted(all_values, bsorted(:, j))
         call searchsorted(all_values, asorted(:, i), a_cdf_idx)
         call searchsorted(all_values, bsorted(:, j), b_cdf_idx)

         a_cdf(:) = a_cdf_idx(:)
         b_cdf(:) = b_cdf_idx(:)
         a_cdf(:) = a_cdf(:)/rep_size
         b_cdf(:) = b_cdf(:)/rep_size

         ! k(i,j) = exp(-sum(abs(a_cdf-b_cdf)*deltas)/sigma)
         k(i, j) = exp(-(sum((abs(a_cdf - b_cdf)**p)*deltas)**(1.0d0/p))**q/sigma)

      end do
   end do
   !$OMP END PARALLEL DO
end subroutine fwasserstein_kernel

subroutine fget_gaussian_process_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, &
       & nm1, nm2, naq2, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, dx, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, &
       & get_pmax, get_ksi, init_cosp_sinp, get_selfscalar, &
       & get_pmax_displaced, get_ksi_displaced, init_cosp_sinp_displaced, get_selfscalar_displaced

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (nm1,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1

   ! fchl descriptors for the training set, format (nm2,3,2,maxatoms,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :, :, :, :), intent(in) :: nneigh2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Total number of force components
   integer, intent(in) :: naq2

   ! Number of kernels
   integer, intent(in) :: nsigmas

   ! Angular Gaussian width
   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   ! Displacement for numerical differentiation
   double precision, intent(in) :: dx

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting kernel matrix
   double precision, dimension(nsigmas, nm1 + naq2, nm1 + naq2), intent(out) :: kernels

   ! Internal counters
   integer :: i1, i2, j1, j2
   integer :: na, nb
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :, :, :, :) :: self_scalar2

   ! Pre-computed two-body weights
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :, :, :, :) :: ksi2

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp2

   ! Indexes for numerical differentiation
   integer :: xyz_pm1
   integer :: xyz_pm2
   integer :: idx1, idx2
   integer :: xyz1, pm1
   integer :: xyz2, pm2

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   ! Angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   kernels = 0.0d0

   ! Max number of neighbors in the representations
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! pmax = max nuclear charge
   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax_displaced(x2, n2)

   ! Get two-body weight function
   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), 3, size(x2, dim=3), maxval(n2), maxval(n2), maxval(nneigh2)))

   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)

   ! ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   ! ksi2 = get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_displaced(x2, n2, nneigh2, three_body_power, order, cut_start, &
       & cut_distance, cosp2, sinp2, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, maxval(n1)))
   allocate (self_scalar2(nm2, 3, size(x2, dim=3), maxval(n2), maxval(n2)))

   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   call get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)

   ! Pre-calculate self-scalar terms
   ! self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !      & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)
   ! self_scalar2 = get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   ! & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(na,nb,s12,ktmp)
   do a = 1, nm1
      na = n1(a)
      do j1 = 1, na

         do b = 1, nm1
            nb = n1(b)
            do j2 = 1, nb

               s12 = scalar(x1(a, j1, :, :), x1(b, j2, :, :), &
                   & nneigh1(a, j1), nneigh1(b, j2), &
                   & ksi1(a, j1, :), ksi1(b, j2, :), &
                   & sinp1(a, j1, :, :, :), sinp1(b, j2, :, :, :), &
                   & cosp1(a, j1, :, :, :), cosp1(b, j2, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

               ktmp = 0.0d0
               call kernel(self_scalar1(a, j1), self_scalar1(b, j2), s12, &
               & kernel_idx, parameters, ktmp)

               kernels(:, a, b) = kernels(:, a, b) + ktmp
               ! kernels(:, a, b) = kernels(:, a, b) &
               !     & + kernel(self_scalar1(a, j1), self_scalar1(b, j2), s12, &
               !     & kernel_idx, parameters)

            end do
         end do
      end do
   end do
   !$OMP END PARALLEL do

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(na,nb,xyz_pm2,s12,ktmp),&
   !$OMP& PRIVATE(idx1,idx2)
   do a = 1, nm1
      na = n1(a)
      idx1 = a
      do j1 = 1, na

         do b = 1, nm2
            nb = n2(b)
            do xyz2 = 1, 3
            do pm2 = 1, 2
               xyz_pm2 = 2*xyz2 + pm2 - 2
               do i2 = 1, nb
                  idx2 = (sum(n2(:b)) - n2(b))*3 + (i2 - 1)*3 + xyz2 + nm1
                  do j2 = 1, nb

                     s12 = scalar(x1(a, j1, :, :), x2(b, xyz2, pm2, i2, j2, :, :), &
                         & nneigh1(a, j1), nneigh2(b, xyz2, pm2, i2, j2), &
                         & ksi1(a, j1, :), ksi2(b, xyz2, pm2, i2, j2, :), &
                         & sinp1(a, j1, :, :, :), sinp2(b, xyz_pm2, i2, j2, :, :, :), &
                         & cosp1(a, j1, :, :, :), cosp2(b, xyz_pm2, i2, j2, :, :, :), &
                         & t_width, d_width, cut_distance, order, &
                         & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                     ktmp = 0.0d0
                     call kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12, &
                             & kernel_idx, parameters, ktmp)

                     if (pm2 == 2) then

                        kernels(:, idx1, idx2) = kernels(:, idx1, idx2) + ktmp
                        ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                        !         & + kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12, &
                        !         & kernel_idx, parameters)

                        kernels(:, idx2, idx1) = kernels(:, idx1, idx2)

                     else

                        kernels(:, idx1, idx2) = kernels(:, idx1, idx2) - ktmp
                        ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                        !         & - kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12, &
                        !         & kernel_idx, parameters)

                        kernels(:, idx2, idx1) = kernels(:, idx1, idx2)

                     end if

                  end do
               end do
            end do
            end do
         end do
      end do
   end do
   !$OMP END PARALLEL do

   kernels(:, :nm1, nm1 + 1:) = kernels(:, :nm1, nm1 + 1:)/(2*dx)
   kernels(:, nm1 + 1:, :nm1) = kernels(:, nm1 + 1:, :nm1)/(2*dx)

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(na,nb,xyz_pm1,xyz_pm2,s12,ktmp),&
   !$OMP& PRIVATE(idx1,idx2)
   do a = 1, nm1
      na = n1(a)
      do xyz1 = 1, 3
      do pm1 = 1, 2
         xyz_pm1 = 2*xyz1 + pm1 - 2
         do i1 = 1, na
            idx1 = (sum(n1(:a)) - n1(a))*3 + (i1 - 1)*3 + xyz1 + nm1
            do j1 = 1, na

               do b = a, nm1
                  nb = n1(b)
                  do xyz2 = 1, 3
                  do pm2 = 1, 2
                     xyz_pm2 = 2*xyz2 + pm2 - 2
                     do i2 = 1, nb
                        idx2 = (sum(n1(:b)) - n1(b))*3 + (i2 - 1)*3 + xyz2 + nm1
                        do j2 = 1, nb

                           s12 = scalar(x2(a, xyz1, pm1, i1, j1, :, :), x2(b, xyz2, pm2, i2, j2, :, :), &
                               & nneigh2(a, xyz1, pm1, i1, j1), nneigh2(b, xyz2, pm2, i2, j2), &
                               & ksi2(a, xyz1, pm1, i1, j1, :), ksi2(b, xyz2, pm2, i2, j2, :), &
                               & sinp2(a, xyz_pm1, i1, j1, :, :, :), sinp2(b, xyz_pm2, i2, j2, :, :, :), &
                               & cosp2(a, xyz_pm1, i1, j1, :, :, :), cosp2(b, xyz_pm2, i2, j2, :, :, :), &
                               & t_width, d_width, cut_distance, order, &
                               & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                           ktmp = 0.0d0
                           call kernel(self_scalar2(a, xyz1, pm1, i1, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                                 & kernel_idx, parameters, ktmp)

                           if (pm1 == pm2) then

                              kernels(:, idx1, idx2) = kernels(:, idx1, idx2) + ktmp

                              ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                              !     & + kernel(self_scalar2(a, xyz1, pm1, i1, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                              !     & kernel_idx, parameters)

                              if (a /= b) then
                                 kernels(:, idx2, idx1) = kernels(:, idx2, idx1) + ktmp

                                 ! kernels(:, idx2, idx1) = kernels(:, idx2, idx1) &
                                 !     & + kernel(self_scalar2(a, xyz1, pm1, i1, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                                 !     & kernel_idx, parameters)
                              end if

                           else
                              kernels(:, idx1, idx2) = kernels(:, idx1, idx2) - ktmp

                              ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                              !     & - kernel(self_scalar2(a, xyz1, pm1, i1, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                              !     & kernel_idx, parameters)

                              if (a /= b) then
                                 kernels(:, idx2, idx1) = kernels(:, idx2, idx1) - ktmp

                                 ! kernels(:, idx2, idx1) = kernels(:, idx2, idx1) &
                                 !     & - kernel(self_scalar2(a, xyz1, pm1, i1, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                                 !     & kernel_idx, parameters)
                              end if

                           end if

                        end do
                     end do
                  end do
                  end do
               end do
            end do
         end do
      end do
      end do
   end do
   !$OMP END PARALLEL do

   kernels(:, nm1 + 1:, nm1 + 1:) = kernels(:, nm1 + 1:, nm1 + 1:)/(4*dx**2)

   deallocate (ktmp)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (sinp1)
   deallocate (cosp2)
   deallocate (sinp2)
   deallocate (self_scalar1)
   deallocate (self_scalar2)

end subroutine fget_gaussian_process_kernels_fchl

subroutine fget_local_gradient_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, &
       & nm1, nm2, naq2, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, dx, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, &
       & get_pmax, get_ksi, init_cosp_sinp, get_selfscalar, &
       & get_pmax_displaced, get_ksi_displaced, init_cosp_sinp_displaced, get_selfscalar_displaced

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (nm1,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1

   ! fchl descriptors for the training set, format (nm2,3,2,maxatoms,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :, :, :, :), intent(in) :: nneigh2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Total number of force components
   integer, intent(in) :: naq2

   ! Number of kernels
   integer, intent(in) :: nsigmas

   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   ! Displacement for numerical differentiation
   double precision, intent(in) :: dx

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, nm1, naq2), intent(out) :: kernels

   ! Internal counters
   integer :: i2, j1, j2
   integer :: na, nb
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :, :, :, :) :: self_scalar2

   ! Pre-computed two-body weights
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :, :, :, :) :: ksi2

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp2

   ! Indexes for numerical differentiation
   integer :: idx1, idx2
   integer :: xyz_pm2
   integer :: xyz2, pm2

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   kernels = 0.0d0

   ! Angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   ! Max number of neighbors in the representations
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! pmax = max nuclear charge
   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax_displaced(x2, n2)

   ! Get two-body weight function
   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), 3, size(x2, dim=3), maxval(n2), maxval(n2), maxval(nneigh2)))

   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)

   ! ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   ! ksi2 = get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_displaced(x2, n2, nneigh2, three_body_power, order, cut_start, &
       & cut_distance, cosp2, sinp2, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, maxval(n1)))
   allocate (self_scalar2(nm2, 3, size(x2, dim=3), maxval(n2), maxval(n2)))
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   call get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)

   ! Pre-calculate self-scalar terms
   ! self_scalar2 = get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   ! & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)
   ! self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !      & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(na,nb,xyz_pm2,s12),&
   !$OMP& PRIVATE(idx1,idx2)
   do a = 1, nm1
      na = n1(a)
      idx1 = a
      do j1 = 1, na

         do b = 1, nm2
            nb = n2(b)
            do xyz2 = 1, 3
            do pm2 = 1, 2
               xyz_pm2 = 2*xyz2 + pm2 - 2
               do i2 = 1, nb
                  idx2 = (sum(n2(:b)) - n2(b))*3 + (i2 - 1)*3 + xyz2
                  do j2 = 1, nb

                     s12 = scalar(x1(a, j1, :, :), x2(b, xyz2, pm2, i2, j2, :, :), &
                         & nneigh1(a, j1), nneigh2(b, xyz2, pm2, i2, j2), &
                         & ksi1(a, j1, :), ksi2(b, xyz2, pm2, i2, j2, :), &
                         & sinp1(a, j1, :, :, :), sinp2(b, xyz_pm2, i2, j2, :, :, :), &
                         & cosp1(a, j1, :, :, :), cosp2(b, xyz_pm2, i2, j2, :, :, :), &
                         & t_width, d_width, cut_distance, order, &
                         & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                     ktmp = 0.0d0
                     call kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12, &
                     & kernel_idx, parameters, ktmp)

                     if (pm2 == 2) then

                        kernels(:, idx1, idx2) = kernels(:, idx1, idx2) + ktmp

                        ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                        !     & + kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12, &
                        !     & kernel_idx, parameters)
                     else
                        kernels(:, idx1, idx2) = kernels(:, idx1, idx2) - ktmp

                        ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                        !     & - kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12, &
                        !     & kernel_idx, parameters)
                     end if

                  end do
               end do
            end do
            end do
         end do
      end do
   end do
   !$OMP END PARALLEL do

   kernels = kernels/(2*dx)

   deallocate (ktmp)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (sinp1)
   deallocate (cosp2)
   deallocate (sinp2)
   deallocate (self_scalar1)
   deallocate (self_scalar2)

end subroutine fget_local_gradient_kernels_fchl

subroutine fget_local_hessian_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, &
       &  nm1, nm2, naq1, naq2, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, dx, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, &
       & get_pmax_displaced, get_ksi_displaced, init_cosp_sinp_displaced, get_selfscalar_displaced

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (nm1,3,2,maxatoms,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :, :, :, :), intent(in) :: nneigh1
   integer, dimension(:, :, :, :, :), intent(in) :: nneigh2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Total number of force components
   integer, intent(in) :: naq1
   integer, intent(in) :: naq2

   ! Number of kernels
   integer, intent(in) :: nsigmas

   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   ! Displacement for numerical differentiation
   double precision, intent(in) :: dx

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, naq1, naq2), intent(out) :: kernels

   ! Internal counters
   integer :: i1, i2, j1, j2
   integer :: na, nb
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :, :, :, :) :: self_scalar1
   double precision, allocatable, dimension(:, :, :, :, :) :: self_scalar2

   ! Pre-computed two-body weights
   double precision, allocatable, dimension(:, :, :, :, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :, :, :, :) :: ksi2

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp1

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp2

   ! Indexes for numerical differentiation
   integer :: xyz_pm1
   integer :: xyz_pm2
   integer :: idx1, idx2
   integer :: xyz1, pm1
   integer :: xyz2, pm2

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   ! Angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   kernels = 0.0d0

   ! Max number of neighbors in the representations
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! pmax = max nuclear charge
   pmax1 = get_pmax_displaced(x1, n1)
   pmax2 = get_pmax_displaced(x2, n2)

   ! Get two-body weight function
   allocate (ksi1(size(x1, dim=1), 3, size(x1, dim=3), maxval(n1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), 3, size(x2, dim=3), maxval(n2), maxval(n2), maxval(nneigh2)))
   call get_ksi_displaced(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)

   ! ksi1 = get_ksi_displaced(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   ! ksi2 = get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, 3*2, maxval(n1), maxval(n1), pmax1, order, maxval(nneigh1)))
   allocate (sinp1(nm1, 3*2, maxval(n1), maxval(n1), pmax1, order, maxval(nneigh1)))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_displaced(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Initialize and pre-calculate three-body Fourier terms
   allocate (cosp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_displaced(x2, n2, nneigh2, three_body_power, order, cut_start, &
       & cut_distance, cosp2, sinp2, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, 3, size(x1, dim=3), maxval(n1), maxval(n1)))
   allocate (self_scalar2(nm2, 3, size(x2, dim=3), maxval(n2), maxval(n2)))
   call get_selfscalar_displaced(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, &
   & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   call get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)

   ! Pre-calculate self-scalar terms
   ! self_scalar1 = get_selfscalar_displaced(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, &
   ! & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)
   ! self_scalar2 = get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   ! & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(na,nb,xyz_pm1,xyz_pm2,s12),&
   !$OMP& PRIVATE(idx1,idx2)
   do a = 1, nm1
      na = n1(a)
      do xyz1 = 1, 3
      do pm1 = 1, 2
         xyz_pm1 = 2*xyz1 + pm1 - 2
         do i1 = 1, na
            idx1 = (sum(n1(:a)) - n1(a))*3 + (i1 - 1)*3 + xyz1
            do j1 = 1, na

               do b = 1, nm2
                  nb = n2(b)
                  do xyz2 = 1, 3
                  do pm2 = 1, 2
                     xyz_pm2 = 2*xyz2 + pm2 - 2
                     do i2 = 1, nb
                        idx2 = (sum(n2(:b)) - n2(b))*3 + (i2 - 1)*3 + xyz2
                        do j2 = 1, nb

                           s12 = scalar(x1(a, xyz1, pm1, i1, j1, :, :), x2(b, xyz2, pm2, i2, j2, :, :), &
                               & nneigh1(a, xyz1, pm1, i1, j1), nneigh2(b, xyz2, pm2, i2, j2), &
                               & ksi1(a, xyz1, pm1, i1, j1, :), ksi2(b, xyz2, pm2, i2, j2, :), &
                               & sinp1(a, xyz_pm1, i1, j1, :, :, :), sinp2(b, xyz_pm2, i2, j2, :, :, :), &
                               & cosp1(a, xyz_pm1, i1, j1, :, :, :), cosp2(b, xyz_pm2, i2, j2, :, :, :), &
                               & t_width, d_width, cut_distance, order, &
                               & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                           ktmp = 0.0d0
                           call kernel(self_scalar1(a, xyz1, pm1, i1, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                           & kernel_idx, parameters, ktmp)

                           if (pm1 == pm2) then

                              kernels(:, idx1, idx2) = kernels(:, idx1, idx2) + ktmp

                              ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                              !     & + kernel(self_scalar1(a, xyz1, pm1, i1, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                              !     & kernel_idx, parameters)

                           else
                              kernels(:, idx1, idx2) = kernels(:, idx1, idx2) - ktmp

                              ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                              !     & - kernel(self_scalar1(a, xyz1, pm1, i1, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                              !     & kernel_idx, parameters)

                           end if

                        end do
                     end do
                  end do
                  end do
               end do
            end do
         end do
      end do
      end do
   end do
   !$OMP END PARALLEL do

   kernels = kernels/(4*dx**2)

   deallocate (ktmp)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (sinp1)
   deallocate (cosp2)
   deallocate (sinp2)
   deallocate (self_scalar1)
   deallocate (self_scalar2)

end subroutine fget_local_hessian_kernels_fchl

subroutine fget_local_symmetric_hessian_kernels_fchl(x1, verbose, n1, nneigh1, &
       & nm1, naq1, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, dx, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, &
       & get_pmax_displaced, get_ksi_displaced, init_cosp_sinp_displaced, get_selfscalar_displaced

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (nm1,3,2,maxatoms,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x1

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :, :, :, :), intent(in) :: nneigh1

   ! Number of molecules
   integer, intent(in) :: nm1

   ! Total number of force components
   integer, intent(in) :: naq1

   ! Number of kernels
   integer, intent(in) :: nsigmas

   ! Angular Gaussian width
   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   ! Displacement for numerical differentiation
   double precision, intent(in) :: dx

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, naq1, naq1), intent(out) :: kernels

   ! Internal counters
   integer :: i1, i2, j1, j2
   integer :: na, nb
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :, :, :, :) :: self_scalar1

   ! Pre-computed two-body weights
   double precision, allocatable, dimension(:, :, :, :, :, :) :: ksi1

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp1

   ! Indexes for numerical differentiation
   integer :: xyz_pm1
   integer :: xyz_pm2
   integer :: xyz1, pm1
   integer :: xyz2, pm2
   integer :: idx1, idx2

   ! Max index in the periodic table
   integer :: pmax1

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   ! Angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   kernels = 0.0d0

   ! Max number of neighbors
   maxneigh1 = maxval(nneigh1)

   ! pmax = max nuclear charge
   pmax1 = get_pmax_displaced(x1, n1)

   ! Get two-body weight function
   allocate (ksi1(size(x1, dim=1), 3, size(x1, dim=3), maxval(n1), maxval(n1), maxval(nneigh1)))
   call get_ksi_displaced(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   ! ksi1 = get_ksi_displaced(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, 3*2, maxval(n1), maxval(n1), pmax1, order, maxval(nneigh1)))
   allocate (sinp1(nm1, 3*2, maxval(n1), maxval(n1), pmax1, order, maxval(nneigh1)))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_displaced(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, 3, size(x1, dim=3), maxval(n1), maxval(n1)))
   call get_selfscalar_displaced(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width,&
   & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   ! self_scalar1 = get_selfscalar_displaced(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width,&
   ! & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(na,nb,xyz_pm1,xyz_pm2,s12),&
   !$OMP& PRIVATE(idx1,idx2)
   do a = 1, nm1
      na = n1(a)
      do xyz1 = 1, 3
      do pm1 = 1, 2
         xyz_pm1 = 2*xyz1 + pm1 - 2
         do i1 = 1, na
            idx1 = (sum(n1(:a)) - n1(a))*3 + (i1 - 1)*3 + xyz1
            do j1 = 1, na

               do b = a, nm1
                  nb = n1(b)
                  do xyz2 = 1, 3
                  do pm2 = 1, 2
                     xyz_pm2 = 2*xyz2 + pm2 - 2
                     do i2 = 1, nb
                        idx2 = (sum(n1(:b)) - n1(b))*3 + (i2 - 1)*3 + xyz2
                        do j2 = 1, nb

                           s12 = scalar(x1(a, xyz1, pm1, i1, j1, :, :), x1(b, xyz2, pm2, i2, j2, :, :), &
                               & nneigh1(a, xyz1, pm1, i1, j1), nneigh1(b, xyz2, pm2, i2, j2), &
                               & ksi1(a, xyz1, pm1, i1, j1, :), ksi1(b, xyz2, pm2, i2, j2, :), &
                               & sinp1(a, xyz_pm1, i1, j1, :, :, :), sinp1(b, xyz_pm2, i2, j2, :, :, :), &
                               & cosp1(a, xyz_pm1, i1, j1, :, :, :), cosp1(b, xyz_pm2, i2, j2, :, :, :), &
                               & t_width, d_width, cut_distance, order, &
                               & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                           ktmp = 0.0d0
                           call kernel(self_scalar1(a, xyz1, pm1, i1, j1), self_scalar1(b, xyz2, pm2, i2, j2), s12,&
                                 & kernel_idx, parameters, ktmp)

                           if (pm1 == pm2) then

                              kernels(:, idx1, idx2) = kernels(:, idx1, idx2) + ktmp

                              ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                              !     & + kernel(self_scalar1(a, xyz1, pm1, i1, j1), self_scalar1(b, xyz2, pm2, i2, j2), s12,&
                              !     & kernel_idx, parameters)

                              if (a /= b) then
                                 kernels(:, idx2, idx1) = kernels(:, idx2, idx1) + ktmp

                                 ! kernels(:, idx2, idx1) = kernels(:, idx2, idx1) &
                                 !     & + kernel(self_scalar1(a, xyz1, pm1, i1, j1), self_scalar1(b, xyz2, pm2, i2, j2), s12,&
                                 !     & kernel_idx, parameters)
                              end if

                           else
                              kernels(:, idx1, idx2) = kernels(:, idx1, idx2) - ktmp
                              ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                              !     & - kernel(self_scalar1(a, xyz1, pm1, i1, j1), self_scalar1(b, xyz2, pm2, i2, j2), s12,&
                              !     & kernel_idx, parameters)

                              if (a /= b) then
                                 kernels(:, idx2, idx1) = kernels(:, idx2, idx1) - ktmp

                                 ! kernels(:, idx2, idx1) = kernels(:, idx2, idx1) &
                                 !     & - kernel(self_scalar1(a, xyz1, pm1, i1, j1), self_scalar1(b, xyz2, pm2, i2, j2), s12,&
                                 !     & kernel_idx, parameters)
                              end if

                           end if

                        end do
                     end do
                  end do
                  end do
               end do
            end do
         end do
      end do
      end do
   end do
   !$OMP END PARALLEL do

   kernels = kernels/(4*dx**2)

   deallocate (ktmp)
   deallocate (ksi1)
   deallocate (cosp1)
   deallocate (sinp1)
   deallocate (self_scalar1)

end subroutine fget_local_symmetric_hessian_kernels_fchl

subroutine fget_force_alphas_fchl(x1, x2, verbose, forces, energies, n1, n2, &
        & nneigh1, nneigh2, nm1, nm2, na1, nsigmas, &
        & t_width, d_width, cut_start, cut_distance, order, pd, &
        & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, dx, &
        & kernel_idx, parameters, llambda, alphas)

   use ffchl_module, only: scalar, get_angular_norm2, &
       & get_pmax, get_ksi, init_cosp_sinp, get_selfscalar, &
       & get_pmax_displaced, get_ksi_displaced, init_cosp_sinp_displaced, get_selfscalar_displaced

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (nm1,3,2,maxatoms,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   double precision, dimension(:, :), intent(in) :: forces
   double precision, dimension(:), intent(in) :: energies

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :, :, :, :), intent(in) :: nneigh2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   ! Number of atoms (and force components in each direction)
   integer, intent(in) :: na1

   ! Number of kernels
   integer, intent(in) :: nsigmas

   ! Angular Gaussian width
   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   ! Displacement for numerical differentiation
   double precision, intent(in) :: dx

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Regularization Lambda
   double precision, intent(in) :: llambda

   double precision, dimension(nsigmas, na1), intent(out) :: alphas

   ! Internal counters
   integer :: i, j, k, i2, j1, j2
   integer :: na, nb, ni, nj
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :, :, :, :) :: self_scalar2

   ! Pre-computed terms
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :, :, :, :) :: ksi2

   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1

   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp2

   ! Indexes for numerical differentiation
   integer :: xyz_pm2
   integer :: xyz2, pm2
   integer :: idx1
   integer :: idx2
   integer :: idx1_start
   integer :: idx2_start

   ! 1/(2*dx)
   double precision :: inv_2dx

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   ! Info variable for BLAS/LAPACK calls
   integer :: info

   ! Feature vector multiplied by the kernel derivatives
   double precision, allocatable, dimension(:, :) :: y

   ! Numerical derivatives of kernel
   double precision, allocatable, dimension(:, :, :)  :: kernel_delta

   ! Scratch space for products of the kernel derivatives
   double precision, allocatable, dimension(:, :, :)  :: kernel_scratch

   ! Kernel between molecules and atom
   double precision, allocatable, dimension(:, :, :) :: kernel_ma

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   inv_2dx = 1.0d0/(2.0d0*dx)

   ! Angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   ! Max number of neighbors in the representations
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! pmax = max nuclear charge
   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax_displaced(x2, n2)

   ! Get two-body weight function
   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), 3, size(x2, dim=3), maxval(n2), maxval(n2), maxval(nneigh2)))
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)

   ! ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   ! ksi2 = get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_displaced(x2, n2, nneigh2, three_body_power, order, cut_start, &
       & cut_distance, cosp2, sinp2, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, maxval(n1)))
   allocate (self_scalar2(nm2, 3, size(x2, dim=3), maxval(n2), maxval(n2)))
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   call get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)

   ! Pre-calculate self-scalar terms
   ! self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !      & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)
   ! self_scalar2 = get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   ! & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   allocate (kernel_delta(na1, na1, nsigmas))
   allocate (y(na1, nsigmas))
   y = 0.0d0

   allocate (kernel_scratch(na1, na1, nsigmas))
   kernel_scratch = 0.0d0

   ! Calculate kernel derivatives and add to kernel matrix
   do xyz2 = 1, 3

      kernel_delta = 0.0d0

      !$OMP PARALLEL DO schedule(dynamic) PRIVATE(na,nb,xyz_pm2,s12), &
      !$OMP& PRIVATE(idx1,idx2,idx1_start,idx2_start)
      do a = 1, nm1
         na = n1(a)
         idx1_start = sum(n1(:a)) - na
         do j1 = 1, na
            idx1 = idx1_start + j1

            do b = 1, nm2
               nb = n2(b)
               idx2_start = (sum(n2(:b)) - nb)

               do pm2 = 1, 2
                  xyz_pm2 = 2*xyz2 + pm2 - 2
                  do i2 = 1, nb
                     idx2 = idx2_start + i2
                     do j2 = 1, nb

                        s12 = scalar(x1(a, j1, :, :), x2(b, xyz2, pm2, i2, j2, :, :), &
                            & nneigh1(a, j1), nneigh2(b, xyz2, pm2, i2, j2), &
                            & ksi1(a, j1, :), ksi2(b, xyz2, pm2, i2, j2, :), &
                            & sinp1(a, j1, :, :, :), sinp2(b, xyz_pm2, i2, j2, :, :, :), &
                            & cosp1(a, j1, :, :, :), cosp2(b, xyz_pm2, i2, j2, :, :, :), &
                            & t_width, d_width, cut_distance, order, &
                            & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                        ktmp = 0.0d0
                        call kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12, &
                                    kernel_idx, parameters, ktmp)

                        if (pm2 == 2) then

                           kernel_delta(idx1, idx2, :) = kernel_delta(idx1, idx2, :) + ktmp*inv_2dx

                           ! kernel_delta(idx1, idx2, :) = kernel_delta(idx1, idx2, :) &
                           !     & + kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12, &
                           !      kernel_idx, parameters)*inv_2dx

                        else

                           kernel_delta(idx1, idx2, :) = kernel_delta(idx1, idx2, :) - ktmp*inv_2dx

                           ! kernel_delta(idx1, idx2, :) = kernel_delta(idx1, idx2, :) &
                           !     & - kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12, &
                           !      kernel_idx, parameters)*inv_2dx

                        end if

                     end do
                  end do
               end do
            end do
         end do
      end do
      !$OMP END PARALLEL do

      do k = 1, nsigmas

         call dsyrk("U", "N", na1, na1, 1.0d0, kernel_delta(1, 1, k), na1, &
            & 1.0d0, kernel_scratch(1, 1, k), na1)

         ! kernel_scratch(:,:,k) = kernel_scratch(:,:,k) &
         !    & + matmul(kernel_delta(:,:,k),transpose(kernel_delta(:,:,k)))! * inv_2dx*inv_2dx

         call dgemv("N", na1, na1, 1.0d0, kernel_delta(:, :, k), na1, &
             & forces(:, xyz2), 1, 1.0d0, y(:, k), 1)

         ! y(:,k) = y(:,k) + matmul(kernel_delta(:,:,k), forces(:,xyz2))!* inv_2dx

      end do

   end do

   deallocate (kernel_delta)
   deallocate (self_scalar2)
   deallocate (ksi2)
   deallocate (cosp2)
   deallocate (sinp2)

   allocate (kernel_MA(nm1, na1, nsigmas))
   kernel_MA = 0.0d0

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(ni,nj,idx1,s12,idx1_start)
   do a = 1, nm1
      ni = n1(a)
      idx1_start = sum(n1(:a)) - ni
      do i = 1, ni

         idx1 = idx1_start + i

         do b = 1, nm1
            nj = n1(b)
            do j = 1, nj

               s12 = scalar(x1(a, i, :, :), x1(b, j, :, :), &
                   & nneigh1(a, i), nneigh1(b, j), ksi1(a, i, :), ksi1(b, j, :), &
                   & sinp1(a, i, :, :, :), sinp1(b, j, :, :, :), &
                   & cosp1(a, i, :, :, :), cosp1(b, j, :, :, :), &
                   & t_width, d_width, cut_distance, order, &
                   & pd, ang_norm2, distance_scale, angular_scale, alchemy)

               ktmp = 0.0d0
               call kernel(self_scalar1(a, i), self_scalar1(b, j), s12, &
                           kernel_idx, parameters, ktmp)

               kernel_MA(b, idx1, :) = kernel_MA(b, idx1, :) + ktmp

               ! kernel_MA(b, idx1, :) = kernel_MA(b, idx1, :) &
               !     & + kernel(self_scalar1(a, i), self_scalar1(b, j), s12, &
               !      kernel_idx, parameters)

            end do
         end do

      end do
   end do
   !$OMP END PARALLEL DO

   deallocate (self_scalar1)
   deallocate (ksi1)
   deallocate (cosp1)
   deallocate (sinp1)

   do k = 1, nsigmas

      ! kernel_scratch(:,:,k) = kernel_scratch(:,:,k) &
      !    & + matmul(transpose(kernel_MA(:,:,k)),kernel_MA(:,:,k))

      ! y(:,k) = y(:,k) + matmul(transpose(kernel_MA(:,:,k)), energies(:))

      call dsyrk("U", "T", na1, nm1, 1.0d0, kernel_MA(:, :, k), nm1, &
          & 1.0d0, kernel_scratch(:, :, k), na1)

      call dgemv("T", nm1, na1, 1.0d0, kernel_ma(:, :, k), nm1, &
                    & energies(:), 1, 1.0d0, y(:, k), 1)

   end do

   deallocate (kernel_ma)

   ! Add regularization
   do k = 1, nsigmas
      do i = 1, na1
         kernel_scratch(i, i, k) = kernel_scratch(i, i, k) + llambda
      end do
   end do

   alphas = 0.0d0

   ! Solve alphas
   do k = 1, nsigmas

      call dpotrf("U", na1, kernel_scratch(:, :, k), na1, info)
      if (info > 0) then
         write (*, *) "QML WARNING: Error in LAPACK Cholesky decomposition DPOTRF()."
         write (*, *) "QML WARNING: The", info, "-th leading order is not positive definite."
      else if (info < 0) then
         write (*, *) "QML WARNING: Error in LAPACK Cholesky decomposition DPOTRF()."
         write (*, *) "QML WARNING: The", -info, "-th argument had an illegal value."
      end if

      call dpotrs("U", na1, 1, kernel_scratch(:, :, k), na1, y(:, k), na1, info)
      if (info < 0) then
         write (*, *) "QML WARNING: Error in LAPACK Cholesky solver DPOTRS()."
         write (*, *) "QML WARNING: The", -info, "-th argument had an illegal value."
      end if

      alphas(k, :) = y(:, k)
   end do

   deallocate (y)
   deallocate (kernel_scratch)

   deallocate (ktmp)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (sinp1)
   deallocate (cosp2)
   deallocate (sinp2)
   deallocate (self_scalar1)
   deallocate (self_scalar2)

end subroutine fget_force_alphas_fchl

subroutine fget_atomic_local_gradient_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, &
       & nm1, nm2, na1, naq2, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, dx, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, &
       & get_pmax, get_ksi, init_cosp_sinp, get_selfscalar, &
       & get_pmax_displaced, get_ksi_displaced, init_cosp_sinp_displaced, get_selfscalar_displaced

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (nm1,3,2,maxatoms,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :, :, :, :), intent(in) :: nneigh2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   integer, intent(in) :: na1
   integer, intent(in) :: naq2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of kernels
   integer, intent(in) :: nsigmas

   ! Angular Gaussian width
   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   ! Displacement for numerical differentiation
   double precision, intent(in) :: dx

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, na1, naq2), intent(out) :: kernels

   ! Internal counters
   integer :: i2, j1, j2
   integer :: na, nb
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :, :, :, :) :: self_scalar2

   ! Pre-computed two-body weights
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :, :, :, :) :: ksi2

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp2

   ! Indexes for numerical differentiation
   integer :: xyz_pm2
   integer :: xyz2, pm2
   integer :: idx1, idx2
   integer :: idx1_start, idx1_end
   integer :: idx2_start, idx2_end

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   kernels = 0.0d0

   ! Angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   ! Max number of neighbors in the representations
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! pmax = max nuclear charge
   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax_displaced(x2, n2)

   ! Get two-body weight function
   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), 3, size(x2, dim=3), maxval(n2), maxval(n2), maxval(nneigh2)))
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)

   ! ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   ! ksi2 = get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2(nm2, 3*2, maxval(n2), maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_displaced(x2, n2, nneigh2, three_body_power, order, cut_start, &
       & cut_distance, cosp2, sinp2, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, maxval(n1)))
   allocate (self_scalar2(nm2, 3, size(x2, dim=3), maxval(n2), maxval(n2)))
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   call get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)

   ! Pre-calculate self-scalar terms
   ! self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !      & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)
   ! self_scalar2 = get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   ! & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(na,nb,xyz_pm2,s12),&
   !$OMP& PRIVATE(idx1,idx2,idx1_start,idx1_end,idx2_start,idx2_end)
   do a = 1, nm1
      na = n1(a)

      idx1_end = sum(n1(:a))
      idx1_start = idx1_end - na + 1

      do j1 = 1, na
         idx1 = idx1_start - 1 + j1

         do b = 1, nm2
            nb = n2(b)

            idx2_end = sum(n2(:b))
            idx2_start = idx2_end - nb + 1

            do xyz2 = 1, 3
            do pm2 = 1, 2
               xyz_pm2 = 2*xyz2 + pm2 - 2
               do i2 = 1, nb

                  idx2 = (idx2_start - 1)*3 + (i2 - 1)*3 + xyz2

                  do j2 = 1, nb

                     s12 = scalar(x1(a, j1, :, :), x2(b, xyz2, pm2, i2, j2, :, :), &
                         & nneigh1(a, j1), nneigh2(b, xyz2, pm2, i2, j2), &
                         & ksi1(a, j1, :), ksi2(b, xyz2, pm2, i2, j2, :), &
                         & sinp1(a, j1, :, :, :), sinp2(b, xyz_pm2, i2, j2, :, :, :), &
                         & cosp1(a, j1, :, :, :), cosp2(b, xyz_pm2, i2, j2, :, :, :), &
                         & t_width, d_width, cut_distance, order, &
                         & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                     ktmp = 0.0d0
                     call kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                           & kernel_idx, parameters, ktmp)

                     if (pm2 == 2) then

                        kernels(:, idx1, idx2) = kernels(:, idx1, idx2) + ktmp

                        ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                        !     & + kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                        !     & kernel_idx, parameters)
                     else
                        kernels(:, idx1, idx2) = kernels(:, idx1, idx2) - ktmp

                        ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                        !     & - kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                        !     & kernel_idx, parameters)

                     end if

                  end do
               end do
            end do
            end do
         end do
      end do
   end do
   !$OMP END PARALLEL do

   kernels = kernels/(2*dx)

   deallocate (ktmp)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (sinp1)
   deallocate (cosp2)
   deallocate (sinp2)
   deallocate (self_scalar1)
   deallocate (self_scalar2)

end subroutine fget_atomic_local_gradient_kernels_fchl

subroutine fget_atomic_local_gradient_5point_kernels_fchl(x1, x2, verbose, n1, n2, nneigh1, nneigh2, &
       & nm1, nm2, na1, naq2, nsigmas, &
       & t_width, d_width, cut_start, cut_distance, order, pd, &
       & distance_scale, angular_scale, alchemy, two_body_power, three_body_power, dx, &
       & kernel_idx, parameters, kernels)

   use ffchl_module, only: scalar, get_angular_norm2, &
       & get_pmax, get_ksi, init_cosp_sinp, get_selfscalar, &
       & get_pmax_displaced, get_ksi_displaced, init_cosp_sinp_displaced, get_selfscalar_displaced

   use ffchl_kernels, only: kernel

   implicit none

   ! fchl descriptors for the training set, format (nm1,3,2,maxatoms,maxatoms,5,maxneighbors)
   double precision, dimension(:, :, :, :), intent(in) :: x1
   double precision, dimension(:, :, :, :, :, :, :), intent(in) :: x2

   ! Whether to be verbose with output
   logical, intent(in) :: verbose

   ! Number of neighbors for each atom in each compound
   integer, dimension(:, :), intent(in) :: nneigh1
   integer, dimension(:, :, :, :, :), intent(in) :: nneigh2

   ! Number of molecules
   integer, intent(in) :: nm1
   integer, intent(in) :: nm2

   integer, intent(in) :: na1
   integer, intent(in) :: naq2

   ! List of numbers of atoms in each molecule
   integer, dimension(:), intent(in) :: n1
   integer, dimension(:), intent(in) :: n2

   ! Number of kernels
   integer, intent(in) :: nsigmas

   ! Angular Gaussian width
   double precision, intent(in) :: t_width

   ! Distance Gaussian width
   double precision, intent(in) :: d_width

   ! Fraction of cut_distance at which cut-off starts
   double precision, intent(in) :: cut_start
   double precision, intent(in) :: cut_distance

   ! Truncation order for Fourier terms
   integer, intent(in) :: order

   ! Periodic table distance matrix
   double precision, dimension(:, :), intent(in) :: pd

   ! Scaling for angular and distance terms
   double precision, intent(in) :: distance_scale
   double precision, intent(in) :: angular_scale

   ! Switch alchemy on or off
   logical, intent(in) :: alchemy

   ! Decaying power laws for two- and three-body terms
   double precision, intent(in) :: two_body_power
   double precision, intent(in) :: three_body_power

   ! Displacement for numerical differentiation
   double precision, intent(in) :: dx

   ! Kernel ID and corresponding parameters
   integer, intent(in) :: kernel_idx
   double precision, dimension(:, :), intent(in) :: parameters

   ! Resulting alpha vector
   double precision, dimension(nsigmas, na1, naq2), intent(out) :: kernels

   ! Internal counters
   integer :: i2, j1, j2
   integer :: na, nb
   integer :: a, b

   ! Temporary variables necessary for parallelization
   double precision :: s12

   ! Pre-computed terms in the full distance matrix
   double precision, allocatable, dimension(:, :) :: self_scalar1
   double precision, allocatable, dimension(:, :, :, :, :) :: self_scalar2

   ! Pre-computed two-body weights
   double precision, allocatable, dimension(:, :, :) :: ksi1
   double precision, allocatable, dimension(:, :, :, :, :, :) :: ksi2

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :) :: sinp1
   double precision, allocatable, dimension(:, :, :, :, :) :: cosp1

   ! Pre-computed terms for the Fourier expansion of the three-body term
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: sinp2
   double precision, allocatable, dimension(:, :, :, :, :, :, :) :: cosp2

   ! Indexes for numerical differentiation
   integer :: xyz_pm2
   integer :: xyz2, pm2
   integer :: idx1, idx2
   integer :: idx1_start, idx1_end
   integer :: idx2_start, idx2_end

   ! Max index in the periodic table
   integer :: pmax1
   integer :: pmax2

   ! Angular normalization constant
   double precision :: ang_norm2

   ! Max number of neighbors
   integer :: maxneigh1
   integer :: maxneigh2

   ! For numerical differentiation
   double precision, parameter, dimension(5) :: fact = (/1.0d0, -8.0d0, 0.0d0, 8.0d0, -1.0d0/)

   ! Work kernel
   double precision, allocatable, dimension(:) :: ktmp
   allocate (ktmp(size(parameters, dim=1)))

   ! fact(1) =   1.0d0
   ! fact(2) =  -8.0d0
   ! fact(3) =   0.0d0
   ! fact(4) =   8.0d0
   ! fact(5) =  -1.0d0

   kernels = 0.0d0

   ! Angular normalization constant
   ang_norm2 = get_angular_norm2(t_width)

   ! Max number of neighbors in the representations
   maxneigh1 = maxval(nneigh1)
   maxneigh2 = maxval(nneigh2)

   ! pmax = max nuclear charge
   pmax1 = get_pmax(x1, n1)
   pmax2 = get_pmax_displaced(x2, n2)

   ! Get two-body weight function
   allocate (ksi1(size(x1, dim=1), maxval(n1), maxval(nneigh1)))
   allocate (ksi2(size(x2, dim=1), 3, size(x2, dim=3), maxval(n2), maxval(n2), maxval(nneigh2)))
   call get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose, ksi1)
   call get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose, ksi2)
   ! ksi1 = get_ksi(x1, n1, nneigh1, two_body_power, cut_start, cut_distance, verbose)
   ! ksi2 = get_ksi_displaced(x2, n2, nneigh2, two_body_power, cut_start, cut_distance, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp1(nm1, maxval(n1), pmax1, order, maxneigh1))
   allocate (sinp1(nm1, maxval(n1), pmax1, order, maxneigh1))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp(x1, n1, nneigh1, three_body_power, order, cut_start, cut_distance, &
       & cosp1, sinp1, verbose)

   ! Allocate three-body Fourier terms
   allocate (cosp2(nm2, 3*5, maxval(n2), maxval(n2), pmax2, order, maxneigh2))
   allocate (sinp2(nm2, 3*5, maxval(n2), maxval(n2), pmax2, order, maxneigh2))

   ! Initialize and pre-calculate three-body Fourier terms
   call init_cosp_sinp_displaced(x2, n2, nneigh2, three_body_power, order, cut_start, &
       & cut_distance, cosp2, sinp2, verbose)

   ! Pre-calculate self-scalar terms
   allocate (self_scalar1(nm1, maxval(n1)))
   allocate (self_scalar2(nm2, 3, size(x2, dim=3), maxval(n2), maxval(n2)))
   call get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
        & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar1)
   call get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose, self_scalar2)

   ! Pre-calculate self-scalar terms
   ! self_scalar1 = get_selfscalar(x1, nm1, n1, nneigh1, ksi1, sinp1, cosp1, t_width, d_width, &
   !     & cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)
   ! self_scalar2 = get_selfscalar_displaced(x2, nm2, n2, nneigh2, ksi2, sinp2, cosp2, t_width, &
   ! & d_width, cut_distance, order, pd, ang_norm2, distance_scale, angular_scale, alchemy, verbose)

   !$OMP PARALLEL DO schedule(dynamic) PRIVATE(na,nb,xyz_pm2,s12),&
   !$OMP& PRIVATE(idx1,idx2,idx1_start,idx1_end,idx2_start,idx2_end)
   do a = 1, nm1
      na = n1(a)

      idx1_end = sum(n1(:a))
      idx1_start = idx1_end - na + 1

      do j1 = 1, na
         idx1 = idx1_start - 1 + j1

         do b = 1, nm2
            nb = n2(b)

            idx2_end = sum(n2(:b))
            idx2_start = idx2_end - nb + 1

            do xyz2 = 1, 3
            do pm2 = 1, 5

               if (pm2 /= 3) then

                  ! xyz_pm2 = 2*xyz2 + pm2 - 2
                  xyz_pm2 = 5*(xyz2 - 1) + pm2

                  do i2 = 1, nb
                     idx2 = (idx2_start - 1)*3 + (i2 - 1)*3 + xyz2

                     do j2 = 1, nb

                        s12 = scalar(x1(a, j1, :, :), x2(b, xyz2, pm2, i2, j2, :, :), &
                            & nneigh1(a, j1), nneigh2(b, xyz2, pm2, i2, j2), &
                            & ksi1(a, j1, :), ksi2(b, xyz2, pm2, i2, j2, :), &
                            & sinp1(a, j1, :, :, :), sinp2(b, xyz_pm2, i2, j2, :, :, :), &
                            & cosp1(a, j1, :, :, :), cosp2(b, xyz_pm2, i2, j2, :, :, :), &
                            & t_width, d_width, cut_distance, order, &
                            & pd, ang_norm2, distance_scale, angular_scale, alchemy)

                        ktmp = 0.0d0
                        call kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                        & kernel_idx, parameters, ktmp)

                        kernels(:, idx1, idx2) = kernels(:, idx1, idx2) + ktmp*fact(pm2)

                        ! kernels(:, idx1, idx2) = kernels(:, idx1, idx2) &
                        !     & + kernel(self_scalar1(a, j1), self_scalar2(b, xyz2, pm2, i2, j2), s12,&
                        !     & kernel_idx, parameters)*fact(pm2)

                     end do
                  end do

               end if

            end do
            end do
         end do
      end do
   end do
   !$OMP END PARALLEL do

   kernels = kernels/(12*dx)

   deallocate (ktmp)
   deallocate (ksi1)
   deallocate (ksi2)
   deallocate (cosp1)
   deallocate (sinp1)
   deallocate (cosp2)
   deallocate (sinp2)
   deallocate (self_scalar1)
   deallocate (self_scalar2)

end subroutine fget_atomic_local_gradient_5point_kernels_fchl
